;                                                                      
; PMAM - Precision architecture/Medusa Active Message layer, V0.0
;        utilities in assembly language
;
; "Copyright (c) 1993 The Regents of the University of California.
; All rights reserved.
; 
; Permission to use, copy, modify, and distribute this software and its
; documentation for any purpose, without fee, and without written agreement is
; hereby granted, provided that the above copyright notice and the following
; two paragraphs appear in all copies of this software.
; 
; IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
; DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
; OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
; CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
; 
; THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
; AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
; ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
; PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
;
; Author:              Richard P. Martin
; Version:             0.01
; Creation Date:       Fri Nov 19 21:40:01 PST 1993
; Filename:            asm_util.s
; History:             

	
;;; A short routine which emulates the syscall()
;;; mechanism found in SunOS and Ultrix for HPUX PA machines
;;; usage:	 return_val = syscall(call number,arg0 ... arg3)
;;; returns -1 if an error, the error is placed in errno
;;; see sys/syscall.h for the call numbers
 
        .SPACE  $TEXT$,SORT=8
        .SUBSPA $CODE$,QUAD=0,ALIGN=8,ACCESS=44,CODE_ONLY,SORT=24
syscall
        .PROC
        .CALLINFO CALLER,FRAME=8,ENTRY_SR=3,SAVE_RP
        .ENTRY
        STW     %r2,-20(0,%r30) ;
        LDO     64(%r30),%r30   ; 
        STW     %r22,-52(0,%r30)  ; save r22, need for the syscall

	COPY    %r26,%r22       ; system call number
        COPY    %r25,%r26       ; have to shift the args because the 
        COPY    %r24,%r25       ; first arg is the syscall #. 
        COPY    %r23,%r24       ; could elim this copy if had call 3 last
	LDW     -116(0,%r30),%r23; arg3 is on the stack

	LDIL    L%0xc0000004,%r1       ;  jump to system space, see SYSCALLGATE
        BLE     R%0xc0000004,(%sr7,%r1);  in syscall.h
	NOP
	
        COMIB,=,N       0,%r22,sysend  ; is the status of r22==0?
	NOP
        ADDIL   LR'errno-$global$,%r27  ;  no, an error happend
        STW     %r28,RR'errno-$global$(0,%r1); set errno=r28 and r28=-1
        LDI     -1,%r28 ;offset 0x3c    ;
sysend
	LDW     -52(0,%r30),%r22;  restore r22 
        LDW     -84(0,%r30),%r2 ;
        BV      %r0(%r2)        ;
        .EXIT
        LDO     -64(%r30),%r30  ;
	.PROCEND ;in=23,24,25,26;out=28;

;;; 
;;; 
	
		
        .space  $PRIVATE$
        .subspa $DATA$

;Move to/from Control Register Access Table
;  A non-zero value indicates access is permitted.  A mask
;  would have been used but we would have wipe out SAR in
;  order to use vextru.

mctltab
        .word   0xff000000      ;RC permitted, 1-3 reserved
        .word   0x00000000      ;4-7 reserved
        .word   0xffffffff      ;PID1, PID2, CCR, SAR permitted
        .word   0xffffffff      ;PID3, PID4, IVA, EIEM permitted
        .word   0xffffffff      ;IT, PCSQ, PCOQ, IIR permitted
        .word   0xffffffff      ;ISR, IOR, IPSW, EIRR permitted
        .word   0xffffffff      ;Temporaries CR24-CR27 permitted

;;;   this routine returns the value of a given contol register
;;;   usage:	 return_val = mfctl(#) , where # =0-31
;;; 
	.space  $TEXT$
        .subspa $CODE$
        .export mfctl,entry
mfctl	
        .proc
        .callinfo save_rp,calls
	.enter
        comib,>,n %cr0,%r26,mfctlerr  ;Error if %cr is less than %cr0
        ldo     %cr31(%r0),%r22
        comb,<,n %r22,%r26,mfctlerr  ;Error if %cr is greater than %cr31
        ldil    L%mctltab,%r22
        ldo     R%mctltab(%r22),%r22  ;Get pointer to access table
        ldbx    %r26(%r22),%r22       ;Get entry for this control register
        comb,=,n %r0,%r22,mfctlerr     ;Zero indicates access not permitted
;Get Value from Control Register
        blr,n   %r26,%r0
        nop
        b       mfctlend
        mfctl   %cr0,%r28
        b       mfctlend
        nop                     ;No access to %cr1
        b       mfctlend
        nop                     ;No access to %cr2
        b       mfctlend
        nop                     ;No access to %cr3
        b       mfctlend
        nop                     ;No access to %cr4
        b       mfctlend
        nop                     ;No access to %cr5
        b       mfctlend
        nop                     ;No access to %cr6
        b       mfctlend
        nop                     ;No access to %cr7
        b       mfctlend
        mfctl   %cr8,%r28
        b       mfctlend
        mfctl   %cr9,%r28
        b       mfctlend
        mfctl   %cr10,%r28
        b       mfctlend
        mfctl   %cr11,%r28
        b       mfctlend
        mfctl   %cr12,%r28
        b       mfctlend
        mfctl   %cr13,%r28
        b       mfctlend
        mfctl   %cr14,%r28
        b       mfctlend
        mfctl   %cr15,%r28
        b       mfctlend
        mfctl   %cr16,%r28
        b       mfctlend
        mfctl   %cr17,%r28
        b       mfctlend
        mfctl   %cr18,%r28
        b       mfctlend
        mfctl   %cr19,%r28
        b       mfctlend
        mfctl   %cr20,%r28
        b       mfctlend
        mfctl   %cr21,%r28
        b       mfctlend
        mfctl   %cr22,%r28
        b       mfctlend
        mfctl   %cr23,%r28
        b       mfctlend
        mfctl   %cr24,%r28
        b       mfctlend
        mfctl   %cr25,%r28
        b       mfctlend
        mfctl   %cr26,%r28
        b       mfctlend
        mfctl   %cr27,%r28
        b       mfctlend
        mfctl   %cr28,%r28
        b       mfctlend
        mfctl   %cr29,%r28
        b       mfctlend
        mfctl   %cr30,%r28
        b       mfctlend
        mfctl   %cr31,%r28
;Mfctl Error - Call printf
mfctlerr
	copy %r26,%r25		;  move cr to arg1 
	addil LR'$THIS_DATA$-$global$(%r1),%r27		
        .call ARGW0=GR,ARGW1=GR
        bl,n    printf,%r2
        ldo LR'$THIS_DATA$-$global$(%r1),%r26		
mfctlend
        .leave
        .procend
;;;
;;;
	
        .SPACE  $TEXT$
        .SUBSPA $CODE$
        .SPACE  $PRIVATE$,SORT=16
        .SUBSPA $DATA$,QUAD=1,ALIGN=8,ACCESS=31,SORT=16
$THIS_DATA$
	.ALIGN 4
	.STRINGZ "mfctl(): invalid control register %d\n"
	
        .IMPORT $global$,DATA
        .SPACE  $TEXT$
        .SUBSPA $CODE$
        .EXPORT syscall,ENTRY,PRIV_LEV=3,ARGW0=GR,ARGW1=GR,ARGW2=GR,ARGW3=GR,RTNVAL=GR
        .EXPORT mfctl,ENTRY,PRIV_LEV=3,ARGW0=GR,RTNVAL=GR
	.IMPORT printf,CODE
        .IMPORT errno,DATA
        .END

