#ifndef __GLUNIX_TYPES_H__
#define __GLUNIX_TYPES_H__
/******************************************************************************
 *
 * GLUnix group
 * NOW Project
 *
 * types.h --
 *
 *     This file defines many common types used in GLunix.
 *
 * $Id$
 *
 * $Log$
 *
 *
 * Copyright (c) 1994 by The Regents of the University of California.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * In no event shall the University of California be liable to any party for
 * direct, indirect, special, incidental, or consequential damages arising out
 * of the use of this software and its documentation, even if the University of
 * California has been advised of the possibility of such damage.
 * 
 * The University of California specifically disclaims any warranties,
 * including, but not limited to, the implied warranties of merchantability
 * and fitness for a particular purpose.  The software provided hereunder is
 * on an "as is" basis, and the University of California has no obligation to
 * provide maintenance, support, updates, enhancements, or modifications.
 *
 *****************************************************************************/

#include <sys/types.h>
#include <errno.h>

/*****************************************************************************/

/* Add our own errno for no error. */
#ifndef ESUCCESS
#define ESUCCESS 0
#endif
#define ENODES   500    /* Too many nodes requested */

/*****************************************************************************/

typedef const char   cchar;
typedef const short  cshort;
typedef const int    cint;
typedef const float  cfloat;
typedef const double cdouble;

/*****************************************************************************/

/* If we do this as an enum, like we want, then we cannot do boolean
   operations on it. */

typedef int Bool;

#define False 0
#define True  1

#ifdef FALSE
#undef FALSE
#undef TRUE
#endif

#define FALSE False
#define TRUE True

/*****************************************************************************/

typedef int  Npid;
typedef int  VNN;

#define NPID_NOBODY -1
#define VNN_NOBODY  -1

/*****************************************************************************/

#endif /* __GLUNIX_TYPES_H__ */
