/*                                                                      tab:5
 * HPAM - Precision architecture/Medusa Active Message layer, V2.1
 *
 * "Copyright (c) 1993 The Regents of the University of California.
 * All rights reserved.
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author:              Richard P. Martin
 * Version:             0.01
 * Creation Date:       Mon Oct 25 23:01:45 PDT 1993
 * Filename:            hpam.h
 * History:
 */

#ifndef _HPAM_INCLUDED_H_   /* allow multiple includes */
#define _HPAM_INCLUDED_H_


/* prototypes */
extern void am_enable();
extern void am_disable();

extern void am_poll();
extern int  HPAM_flush(int dest); 
extern void HPAM_wait(volatile int *flag,int value);
extern void HPAM_poll_wait(volatile int *flag,int value);

extern int am_request_4(int dest, void (*fun)(), ... ); 
extern int am_reply_4(int dest, void (*fun)(), ... );        

extern int am_store(int dest, void *lva, void *rva, int len, void (*handler)(),
		    void *arg);

extern int am_get(int dest, void *rva, void *lva, int len, void (*handler)(),
		    void *arg);

extern void HPAM_barrier();
/* manipute the timeout/retransmission */

#define HPAM_MAX_PKT 8000
extern int HPAM_self_address;
extern int HPAM_partition_size;
#endif
