/* dlpi.c */
/*************************************************************************
 *                                                                       *
 * Myricom Myrinet Software                                              *
 *                                                                       *
 * Copyright (c) 1994 by Myricom, Inc.                                   *
 * All rights reserved.                                                  *
 *                                                                       *
 * This software is released under a non-disclosure agreement with       *
 * Myricom, Inc. Redistribution in any form is strictly prohibited.      *
 *                                                                       *
 * Myricom, Inc. makes no representations about the suitability of this  *
 * software for any purpose.                                             *
 *                                                                       *
 * THIS FILE IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING  *
 * THE WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A           *
 * PARTICULAR PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR     *
 * TRADE PRACTICE. MYRICOM, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO *
 * THE INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY THIS  *
 * FILE OR ANY PART THEREOF.                                             *
 *                                                                       *
 * In no event will Myricom, Inc. be liable for any lost revenue         *
 * or profits or other special, indirect and consequential damages, even *
 * if Myricom has been advised of the possibility of such damages.       *
 *                                                                       *
 *                                                                       *
 * Other copyrights might apply to parts of this software and are so     *
 * noted when applicable.                                                *
 *                                                                       *
 * Myricom, Inc.                                                         *
 * 325 N. Santa Anita Ave.                                               *
 * Arcadia, CA 91024                                                     *
 *                                                                       *
 *************************************************************************/
static char *myricopyright = "\t\t\tCopyright (c) 1994 by Myricom, Inc.";

#define MYRIVERSION	"Myrinet DLPI Driver(2.2)-RPM"

/*
 *  SunOS Multithreaded STREAMS DLPI Driver
 *
 * This file is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify this file without charge, but are not authorized to
 * license or distribute it to anyone else except as part of a product
 * or program developed by the user.
 *
 * THIS FILE IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 *
 * This file is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 *
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY THIS FILE
 * OR ANY PART THEREOF.
 *
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even
 * if Sun has been advised of the possibility of such damages.
 *
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */


/*
 * Includes, Declarations and Local Data
 */

#include	<sys/types.h>
#include	<sys/errno.h>
#include	<sys/debug.h>
#include	<sys/stropts.h>
#include	<sys/stream.h>
#include	<sys/strlog.h>
#include	<sys/cmn_err.h>
#include	<sys/kmem.h>
#include	<sys/conf.h>
#include	<sys/ksynch.h>
#include	<sys/stat.h>
#include	<sys/dlpi.h>
#include 	<sys/modctl.h>
#ifdef  KSTAT
#include        <sys/kstat.h>
#endif
#include    <sys/time.h>
/*
#include	<string.h>
*/
#include	<sys/ddi.h>
#include	<sys/sunddi.h>

#include "config.h"
#include "myri_api.h"
#include "myri.h"

#define AM_INTR 0xf211 /* flag used for interrupts */

static void pserror(queue_t *, mblk_t *, int);
static void psiocack(queue_t *, mblk_t *, int, int);
static void psiocnak(queue_t *, mblk_t *, int, int);
static mblk_t *psexchange(queue_t *, mblk_t *, int, int, long);
static void psdlbindack(queue_t *, mblk_t *, u_long, caddr_t, int, int, u_long);
static void psdlokack(queue_t *, mblk_t *, u_long);
static void psdlerrorack(queue_t *, mblk_t *, u_long, u_long, u_long);
static void
psdluderrorind(queue_t *, mblk_t *, u_char *, u_long,
	       u_long, u_long);
static void psdlphysaddrack(queue_t *, mblk_t *, caddr_t, int);
static int myriidentify(dev_info_t *);
static int myriprobe(dev_info_t *);
static int myriattach(dev_info_t *, ddi_attach_cmd_t);
static int myridetach(dev_info_t *, ddi_detach_cmd_t);
static int myriinfo(dev_info_t *, ddi_info_cmd_t, void *, void **);
static int myriopen(queue_t *, dev_t *, int, int, cred_t *);
static int myriclose(queue_t *, int, cred_t *);
static int myriwput(queue_t *, mblk_t *);
static int myriwsrv(queue_t *);
#ifdef FLOW_CONTROL
static int myrirsrv(queue_t *);
#endif				/* FLOW_CONTROL */
static void myriproto(queue_t *, mblk_t *);
static void myriioctl(queue_t *, mblk_t *);
static void myriareq(queue_t *, mblk_t *);
static void myridreq(queue_t *, mblk_t *);
static void myridodetach(struct myristr *);
static void myribreq(queue_t *, mblk_t *);
static void myriubreq(queue_t *, mblk_t *);
static void myriireq(queue_t *, mblk_t *);
static void myriponreq(queue_t *, mblk_t *);
static void myripoffreq(queue_t *, mblk_t *);
static void myriemreq(queue_t *, mblk_t *);
static void myridmreq(queue_t *, mblk_t *);
static void myripareq(queue_t *, mblk_t *);
static void myrispareq(queue_t *, mblk_t *);
static void myriudreq(queue_t *, mblk_t *);
static int myristart(queue_t *, mblk_t *, struct myri *);
static u_int myriintr();
/*
static struct myristr *
myripaccept(struct myristr *, struct myri *, int,
	    struct medium_addr *);
static void myrireclaim(struct myri *);
static void myriread(struct myri *, caddr_t);
*/
INLINE int myrimcmatch(struct myristr *, struct medium_addr *);
static int myriinit(struct myri *);
static void myriuninit(struct myri * myrip);
static void myrierror(dev_info_t *, const char *fmt,...);
mblk_t *
myriaddudind(struct myri *, mblk_t *, struct medium_addr *,
	     struct medium_addr *, int, ulong);

INLINE static int
    myrifastpath(queue_t * wq, mblk_t * mp);


struct timeval time_start[32], time_stop[32];
int send_immediate, had_to_copy;

/* active message mutex flags */

int myri_use_am_intr ;  /* to myriintr, check am_flags? */
int am_intr_count;      /* how many interrupts to use?  */
kmutex_t   myri_am_mu;
kcondvar_t myri_am_cv;

#ifdef i86pc
 ddi_device_acc_attr_t dev_attr =
			{ DDI_DEVICE_ATTR_V0,
			DDI_NEVERSWAP_ACC,
			DDI_STRICTORDER_ACC};
#endif i86pc


void
bcopy_addr(caddr_t src, caddr_t dst, size_t len)
{
#ifdef MORE_GENERAL
	if (len == 6) {
		/* might be able to copy u_shorts depending on alignment */
		if (!(((unsigned) src & 1) || ((unsigned) dst & 1))) {
			register u_short *srcp = (u_short *) (src);
			register u_short *dstp = (u_short *) (dst);

			*dstp++ = *srcp++;
			*dstp++ = *srcp++;
			*dstp++ = *srcp++;
		}
		else {
#endif				/* MORE_GENERAL */
			register u_char *srcp = (u_char *) (src);
			register u_char *dstp = (u_char *) (dst);

			*dstp++ = *srcp++;
			*dstp++ = *srcp++;
			*dstp++ = *srcp++;
			*dstp++ = *srcp++;
			*dstp++ = *srcp++;
			*dstp++ = *srcp++;
#ifdef MORE_GENERAL
		}
	}
	else {
		bcopy(src, dst, len);
	}
#endif				/* MORE_GENERAL */
}

int
bcmp_addr(caddr_t src, caddr_t dst, size_t len)
{
	register u_char *srcp = (u_char *) (src);
	register u_char *dstp = (u_char *) (dst);

	if (
			(*dstp++ == *srcp++) &&
			(*dstp++ == *srcp++) &&
			(*dstp++ == *srcp++) &&
			(*dstp++ == *srcp++) &&
			(*dstp++ == *srcp++) &&
			(*dstp++ == *srcp++)) {
		return (0);
	}
	else {
		return (1);
	}

}


extern unsigned short *LANAI[MYRI_MAX_BOARDS];
extern unsigned short *LANAI_WAKE[MYRI_MAX_BOARDS];
extern unsigned short *BOARD[MYRI_MAX_BOARDS];

int instance_used[MYRI_MAX_BOARDS] = {-1, -1, -1, -1, -1, -1, -1, -1};

/* Local Static def's */

/*
 * Physical Medium broadcast address definition.
 */
static struct medium_addr medbroadcastaddr = {{
		0xff, 0xff, 0xff, 0xff, 0xff, 0xff
}};

/*
 * Linked list of "myri" structures - one per device.
 */
struct myri *myridev = NULL;

/*
 * Linked list of active (inuse) driver Streams.
 */
static struct myristr *myristrup = NULL;
static krwlock_t myristruplock;


/*
 * Our DL_INFO_ACK template.
 */
static dl_info_ack_t myriinfoack = {
	DL_INFO_ACK,		/* dl_primitive */
	MEDIUM_MTU,		/* dl_max_sdu */
	0,			/* dl_min_sdu */
	DEVICE_ADDRL,		/* dl_addr_length */
	DL_ETHER,		/* dl_mac_type */
	0,			/* dl_reserved */
	0,			/* dl_current_state */
	-2,			/* dl_sap_length */
	DL_CLDLS,		/* dl_service_mode */
	0,			/* dl_qos_length */
	0,			/* dl_qos_offset */
	0,			/* dl_range_length */
	0,			/* dl_range_offset */
	DL_STYLE2,		/* dl_provider_style */
	sizeof(dl_info_ack_t),	/* dl_addr_offset */
	DL_VERSION_2,		/* dl_version */
	MEDIUM_ADDRL,		/* dl_brdcst_addr_length */
	sizeof(dl_info_ack_t) + DEVICE_ADDRL,	/* dl_brdcst_addr_offset */
	0			/* dl_growth */
};

/*
 * Allocate and zero-out "number" structures
 * each of type "structure" in kernel memory.
 */
#define	GETSTRUCT(structure, number)   \
	((structure *) kmem_zalloc(\
		(u_int) (sizeof (structure) * (number)), KM_NOSLEEP))

/*
#define	MYRISAPMATCH(sap, type, flags) ((sap == type)? 1 : \
	((flags & SLALLSAP)? 1 : \
	((sap < MEDIUM_MTU) && (sap > 0) && (type < MEDIUM_MTU))? 1 : 0))
*/
#define	MYRISAPMATCH(sap, type, flags) ((sap == type)? 1 : \
	((flags & SLALLSAP)? 1 : 0))

/*
 * Defining DEBUG on the compile line (-DDEBUG) will enable debugging
 * statements in this driver.
 * Error message control:
 * 0 = no messages.
 * 1 = Error messages.
 * Can set the value of the debug flag using adb or in /etc/system file
 * with "set myri:myridebug=<value>
 */

#ifdef LATER
#ifdef  DEBUG
int myridebug = 1;
#else
int myridebug = 0;
#endif				/* DEBUG */
#endif				/* LATER */

int myridebug = 1;



void *myri_state;		/* opaque handle for state structs */

/* Standard Streams declarations */

static struct module_info myriminfo = {
	MYRIIDNUM,		/* mi_idnum */
	MYRINAME,		/* mi_idname */
	MYRIMINPSZ,		/* mi_minpsz */
	MYRIMAXPSZ,		/* mi_maxpsz */
	MYRIHIWAT,		/* mi_hiwat */
	MYRILOWAT,		/* mi_lowat */
};

static struct qinit myririnit = {
	NULL,			/* qi_putp */
#ifdef FLOW_CONTROL
	myrirsrv,		/* qi_srvp */
#else
	NULL,			/* qi_srvp */
#endif
	myriopen,		/* qi_qopen */
	myriclose,		/* qi_qclose */
	NULL,			/* qi_qadmin */
	&myriminfo,		/* qi_minfo */
	NULL,			/* qi_mstat */
};

static struct qinit myriwinit = {
	myriwput,		/* qi_putp */
	myriwsrv,		/* qi_srvp */
	NULL,			/* qi_qopen */
	NULL,			/* qi_qclose */
	NULL,			/* qi_qadmin */
	&myriminfo,		/* qi_minfo */
	NULL,			/* qi_mstat */
};

static struct streamtab myri_info = {
	&myririnit,		/* st_rdinit */
	&myriwinit,		/* st_wrinit */
	NULL,			/* st_muxrinit */
	NULL,			/* st_muxwrinit */
};


/* Module Loading/Unloading and Autoconfiguration declarations */

/*
 * cb_ops contains the driver entry points and is roughly equivalent
 * to the cdevsw and bdevsw  structures in previous releases.
 *
 * dev_ops contains, in addition to the pointer to cb_ops, the routines
 * that support loading and unloading our driver.
 *
 * Unsupported entry points are set to nodev, except for the poll
 * routine , which is set to nochpoll(), a routine that returns ENXIO.
 */

static struct cb_ops myri_cb_ops = {
	nodev,			/* cb_open */
	nodev,			/* cb_close */
	nodev,			/* cb_strategy */
	nodev,			/* cb_print */
	nodev,			/* cb_dump */
	nodev,			/* cb_read */
	nodev,			/* cb_write */
	nodev,			/* cb_ioctl */
	nodev,			/* cb_devmap */
	nodev,			/* cb_mmap */
	nodev,			/* cb_segmap */
	nochpoll,		/* cb_chpoll */
	ddi_prop_op,		/* cb_prop_op */
	&myri_info,		/* cb_stream */
	D_MP | D_NEW,		/* cb_flag */
};

static struct dev_ops myri_ops = {
	DEVO_REV,		/* devo_rev */
	0,			/* devo_refcnt */
	myriinfo,		/* devo_getinfo */
	myriidentify,		/* devo_identify */
	myriprobe,		/* devo_probe */
	myriattach,		/* devo_attach */
	myridetach,		/* devo_detach */
	nodev,			/* devo_reset */
	&myri_cb_ops,		/* devo_cb_ops */
	(struct bus_ops *) NULL,/* devo_bus_ops */
};


/*
 * Module linkage information for the kernel.
 */
static struct modldrv modldrv = {
	&mod_driverops,		/* Type of module.  This one is a driver */
	MYRIVERSION,		/* Description */
	&myri_ops,		/* driver ops */
};

static struct modlinkage modlinkage = {
	MODREV_1, {&modldrv, NULL}
};




/*
 * Module Loading and Installation Routines .
 */

/*
 * Module Installation
 * Install the driver and "pre-allocate" space for instances of the driver
 */

int
_init(void)
{
	int status;

	CMN_ERR(3) (CE_CONT, "myri: _init called\n");

	if ((status = ddi_soft_state_init(&myri_state,
					  sizeof(struct myri), 4)) != 0) {
		if (myridebug)
			CMN_ERR(0) (CE_CONT,
			      "myri:_init - soft_state_init failed: 0x%x\n",
				    status);
		return (status);
	}

	/* initialize global locks here */
	rw_init(&myristruplock, "myri streams linked list lock",
		RW_DRIVER, (void *) NULL);

	CMN_ERR(3) (CE_CONT, "myri: _init calling mod_install\n");
	status = mod_install(&modlinkage);
	CMN_ERR(3) (CE_CONT, "myri: _init returning - status = %d\n", status);

	return (status);
}

/*
 * Module Removal
 */

int
_fini(void)
{
	CMN_ERR(3) (CE_CONT, "myri: _fini called\n");

	/* worried about memory allocation and callbacks, so don't unload */
	return (EBUSY);

#ifdef NOT_USED
	{
		int status;
		/*
		 * At this point, make sure you have canceled all call backs
		 * and de-allocated all memory
		 */
		if ((status = mod_remove(&modlinkage)) != 0) {
			if (myridebug)
				CMN_ERR(0) (CE_CONT,
					    "myri:_fini- mod_remove failed: 0x%x\n", status);
			return (status);
		}
		ddi_soft_state_fini(&myri_state);

		return (status);
	}
#endif				/* NOT_USED */

}

/*
 * Return Module Info.
 */

int
_info(struct modinfo * modinfop)
{
	return (mod_info(&modlinkage, modinfop));
}



/*
 * ------------------------------------------------------
 *	Autoconfiguration Routines
 */

/*
 * identify(9e) - are we the right driver.
 */
static int
myriidentify(dev_info_t * dip)
{
	CMN_ERR(0) (CE_CONT, "myriidentify called... str = '%s'\n",
		    ddi_get_name(dip));

	if (strcmp(ddi_get_name(dip), "MYRICOM,mlanai") == 0) {
		CMN_ERR(0) (CE_CONT, "     IDENTIFIED\n");
		return (DDI_IDENTIFIED);
	}
	else if (strcmp(ddi_get_name(dip), "myri") == 0) {
		CMN_ERR(0) (CE_CONT, "     IDENTIFIED\n");
		return (DDI_IDENTIFIED);
	}
#ifdef i86pc
	else if (strcmp(ddi_get_name(dip), "pci10e8,4750") == 0) {
		CMN_ERR(0) (CE_CONT, "     IDENTIFIED\n");
		return (DDI_IDENTIFIED);
	}
#endif i86pc
	else {
		return (DDI_NOT_IDENTIFIED);
	}
}


/*
 * XXX Probe to see if device exists.
 * Note: probe() is required for only non-self-identifying devices.
 * Also Probe should not have any side-effects. Just check that this is the
 * right device. Do not set up any structures or initialize anything.
 */

static int
myriprobe(dip)
	dev_info_t *dip;
{
	CMN_ERR(0) (CE_CONT, "myriPROBE called... str = '%s'\n",
		    ddi_get_name(dip));

	if (ddi_dev_is_sid(dip) == DDI_SUCCESS) {
		return (DDI_PROBE_DONTCARE);
	}

#ifdef i86pc
	{
		volatile struct AMCC_regs *regsp;

		if (ddi_map_regs(dip, 0, (caddr_t *) regsp,
				 0, sizeof(struct AMCC_regs) ) != DDI_SUCCESS) {

			/*
			 * XXX use ddi_peek(9F) ddi_pokes(9F) here to check
			 * if write to device succeeds.
			 */
			ddi_unmap_regs(dip, 0, (caddr_t *) regsp, 0, sizeof(struct AMCC_regs));
			CMN_ERR(0) (CE_CONT, "myriPROBE returning SUCCESS\n");
			return (DDI_PROBE_SUCCESS);
		}
		else {
			if (myridebug) {
				myrierror(dip, "probe failed trying to map regs");
			}
			return (DDI_PROBE_FAILURE);
		}
	}
#endif				/* i86pc */


	return (DDI_PROBE_DONTCARE);
}

/*
 * Interface exists: make available by filling in network interface
 * record.  System will initialize the interface when it is ready
 * to accept packets.
 */

static int
myriattach(dev_info_t * dip, ddi_attach_cmd_t cmd)
{
	struct myri *myrip;
	int instance;

	if (cmd != DDI_ATTACH) {
		myrierror(dip, "myriattach ! DDI_ATTACH : failed");
		return (DDI_FAILURE);
	}

	instance = ddi_get_instance(dip);

	CMN_ERR(0) (CE_CONT, "myriattach called... name = '%s' instance = %d\n",
		    ddi_get_name(dip), instance);

	CMN_ERR(0) (CE_CONT, "myriattach: '%s' %d 0x%x 0x%x 0x%x\n",
		    ddi_get_name(dip),
		    instance,
		    (unsigned) ddi_get_nodeid(dip),
		    (unsigned) ddi_get_driver(dip),
		    (unsigned) ddi_get_driver_private(dip));


	if (instance_used[instance] != -1) {
		CMN_ERR(0) (CE_CONT, "--------------------------------------------------------\n");
		CMN_ERR(0) (CE_CONT, "**** myriattach: Instance = %d ALREADY ATTACHED!\n",
			    instance);
		CMN_ERR(0) (CE_CONT, "**** myriattach: WHY IS ATTACH BEING CALLED!\n");
		ddi_report_dev(dip);
		CMN_ERR(0) (CE_CONT, "**** myriattach: WILL FAIL soft_state_alloc()\n");
		CMN_ERR(0) (CE_CONT, "--------------------------------------------------------\n");
	}

	instance_used[instance] = instance;

	/*
	 * Allocate soft data structure
	 */

	if (ddi_soft_state_zalloc(myri_state, instance) != DDI_SUCCESS) {
		if (myridebug)
			myrierror(dip, "soft state alloc: failed");
		return (DDI_FAILURE);
	}

	CMN_ERR(3) (CE_CONT, "allocated the soft state\n");

	if (!(myrip = ddi_get_soft_state(myri_state, instance))) {
		CMN_ERR(3) (CE_CONT, "myriattach: failed ddi_get_soft_state(%d)\n",
			    instance);
		return (DDI_FAILURE);
	}

	CMN_ERR(3) (CE_CONT, "got the soft state\n");

	/*
	 * Map in the device registers. It is different for each
	 * architecture.
	 */


#ifndef i86pc
	/*
	 * Save the register mapping and the size of the memory. This value
	 * depends on the FCode in the SBus device(=4). We go ahead and map
	 * all the memory so we can overwrite the LANai memory if necessary.
	 */
	if (ddi_map_regs(dip, 0, (caddr_t *) & myrip->myri_regsp,
			 0, TOTSIZE_BYTES) != DDI_SUCCESS) {
		if (myridebug)
			myrierror(dip, "ddi_map_regs failed");
		goto bad;
	}
#endif				/* i86pc */


#ifdef i86pc
	/* For the x86 there should be 3 register sets */
	if (ddi_map_regs(dip, 0, (caddr_t *) & myrip->myri_regsp,
			 0, sizeof(struct AMCC_regs) ) != DDI_SUCCESS) {
		if (myridebug)
			myrierror(dip, "ddi_map_regs set 0 failed");
		goto bad;
	}
	CMN_ERR(3) (CE_CONT, "mapped register set = 0\n");

	if (ddi_map_regs(dip, 1, (caddr_t *) & myrip->lanai_memory,
			 0, (256 * 1024)) != DDI_SUCCESS) {
		if (myridebug)
			myrierror(dip, "ddi_map_regs set 1 failed");
	}
	else {
		myrip->lanai_registers = myrip->lanai_memory + (128 * 1024);
		CMN_ERR(3) (CE_CONT, "mapped register set = 1\n");
	}

	if (ddi_map_regs(dip, 2, (caddr_t *) & myrip->lanai_memory_wake,
			 0, (256 * 1024)) != DDI_SUCCESS) {
		if (myridebug)
			myrierror(dip, "ddi_map_regs set 2 failed");
	}
	else {
		myrip->lanai_registers_wake = myrip->lanai_memory_wake + (128 * 1024);
		CMN_ERR(3) (CE_CONT, "mapped register set = 2\n");
	}
#endif				/* i86pc */

	CMN_ERR(3) (CE_CONT, "mapped the registers\n");

	/*
	 * Reject this device if it's a Bus Master in a slave-only slot.
	 */

	if ((ddi_slaveonly(dip) == DDI_SUCCESS) &&
			((myrip->myri_flags & MYRISLAVE) == 0)) {
		if (myridebug)
			myrierror(dip, "not used - device in SLAVE only slot");
		goto bad;
	}

	/*
	 * check to see if your device interrupts at a high level - if it
	 * does, you can a) print a msg saying you do not support high level
	 * interrupts OR b) you can write a high level intrrupt handler. To
	 * see how to do this read the Solaris 2.x Writing Device Drivers
	 * manual
	 */


	if (ddi_intr_hilevel(dip, 0) != 0) {
		if (myridebug)
			myrierror(dip, "High level interrupts not supported");
	}

#ifdef i86pc
	AMCC_INT_OFF(myrip->myri_regsp);
	AMCC_RESET_ON(myrip->myri_regsp);
#else
	myrip->myri_regsp->int_off = 1;
	myrip->myri_regsp->rst_on = 1;
#endif

#ifdef NULL_INTERRUPT
	/* add a null interrupt driver -  */
	/* see page 110 of Writing Dev. Drivers- Aug 1994 */

	if (ddi_add_intr(dip, 0, &myrip->iblock_cookie,
		 NULL, (u_int(*) (caddr_t)) nulldev, NULL) != DDI_SUCCESS) {
		if (myridebug)
			myrierror(dip, "ddi_add_intr for NULL device failed");
		goto bad;
	}
	CMN_ERR(3) (CE_CONT, "added NULL interrupt\n");
#else
	/* add the real interrupt routine */
	if (ddi_add_intr(dip, 0, &myrip->iblock_cookie, 0,
			 myriintr, (caddr_t) myrip) != DDI_SUCCESS) {
		if (myridebug)
			myrierror(dip, "ddi_add_intr failed");
		goto bad;
	}
	CMN_ERR(3) (CE_CONT, "added real interrupt routine\n");
#endif				/* NULL_INTERRUPT */

	/*
	 * Initialize mutex's for this device.
	 */
	/* if used in interrupt routine, arg4 = iblock_cookie, else NULL */

	mutex_init(&myrip->myri_xmitlock, "myri xmit lock", MUTEX_DRIVER,
		   (void *) myrip->iblock_cookie);
	mutex_init(&myrip->myri_recvlock, "myri recv lock", MUTEX_DRIVER,
		   (void *) myrip->iblock_cookie);
	mutex_init(&myrip->myri_bufflock, "myri buff lock", MUTEX_DRIVER,
		   (void *) myrip->iblock_cookie);


	CMN_ERR(0) (CE_CONT, "initialized mutex myri_xmitlock = 0x%x\n",
		    (unsigned) &myrip->myri_xmitlock);
	CMN_ERR(0) (CE_CONT, "initialized mutex myri_recvlock = 0x%x\n",
		    (unsigned) &myrip->myri_recvlock);
	CMN_ERR(0) (CE_CONT, "initialized mutex myri_bufflock = 0x%x\n",
		    (unsigned) &myrip->myri_bufflock);

	/* am stuff */
	printf("going to init AM mutex\n");
	mutex_init(&myri_am_mu, "myri AM lock", MUTEX_DRIVER,
		   (void *) myrip->iblock_cookie);
	CMN_ERR(0) (CE_CONT, "initialized AM lock = 0x%x\n",
		    (unsigned) &myrip->myri_bufflock);


	cv_init(&myri_am_cv,"myri AM cv",CV_DRIVER,NULL);
	
	
#ifdef NULL_INTERRUPT
	ddi_remove_intr(dip, 0, myrip->iblock_cookie);

	/* add the real interrupt routine */
	if (ddi_add_intr(dip, 0, &myrip->iblock_cookie, 0,
			 myriintr, (caddr_t) myrip) != DDI_SUCCESS) {
		if (myridebug)
			myrierror(dip, "ddi_add_intr failed");
		goto bad;
	}
	CMN_ERR(3) (CE_CONT, "added real interrupt routine\n");
#endif				/* NULL_INTERRUPT */

	/*
	 * Stuff private info into dip.
	 */

	ddi_set_driver_private(dip, (caddr_t) myrip);
	myrip->myri_dip = dip;

	/*
	 * Link this per-device structure in with the rest.
	 */

	myrip->myri_nextp = myridev;
	myridev = myrip;


	/*
	 * Since we can use ifconfig myri0 ether 0:0:0:0:0:x to set the
	 * device address, we'll just zero the address now.
	 * 
	 */

	bzero((caddr_t) & myrip->myri_ouraddr, sizeof(struct medium_addr));

	/*
	 * Create the filesystem device node.
	 */
	if (ddi_create_minor_node(dip, "myri", S_IFCHR,
			  instance, DDI_NT_NET, CLONE_DEV) == DDI_FAILURE) {
		if (myridebug) {
			myrierror(dip, "ddi_create_minor_node failed");
		}
		ddi_remove_minor_node(dip, NULL);
		goto bad;
	}

	/* intr flag for AM */
	myri_use_am_intr =0;
	am_intr_count =0;

	CMN_ERR(3) (CE_CONT, "created device  myri%d\n", instance);

#ifdef  KSTAT
	myristatinit(myrip);
#endif				/* KSTAT */


	/* set up the LANAI data structures for API stuff to work */
#ifdef i86pc
	LANAI[instance] =
		(u_short *) & myrip->lanai_memory[0];
	LANAI_WAKE[instance] =
		(u_short *) & myrip->lanai_memory_wake[0];
	BOARD[instance] = (unsigned short *) &myrip->myri_regsp;
#else
	LANAI[instance] =
		(u_short *) & myrip->myri_regsp->lanai_memory[0];
#endif

	CMN_ERR(3) (CE_CONT, "Created address for LANAI[%d] = 0x%x\n",
		    instance, LANAI[instance]);

	/* load the LANai processor */
	if (myriLoadLCPkernel(myrip)) {
		myri_init_lanai(myrip);
	}
	else {
		myrierror(dip, "myriattach: Couldn't load the LANai??\n");
	}

	CMN_ERR(1) (CE_CONT, "Calling myri_alloc_buff.\n");
	if (!myri_alloc_buffers(myrip)) {
		CMN_ERR(0) (CE_CONT, "myri_alloc_buff  FAILED!!!!! **********  \n");
		goto bad;
	}

	ddi_report_dev(dip);
	CMN_ERR(0) (CE_CONT, MYRIVERSION);
	CMN_ERR(0) (CE_CONT, "%s\n", myricopyright);



	return (DDI_SUCCESS);

bad:
	ddi_remove_minor_node(dip, "myri");

#ifndef i86pc
	if (myrip->myri_regsp) {
		ddi_unmap_regs(dip, 0, (caddr_t *) & myrip->myri_regsp, 0, TOTSIZE_BYTES);
	}
#endif


#ifdef i86pc
	/* For the x86 there should be 3 register sets */
	if (myrip->myri_regsp) {
		ddi_unmap_regs(dip, 0, (caddr_t *) & myrip->myri_regsp,
			       0, (4 * 1024));
	}

	if (myrip->lanai_memory) {
		ddi_unmap_regs(dip, 1, (caddr_t *) & myrip->lanai_memory,
			       0, (132 * 1024));
	}

	if (myrip->lanai_memory_wake) {
		ddi_unmap_regs(dip, 2, (caddr_t *) & myrip->lanai_memory_wake,
			       0, (132 * 1024));
	}
#endif				/* i86pc */

	/* remove interrupts added to the system */
	if (myrip->iblock_cookie) {
		ddi_remove_intr(dip, 0, myrip->iblock_cookie);
	}

	/* destroy all mutex's */
	mutex_destroy(&myrip->myri_recvlock);
	mutex_destroy(&myrip->myri_xmitlock);
	mutex_destroy(&myrip->myri_bufflock);

	if (myridebug) {
		myrierror(myrip->myri_dip, "attach failed");
	}

	instance_used[instance] = -1;

	if (myrip) {
		ddi_soft_state_free(myri_state, instance);
	}

	return (DDI_FAILURE);
}

/*
 * Detach - Free resources allocated in attach
 */

/*ARGSUSED*/
static int
myridetach(dip, cmd)
	dev_info_t *dip;
	ddi_detach_cmd_t cmd;
{
	int instance;
	struct myri *myrip;

	if (cmd != DDI_DETACH)
		return (DDI_FAILURE);

	instance = ddi_get_instance(dip);

	myrip = ddi_get_soft_state(myri_state, instance);
	if (myrip == NULL)
		return (DDI_FAILURE);

	/* unmap device registers */
	if (myrip->myri_regsp)
		ddi_unmap_regs(dip, 0, (caddr_t *) & myrip->myri_regsp, 0, 0);

	/* remove interrupts added to the system */
	if (myrip->iblock_cookie)
		ddi_remove_intr(dip, 0, myrip->iblock_cookie);

	/* destroy all mutex's */
	mutex_destroy(&myrip->myri_recvlock);
	mutex_destroy(&myrip->myri_xmitlock);
	mutex_destroy(&myrip->myri_bufflock);

	/* release soft state */
	ddi_soft_state_free(myri_state, instance);

	/* release minor node */
	ddi_remove_minor_node(dip, NULL);

	return (DDI_SUCCESS);

}

/*
 * Translate "dev_t" to a pointer to the associated "dev_info_t".
 */
/* ARGSUSED */
static int
myriinfo(dev_info_t * dip, ddi_info_cmd_t infocmd, void *arg,
	 void **result)
{
	dev_t dev;
	int instance, rc;
	struct myri *myrip;

	CMN_ERR(3) (CE_CONT, "myriinfo called\n");

	switch (infocmd) {
		case DDI_INFO_DEVT2DEVINFO:
			dev = (dev_t) arg;
			instance = getminor(dev);
			myrip = ddi_get_soft_state(myri_state, instance);
			CMN_ERR(3) (CE_CONT, "DDI_INFO_DEVT2DEVINFO: minor=%d inst=%d\n",
				    getminor(dev), instance);
			if (myrip == NULL) {
				*result = NULL;
				rc = DDI_FAILURE;
			}
			else {
				*result = myrip->myri_dip;
				rc = DDI_SUCCESS;
			}
			break;

		case DDI_INFO_DEVT2INSTANCE:
			dev = (dev_t) arg;
			instance = getminor(dev);
			*result = (void *) instance;
			rc = DDI_SUCCESS;
			CMN_ERR(3) (CE_CONT, "DDI_INFO_DEVT2INSTANCE: minor = %d inst = %d\n",
				    getminor(dev), instance);
			break;

		default:
			rc = DDI_FAILURE;
			break;
	}

	CMN_ERR(3) (CE_CONT, "returning %s\n",
		    (rc == DDI_SUCCESS) ? "SUCCESS" : "FAILURE");
	return (rc);
}

#ifdef  KSTAT

static int
myristat_kstat_update(kstat_t * ksp, int rw)
{
	struct myri *myrip;
	struct myristat *myrisp;

	if (rw == KSTAT_WRITE)
		return (EACCES);
	myrip = (struct myri *) ksp->ks_private;
	myrisp = (struct myristat *) ksp->ks_data;
	myrisp->les_ipackets.value.ul = myrip->myri_ipackets;
	myrisp->les_ierrors.value.ul = myrip->myri_ierrors;
	myrisp->les_opackets.value.ul = myrip->myri_opackets;
	myrisp->les_oerrors.value.ul = myrip->myri_oerrors;
	myrisp->les_collisions.value.ul = myrip->myri_collisions;
	return (0);
}

static void
myristatinit(struct myri * myrip)
{
	struct kstat *ksp;
	struct myristat *myrisp;

	if ((ksp = kstat_create("myri", ddi_get_instance(myrip->myri_dip),
				NULL, "net", KSTAT_TYPE_NAMED,
	     sizeof(struct myristat) / sizeof(kstat_named_t), 0)) == NULL) {
		myrierror(myrip->myri_dip, "kstat_create failed");
		return;
	}
	myrisp = (struct myristat *) (ksp->ks_data);
	kstat_named_init(&myrisp->les_ipackets, "ipackets",
			 KSTAT_DATA_ULONG);
	kstat_named_init(&myrisp->les_ierrors, "ierrors",
			 KSTAT_DATA_ULONG);
	kstat_named_init(&myrisp->les_opackets, "opackets",
			 KSTAT_DATA_ULONG);
	kstat_named_init(&myrisp->les_oerrors, "oerrors",
			 KSTAT_DATA_ULONG);
	kstat_named_init(&myrisp->les_collisions, "collisions",
			 KSTAT_DATA_ULONG);
	ksp->ks_update = myristat_kstat_update;
	ksp->ks_private = (void *) myrip;
	kstat_install(ksp);

}

#endif				/* KSTAT */

/*ARGSUSED*/
static
int
myriopen(queue_t * rq, dev_t * devp, int flag, int sflag, cred_t * credp)
{
	struct myristr *slp;
	struct myristr **prevslp;
	minor_t minordev;
	int rc = 0;

	CMN_ERR(3) (CE_CONT, "myriopen called  rq = 0x%x\n", rq);

	ASSERT(sflag != MODOPEN);

	/*
	 * Serialize all driver open and closes.
	 */
	rw_enter(&myristruplock, RW_WRITER);

	/*
	 * Determine minor device number.
	 */
	prevslp = &myristrup;
	if (sflag == CLONEOPEN) {
		minordev = 0;
		for (; (slp = *prevslp); prevslp = &slp->sl_nextp) {
			if (minordev < slp->sl_minor)
				break;
			minordev++;
		}
		*devp = makedevice(getmajor(*devp), minordev);
	}
	else {
		minordev = getminor(*devp);
	}

	CMN_ERR(3) (CE_CONT, "myriopen minordev = %d\n", minordev);
	if (rq->q_ptr)
		goto done;

	if ((slp = GETSTRUCT(struct myristr, 1)) == NULL) {
		rc = ENOMEM;
		rw_exit(&myristruplock);
		return (rc);
	}

	slp->sl_minor = minordev;
	slp->sl_rq = rq;
	slp->sl_state = DL_UNATTACHED;
	slp->sl_sap = 0;
	slp->sl_flags = 0;
	slp->sl_myrip = NULL;
	slp->sl_mccount = 0;
	slp->sl_mctab = NULL;
	mutex_init(&slp->sl_lock, "myri stream lock", MUTEX_DRIVER, (void *) 0);

	/*
	 * Link new entry into the list of active entries.
	 */
	slp->sl_nextp = *prevslp;
	*prevslp = slp;

	rq->q_ptr = WR(rq)->q_ptr = slp;

	/*
	 * Disable our write-side  & read-side service procedures.
	 */
	noenable(WR(rq));
	noenable(rq);

done:
	rw_exit(&myristruplock);
	qprocson(rq);
	return (rc);
}

static int
myriclose(queue_t * rq, int flag, cred_t * credp)
{
	struct myristr *slp;
	struct myristr **prevslp;

	CMN_ERR(3) (CE_CONT, "myriclose called  rq = 0x%x\n", rq);

	ASSERT(rq);
	ASSERT(rq->q_ptr);


	slp = (struct myristr *) rq->q_ptr;

	/*
	 * Implicit detach Stream from interface.
	 */
	if (slp->sl_myrip)
		myridodetach(slp);

	qprocsoff(rq);

	rw_enter(&myristruplock, RW_WRITER);

	/*
	 * Unlink the per-Stream entry from the active list and free it.
	 */
	for (prevslp = &myristrup; (slp = *prevslp); prevslp = &slp->sl_nextp)
		if (slp == (struct myristr *) rq->q_ptr)
			break;
	ASSERT(slp);
	*prevslp = slp->sl_nextp;

	mutex_destroy(&slp->sl_lock);
	kmem_free(slp, sizeof(struct myristr));

	rq->q_ptr = WR(rq)->q_ptr = NULL;

	rw_exit(&myristruplock);
	return (0);
}

static
int
myriwput(queue_t * wq, mblk_t * mp)
{
	struct myristr *slp = (struct myristr *) wq->q_ptr;
	struct myri *myrip;

	GET_TIME(time_start[0]);

	CMN_ERR(3) (CE_CONT, "myriwput called\n");

	switch (DB_TYPE(mp)) {
		case M_DATA:
			CMN_ERR(3) (CE_CONT, "    type = M_DATA\n");
			myrip = slp->sl_myrip;
			if ((slp->sl_flags & SLRAW == 0) ||
					(slp->sl_state != DL_IDLE) ||
					(myrip == NULL)) {
				CMN_ERR(3) (CE_CONT, "   calling pserror\n");
				pserror(wq, mp, EPROTO);
				break;
			}

			/*
			 * If any msgs already enqueued or the interface will
			 * loop back up the message (due to MYRIPROMISC),
			 * then enqueue the msg.  Otherwise just xmit it
			 * directly.
			 */
			if (wq->q_first) {
				CMN_ERR(3) (CE_CONT, "   enqueueing the message\n");
				putq(wq, mp);
				myrip->myri_wantw = 1;
			}
			else if (myrip->myri_flags & MYRIPROMISC) {
				CMN_ERR(3) (CE_CONT, "   enqueueing the message\n");
				putq(wq, mp);
				qenable(wq);
			}
			else {
				CMN_ERR(3) (CE_CONT, "   calling myristart\n");
				(void) myristart(wq, mp, myrip);
			}

			break;

		case M_PROTO:
		case M_PCPROTO:
			{
				int rv = -1;
				CMN_ERR(3) (CE_CONT, "    type = M_PROTO or M_PCPROTO\n");
				if (!wq->q_first) {
					rv = myrifastpath(wq, mp);
				}
				if (!(rv == 1)) {
					CMN_ERR(3) (CE_CONT, "   no fastpath, putq the PROTO msg rv = %d\n",
						    rv);
					putq(wq, mp);
					qenable(wq);
				}
			}
			break;

		case M_IOCTL:
			CMN_ERR(3) (CE_CONT, "    type = M_IOCTL\n");
			myriioctl(wq, mp);
			break;

		case M_FLUSH:
			CMN_ERR(3) (CE_CONT, "    type = M_FLUSH\n");
			if (*mp->b_rptr & FLUSHW) {
				flushq(wq, FLUSHALL);
				*mp->b_rptr &= ~FLUSHW;
			}
			if (*mp->b_rptr & FLUSHR)
				qreply(wq, mp);
			else
				freemsg(mp);
			break;

		default:
			CMN_ERR(0) (CE_CONT, "    type = default = %d\n",
				    DB_TYPE(mp));
			freemsg(mp);
			break;
	}
	return (0);
}

/*
 * Enqueue M_PROTO/M_PCPROTO (always) and M_DATA (sometimes) on the wq.
 *
 * Processing of some of the M_PROTO/M_PCPROTO msgs involves acquiring
 * internal locks that are held across upstream putnext calls.
 * Specifically there's the problem of myriintr() holding myri_intrlock
 * and myristruplock when it calls putnext() and that thread looping
 * back around to call myriwput and, eventually, myriinit() to create a
 * recursive lock panic.  There are two obvious ways of solving this
 * problem: (1) have myriintr() do putq instead of putnext which provides
 * the loopback "cutout" right at the rq, or (2) allow myriintr() to putnext
 * and put the loopback "cutout" around myriproto().  We choose the latter
 * for performance reasons.
 *
 * M_DATA messages are enqueued on the wq *only* when the xmit side
 * is out of buffer space.  Once the xmit resource is available again,
 * wsrv() is enabled and tries to xmit all the messages on the wq.
 */
static
int
myriwsrv(queue_t * wq)
{
	mblk_t *mp;
	struct myristr *slp;
	struct myri *myrip;

	CMN_ERR(3) (CE_CONT, "myriWSRV called\n");

	slp = (struct myristr *) wq->q_ptr;
	myrip = slp->sl_myrip;

	while ((mp = getq(wq)))
		switch (DB_TYPE(mp)) {
			case M_DATA:
				if (myrip) {
					if (myristart(wq, mp, myrip))
						goto done;
				}
				else {
					CMN_ERR(3) (CE_CONT, "   myrip = NULL, freeing the message\n");
					freemsg(mp);
				}
				break;

			case M_PROTO:
			case M_PCPROTO:
				myriproto(wq, mp);
				break;

			default:	/* nothing is working at ths point */
				ASSERT(0);
				break;
		}

done:
	return (0);
}


static void
myriproto(queue_t * wq, mblk_t * mp)
{
	union DL_primitives *dlp;
	struct myristr *slp;
	u_long prim;

	CMN_ERR(3) (CE_CONT, "myriproto called\n");

	slp = (struct myristr *) wq->q_ptr;
	dlp = (union DL_primitives *) mp->b_rptr;
	prim = dlp->dl_primitive;

	mutex_enter(&slp->sl_lock);

	switch (prim) {
		case DL_UNITDATA_REQ:
			myriudreq(wq, mp);
			break;

		case DL_ATTACH_REQ:
			myriareq(wq, mp);
			break;

		case DL_DETACH_REQ:
			myridreq(wq, mp);
			break;

		case DL_BIND_REQ:
			myribreq(wq, mp);
			break;

		case DL_UNBIND_REQ:
			myriubreq(wq, mp);
			break;

		case DL_INFO_REQ:
			myriireq(wq, mp);
			break;

		case DL_PROMISCON_REQ:
			myriponreq(wq, mp);
			break;

		case DL_PROMISCOFF_REQ:
			myripoffreq(wq, mp);
			break;

		case DL_ENABMULTI_REQ:
			myriemreq(wq, mp);
			break;

		case DL_DISABMULTI_REQ:
			myridmreq(wq, mp);
			break;

		case DL_PHYS_ADDR_REQ:
			myripareq(wq, mp);
			break;

		case DL_SET_PHYS_ADDR_REQ:
			myrispareq(wq, mp);
			break;

		default:
			psdlerrorack(wq, mp, prim, DL_UNSUPPORTED, 0);
			break;
	}

	mutex_exit(&slp->sl_lock);
}

static void
myriioctl(queue_t * wq, mblk_t * mp)
{
	struct iocblk *iocp = (struct iocblk *) mp->b_rptr;
	struct myristr *slp = (struct myristr *) wq->q_ptr;

	CMN_ERR(3) (CE_CONT, "myriioctl called\n");

	switch (iocp->ioc_cmd) {
		case DLIOCRAW:	/* raw M_DATA mode */
			slp->sl_flags |= SLRAW;
			psiocack(wq, mp, 0, 0);
			break;

		default:
			psiocnak(wq, mp, 0, EINVAL);
			break;
	}
}

 /* Generic DLPI interface routines */

static void
myriareq(queue_t * wq, mblk_t * mp)
{
	struct myristr *slp;
	union DL_primitives *dlp;
	struct myri *myrip;
	int ppa;

	CMN_ERR(3) (CE_CONT, "myriareq called\n");

	slp = (struct myristr *) wq->q_ptr;
	dlp = (union DL_primitives *) mp->b_rptr;

	if (MBLKL(mp) < DL_ATTACH_REQ_SIZE) {
		psdlerrorack(wq, mp, DL_ATTACH_REQ, DL_BADPRIM, 0);
		return;
	}

	if (slp->sl_state != DL_UNATTACHED) {
		psdlerrorack(wq, mp, DL_ATTACH_REQ, DL_OUTSTATE, 0);
		return;
	}

	ppa = dlp->attach_req.dl_ppa;

	/*
	 * Valid ppa?
	 */
	for (myrip = myridev; myrip; myrip = myrip->myri_nextp)
		if (ppa == ddi_get_instance(myrip->myri_dip))
			break;
	if (myrip == NULL) {
		psdlerrorack(wq, mp, dlp->dl_primitive, DL_BADPPA, 0);
		return;
	}

	/*
	 * Has device been initialized?  Do so if necessary.
	 */
	if ((myrip->myri_flags & MYRIRUNNING) == 0) {
		if (myriinit(myrip)) {
			psdlerrorack(wq, mp, dlp->dl_primitive,
				     DL_INITFAILED, 0);
			return;
		}
	}

	/*
	 * Set link to device and update our state.
	 */
	slp->sl_myrip = myrip;
	slp->sl_state = DL_UNBOUND;

	psdlokack(wq, mp, DL_ATTACH_REQ);
}

static void
myridreq(queue_t * wq, mblk_t * mp)
{
	struct myristr *slp;

	CMN_ERR(3) (CE_CONT, "myridreq called\n");

	slp = (struct myristr *) wq->q_ptr;

	if (MBLKL(mp) < DL_DETACH_REQ_SIZE) {
		psdlerrorack(wq, mp, DL_DETACH_REQ, DL_BADPRIM, 0);
		return;
	}

	if (slp->sl_state != DL_UNBOUND) {
		psdlerrorack(wq, mp, DL_DETACH_REQ, DL_OUTSTATE, 0);
		return;
	}

	myridodetach(slp);
	psdlokack(wq, mp, DL_DETACH_REQ);
}

/*
 * Detach a Stream from an interface.
 */
static void
myridodetach(struct myristr * slp)
{
	struct myristr *tslp;
	struct myri *myrip;
	int reinit = 0;

	CMN_ERR(3) (CE_CONT, "myridodetach called\n");

	ASSERT(slp->sl_myrip);

	myrip = slp->sl_myrip;
	slp->sl_myrip = NULL;

	/*
	 * Disable promiscuous mode if on.
	 */
	if (slp->sl_flags & SLALLPHYS) {
		slp->sl_flags &= ~SLALLPHYS;
		reinit = 1;
	}

	/*
	 * Disable ALLMULTI mode if on.
	 */
	if (slp->sl_flags & SLALLMULTI) {
		slp->sl_flags &= ~SLALLMULTI;
		reinit = 1;
	}

	/*
	 * Disable any Multicast Addresses.
	 */
	slp->sl_mccount = 0;
	if (slp->sl_mctab) {
		kmem_free(slp->sl_mctab, DEVMCALLOC);
		slp->sl_mctab = NULL;
		reinit = 1;
	}

	/*
	 * Detach from device structure. Uninit the device when no other
	 * streams are attached to it.
	 */
	for (tslp = myristrup; tslp; tslp = tslp->sl_nextp)
		if (tslp->sl_myrip == myrip)
			break;
	if (tslp == NULL)
		myriuninit(myrip);
	else if (reinit)
		(void) myriinit(myrip);

	slp->sl_state = DL_UNATTACHED;
}

static void
myribreq(queue_t * wq, mblk_t * mp)
{
	struct myristr *slp;
	union DL_primitives *dlp;
	struct myri *myrip;
	struct myridladdr myriaddr;
	u_long sap;
	int xidtest;

	CMN_ERR(3) (CE_CONT, "myribreq called\n");

	slp = (struct myristr *) wq->q_ptr;

	if (MBLKL(mp) < DL_BIND_REQ_SIZE) {
		psdlerrorack(wq, mp, DL_BIND_REQ, DL_BADPRIM, 0);
		return;
	}

	if (slp->sl_state != DL_UNBOUND) {
		psdlerrorack(wq, mp, DL_BIND_REQ, DL_OUTSTATE, 0);
		return;
	}

	dlp = (union DL_primitives *) mp->b_rptr;
	myrip = slp->sl_myrip;
	sap = dlp->bind_req.dl_sap;
	xidtest = dlp->bind_req.dl_xidtest_flg;

	ASSERT(myrip);

	if (xidtest) {
		psdlerrorack(wq, mp, DL_BIND_REQ, DL_NOAUTO, 0);
		return;
	}

	if (sap > MEDIUMTYPE_MAX) {
		psdlerrorack(wq, mp, dlp->dl_primitive, DL_BADSAP, 0);
		return;
	}

	/*
	 * Save SAP value for this Stream and change state.
	 */
	slp->sl_sap = sap;
	slp->sl_state = DL_IDLE;

	myriaddr.dl_sap = sap;
	bcopy_addr((caddr_t) & myrip->myri_ouraddr,
		   (caddr_t) & myriaddr.dl_phys,
		   sizeof(struct medium_addr));

	CMN_ERR(3) (CE_CONT, "binding a stream sap = %x  wq = %x  rq = %x\n",
		    sap, wq, RD(wq));

	CMN_ERR(3) (CE_CONT, "slp->sl_rq = %x  RD(wq) = %x\n", slp->sl_rq, RD(wq));

	if (slp->sl_rq != RD(wq)) {
		CMN_ERR(3) (CE_CONT, "UPDATING the rq pointer\n");
		slp->sl_rq = RD(wq);
	}

	psdlbindack(wq, mp, sap, (caddr_t) & myriaddr, DEVICE_ADDRL, 0, 0);
}

static void
myriubreq(queue_t * wq, mblk_t * mp)
{
	struct myristr *slp;

	CMN_ERR(3) (CE_CONT, "myriubreq called\n");

	slp = (struct myristr *) wq->q_ptr;

	if (MBLKL(mp) < DL_UNBIND_REQ_SIZE) {
		psdlerrorack(wq, mp, DL_UNBIND_REQ, DL_BADPRIM, 0);
		return;
	}

	if (slp->sl_state != DL_IDLE) {
		psdlerrorack(wq, mp, DL_UNBIND_REQ, DL_OUTSTATE, 0);
		return;
	}

	CMN_ERR(3) (CE_CONT, "UNbinding sap = %x\n", slp->sl_sap);

	slp->sl_state = DL_UNBOUND;

	putnextctl1(RD(wq), M_FLUSH, FLUSHRW);

	psdlokack(wq, mp, DL_UNBIND_REQ);
}

static void
myriireq(queue_t * wq, mblk_t * mp)
{
	struct myristr *slp;
	dl_info_ack_t *dlip;
	struct myridladdr *dlap;
	struct medium_addr *ep;
	int size;

	CMN_ERR(3) (CE_CONT, "myriireq called\n");

	slp = (struct myristr *) wq->q_ptr;

	if (MBLKL(mp) < DL_INFO_REQ_SIZE) {
		psdlerrorack(wq, mp, DL_INFO_REQ, DL_BADPRIM, 0);
		return;
	}

	/*
	 * Exchange current msg for a DL_INFO_ACK.
	 */
	size = sizeof(dl_info_ack_t) + DEVICE_ADDRL + MEDIUM_ADDRL;
	if ((mp = psexchange(wq, mp, size, M_PCPROTO, DL_INFO_ACK)) == NULL)
		return;

	/*
	 * Fill in the DL_INFO_ACK fields and reply.
	 */
	dlip = (dl_info_ack_t *) mp->b_rptr;

/*
	FIX - gcc uses memcpy
	*dlip = myriinfoack;
*/
	bcopy((caddr_t) & myriinfoack, (caddr_t) dlip, sizeof(myriinfoack));

	dlip->dl_current_state = slp->sl_state;
	dlap = (struct myridladdr *) (mp->b_rptr + dlip->dl_addr_offset);
	dlap->dl_sap = slp->sl_sap;
	if (slp->sl_myrip) {
		bcopy_addr((caddr_t) & slp->sl_myrip->myri_ouraddr,
			   (caddr_t) & dlap->dl_phys,
			   sizeof(struct medium_addr));
	}
	else {
		bzero((caddr_t) & dlap->dl_phys, MEDIUM_ADDRL);
	}
	ep = (struct medium_addr *) (mp->b_rptr + dlip->dl_brdcst_addr_offset);
	bcopy_addr((caddr_t) & medbroadcastaddr,
		   (caddr_t) ep,
		   sizeof(struct medium_addr));

	qreply(wq, mp);
}

static void
myriponreq(queue_t * wq, mblk_t * mp)
{
	struct myristr *slp;

	CMN_ERR(3) (CE_CONT, "myriponreq called\n");

	slp = (struct myristr *) wq->q_ptr;

	if (MBLKL(mp) < DL_PROMISCON_REQ_SIZE) {
		psdlerrorack(wq, mp, DL_PROMISCON_REQ, DL_BADPRIM, 0);
		return;
	}

	switch (((dl_promiscon_req_t *) mp->b_rptr)->dl_level) {
		case DL_PROMISC_PHYS:
			slp->sl_flags |= SLALLPHYS;
			break;

		case DL_PROMISC_SAP:
			slp->sl_flags |= SLALLSAP;
			break;

		case DL_PROMISC_MULTI:
			slp->sl_flags |= SLALLMULTI;
			break;

		default:
			psdlerrorack(wq, mp, DL_PROMISCON_REQ,
				     DL_NOTSUPPORTED, 0);
			return;
	}

	if (slp->sl_myrip)
		(void) myriinit(slp->sl_myrip);

	psdlokack(wq, mp, DL_PROMISCON_REQ);
}

static void
myripoffreq(queue_t * wq, mblk_t * mp)
{
	struct myristr *slp;
	int flag;

	CMN_ERR(3) (CE_CONT, "myripoffreq called\n");

	slp = (struct myristr *) wq->q_ptr;

	if (MBLKL(mp) < DL_PROMISCOFF_REQ_SIZE) {
		psdlerrorack(wq, mp, DL_PROMISCOFF_REQ, DL_BADPRIM, 0);
		return;
	}

	switch (((dl_promiscoff_req_t *) mp->b_rptr)->dl_level) {
		case DL_PROMISC_PHYS:
			flag = SLALLPHYS;
			break;

		case DL_PROMISC_SAP:
			flag = SLALLSAP;
			break;

		case DL_PROMISC_MULTI:
			flag = SLALLMULTI;
			break;

		default:
			psdlerrorack(wq, mp, DL_PROMISCOFF_REQ,
				     DL_NOTSUPPORTED, 0);
			return;
	}

	if ((slp->sl_flags & flag) == 0) {
		psdlerrorack(wq, mp, DL_PROMISCOFF_REQ, DL_NOTENAB, 0);
		return;
	}

	slp->sl_flags &= ~flag;
	if (slp->sl_myrip)
		(void) myriinit(slp->sl_myrip);

	psdlokack(wq, mp, DL_PROMISCOFF_REQ);
}

static void
myriemreq(queue_t * wq, mblk_t * mp)
{
	struct myristr *slp;
	union DL_primitives *dlp;
	struct medium_addr *addrp;
	int off;
	int len;

	CMN_ERR(3) (CE_CONT, "myriemreq called\n");

	slp = (struct myristr *) wq->q_ptr;

	if (MBLKL(mp) < DL_ENABMULTI_REQ_SIZE) {
		psdlerrorack(wq, mp, DL_ENABMULTI_REQ, DL_BADPRIM, 0);
		return;
	}

	if (slp->sl_state == DL_UNATTACHED) {
		psdlerrorack(wq, mp, DL_ENABMULTI_REQ, DL_OUTSTATE, 0);
		return;
	}

	dlp = (union DL_primitives *) mp->b_rptr;
	len = dlp->enabmulti_req.dl_addr_length;
	off = dlp->enabmulti_req.dl_addr_offset;
	addrp = (struct medium_addr *) (mp->b_rptr + off);

	if ((len != MEDIUM_ADDRL) ||
			!MBLKIN(mp, off, len)) {
		psdlerrorack(wq, mp, DL_ENABMULTI_REQ, DL_BADADDR, 0);
		return;
	}

	if ((slp->sl_mccount + 1) >= DEVMAXMC) {
		psdlerrorack(wq, mp, DL_ENABMULTI_REQ, DL_TOOMANY, 0);
		return;
	}

	/*
	 * Allocate table on first request.
	 */
	if (slp->sl_mctab == NULL)
		if ((slp->sl_mctab = (struct medium_addr *)
		     kmem_alloc(DEVMCALLOC, KM_NOSLEEP)) == NULL) {
			psdlerrorack(wq, mp, DL_ENABMULTI_REQ,
				     DL_SYSERR, ENOMEM);
			return;
		}

	slp->sl_mctab[slp->sl_mccount++] = *addrp;

	(void) myriinit(slp->sl_myrip);
	psdlokack(wq, mp, DL_ENABMULTI_REQ);
}

static void
myridmreq(queue_t * wq, mblk_t * mp)
{
	struct myristr *slp;
	union DL_primitives *dlp;
	struct medium_addr *addrp;
	int off;
	int len;
	int i;

	CMN_ERR(3) (CE_CONT, "myridmreq called\n");

	slp = (struct myristr *) wq->q_ptr;

	if (MBLKL(mp) < DL_DISABMULTI_REQ_SIZE) {
		psdlerrorack(wq, mp, DL_DISABMULTI_REQ, DL_BADPRIM, 0);
		return;
	}

	if (slp->sl_state == DL_UNATTACHED) {
		psdlerrorack(wq, mp, DL_DISABMULTI_REQ, DL_OUTSTATE, 0);
		return;
	}

	dlp = (union DL_primitives *) mp->b_rptr;
	len = dlp->disabmulti_req.dl_addr_length;
	off = dlp->disabmulti_req.dl_addr_offset;
	addrp = (struct medium_addr *) (mp->b_rptr + off);

	if ((len != MEDIUM_ADDRL) || !MBLKIN(mp, off, len)) {
		psdlerrorack(wq, mp, DL_DISABMULTI_REQ, DL_BADADDR, 0);
		return;
	}

	/*
	 * Find the address in the multicast table for this Stream and delete
	 * it by shifting all subsequent multicast table entries over one.
	 */
	for (i = 0; i < slp->sl_mccount; i++)
		/* all this is architecture specific */
		if (bcmp_addr((caddr_t) addrp, (caddr_t) & slp->sl_mctab[i],
			      sizeof(struct medium_addr)) == 0) {
			bcopy((caddr_t) & slp->sl_mctab[i + 1],
			      (caddr_t) & slp->sl_mctab[i],
			      ((slp->sl_mccount - i) *
			       sizeof(struct medium_addr)));
			slp->sl_mccount--;
			(void) myriinit(slp->sl_myrip);
			psdlokack(wq, mp, DL_DISABMULTI_REQ);
			break;
		}
}

static void
myripareq(queue_t * wq, mblk_t * mp)
{
	struct myristr *slp;
	union DL_primitives *dlp;
	int type;
	struct myri *myrip;
	struct medium_addr addr;

	CMN_ERR(3) (CE_CONT, "myripareq called\n");

	slp = (struct myristr *) wq->q_ptr;

	if (MBLKL(mp) < DL_PHYS_ADDR_REQ_SIZE) {
		psdlerrorack(wq, mp, DL_PHYS_ADDR_REQ, DL_BADPRIM, 0);
		return;
	}

	dlp = (union DL_primitives *) mp->b_rptr;
	type = dlp->physaddr_req.dl_addr_type;
	myrip = slp->sl_myrip;

	if (myrip == NULL) {
		psdlerrorack(wq, mp, DL_PHYS_ADDR_REQ, DL_OUTSTATE, 0);
		return;
	}

	switch (type) {
		case DL_FACT_PHYS_ADDR:
			CMN_ERR(3) (CE_CONT, "        DL_FACT_PHYS_ADDR:\n");
			bcopy_addr((caddr_t) & addr, (caddr_t) & myrip->myri_ouraddr,
				   sizeof(struct medium_addr));
			break;

		case DL_CURR_PHYS_ADDR:
			CMN_ERR(3) (CE_CONT, "        DL_CURR_PHYS_ADDR:\n");
			bcopy_addr((caddr_t) & myrip->myri_ouraddr, (caddr_t) & addr,
				   sizeof(struct medium_addr));
			break;

		default:
			CMN_ERR(3) (CE_CONT, "        default:\n");
			psdlerrorack(wq, mp, DL_PHYS_ADDR_REQ,
				     DL_NOTSUPPORTED, 0);
			return;
	}

	psdlphysaddrack(wq, mp, (caddr_t) & addr, MEDIUM_ADDRL);
}


static void
myrispareq(queue_t * wq, mblk_t * mp)
{
	struct myristr *slp;
	union DL_primitives *dlp;
	int off;
	int len;
	struct medium_addr *addrp;
	struct myri *myrip;

	CMN_ERR(3) (CE_CONT, "myrispareq called\n");

	slp = (struct myristr *) wq->q_ptr;

	if (MBLKL(mp) < DL_SET_PHYS_ADDR_REQ_SIZE) {
		psdlerrorack(wq, mp, DL_SET_PHYS_ADDR_REQ, DL_BADPRIM, 0);
		return;
	}

	dlp = (union DL_primitives *) mp->b_rptr;
	len = dlp->set_physaddr_req.dl_addr_length;
	off = dlp->set_physaddr_req.dl_addr_offset;

	if (!MBLKIN(mp, off, len)) {
		psdlerrorack(wq, mp, DL_SET_PHYS_ADDR_REQ, DL_BADPRIM, 0);
		return;
	}

	addrp = (struct medium_addr *) (mp->b_rptr + off);

	/*
	 * If length of address isn't right or the address specified is a
	 * multicast or broadcast address. then return error.
	 */
	if ((addrp->medaddr[0] & 0x1) ||
		      (!((len == MEDIUM_ADDRL) || (len == DEVICE_ADDRL)))) {
		/* multicast or broadcast address */
		/* or length is bad */
		psdlerrorack(wq, mp, DL_SET_PHYS_ADDR_REQ, DL_BADADDR, 0);
		return;
	}

	/*
	 * Error if this stream is not attached to a device.
	 */
	if ((myrip = slp->sl_myrip) == NULL) {
		psdlerrorack(wq, mp, DL_SET_PHYS_ADDR_REQ, DL_OUTSTATE, 0);
		return;
	}

	/*
	 * Set new interface local address and re-init device. This is
	 * destructive to any other streams attached to this device.
	 */
	bcopy_addr((caddr_t) addrp, (caddr_t) & myrip->myri_ouraddr, MEDIUM_ADDRL);

	CMN_ERR(0) (CE_CONT, "Load & Reset LANai, got new addr %x:%x:%x:%x:%x:%x\n",
		    myrip->myri_ouraddr.medaddr[0],
		    myrip->myri_ouraddr.medaddr[1],
		    myrip->myri_ouraddr.medaddr[2],
		    myrip->myri_ouraddr.medaddr[3],
		    myrip->myri_ouraddr.medaddr[4],
		    myrip->myri_ouraddr.medaddr[5]);

	/* load the LANai processor */
	if (myriLoadLCPkernel(myrip)) {
		myri_init_lanai(myrip);
	}
	else {
		myrierror(myrip->myri_dip,
			  "myripareq: Couldn't load the LANai??\n");
	}


	(void) myriinit(slp->sl_myrip);

	psdlokack(wq, mp, DL_SET_PHYS_ADDR_REQ);
}

static void
myriudreq(queue_t * wq, mblk_t * mp)
{
	struct myristr *slp;
	register struct myri *myrip;
	register dl_unitdata_req_t *dludp;
	mblk_t *nmp;
	struct myridladdr *dlap;
	struct medium_header *headerp;
	int off, len;

	CMN_ERR(3) (CE_CONT, "myriudreq called\n");

	slp = (struct myristr *) wq->q_ptr;
	myrip = slp->sl_myrip;

	dludp = (dl_unitdata_req_t *) mp->b_rptr;

	off = dludp->dl_dest_addr_offset;
	len = dludp->dl_dest_addr_length;

	CMN_ERR(5) (CE_CONT, "   off = %d   len = %d   MED_ADDRL = %d DEVICE_ADRL = %d\n",
		    off, len, MEDIUM_ADDRL, DEVICE_ADDRL);

	/*
	 * Validate destination address format.
	 */
	if (!MBLKIN(mp, off, len) || (len != DEVICE_ADDRL)) {
		psdluderrorind(wq, mp, (u_char *) (mp->b_rptr + off), len,
			       DL_BADADDR, 0);
		CMN_ERR(0) (CE_CONT, "  something wrong with the addrlen  MBLKIN = 0x%x\n",
			    MBLKIN(mp, off, len));
		return;
	}

	/*
	 * Error if no M_DATA follows.
	 */
	nmp = mp->b_cont;
	if (nmp == NULL) {
		psdluderrorind(wq, mp, (u_char *) (mp->b_rptr + off), len,
			       DL_BADDATA, 0);
		CMN_ERR(0) (CE_CONT, "  nmp == NULL?\n");
		return;
	}

	dlap = (struct myridladdr *) (mp->b_rptr + off);

	/*
	 * Create medium header by either prepending it onto the next mblk if
	 * possible, or reusing the M_PROTO block if not.
	 */
	if ((DB_REF(nmp) == 1) &&
			(MBLKHEAD(nmp) >= sizeof(struct medium_header)) &&
			(((ulong) nmp->b_rptr & 0x1) == 0)) {
		nmp->b_rptr -= sizeof(struct medium_header);
		headerp = (struct medium_header *) nmp->b_rptr;
		bcopy_addr((caddr_t) & dlap->dl_phys, (caddr_t) & headerp->med_dhost,
			   sizeof(struct medium_addr));
		bcopy_addr((caddr_t) & myrip->myri_ouraddr,
			   (caddr_t) & headerp->med_shost,
			   sizeof(struct medium_addr));
		headerp->med_type = dlap->dl_sap;
		freeb(mp);
		mp = nmp;
	}
	else {
		DB_TYPE(mp) = M_DATA;
		headerp = (struct medium_header *) mp->b_rptr;
		mp->b_wptr = mp->b_rptr + sizeof(struct medium_header);
		bcopy_addr((caddr_t) & dlap->dl_phys, (caddr_t) & headerp->med_dhost,
			   sizeof(struct medium_addr));
		bcopy_addr((caddr_t) & myrip->myri_ouraddr,
			   (caddr_t) & headerp->med_shost,
			   sizeof(struct medium_addr));
		headerp->med_type = dlap->dl_sap;
	}

	/*
	 * Transmit it.
	 */
	(void) myristart(wq, mp, myrip);
}

/*
 * Start transmission.
 * Return zero on success,
 * otherwise put msg on wq, set 'want' flag and return nonzero.
 */
static
int
myristart(queue_t * wq, mblk_t * mp, struct myri * myrip)
{
	int rv = 1;

#ifdef i86pc
	AMCC_INT_OFF(myrip->myri_regsp);
#else
	myrip->myri_regsp->int_off = 1;
#endif

	if (wq && mp && myrip) {
		CMN_ERR(3) (CE_CONT, "Calling myri_tolanai - SENDING\n");
		rv = myri_tolanai(wq, mp, myrip);
		GET_TIME(time_stop[6]);
	}

	if (rv) {
		/* now check to see if there's anything in recv */
		CMN_ERR(3) (CE_CONT, "Calling myri_handle_lanai_intr after send1\n");
		myri_handle_lanai_intr(myrip, RECV_ALL_MSGS);

#ifdef i86pc
		AMCC_INT_ON(myrip->myri_regsp);
#else
		myrip->myri_regsp->int_on = 1;
#endif

#ifdef DO_TIMING
		SUB_TIME(time_stop[2], time_start[0]);
		SUB_TIME(time_stop[3], time_start[0]);
		SUB_TIME(time_stop[4], time_start[0]);
		SUB_TIME(time_stop[5], time_start[0]);
		SUB_TIME(time_stop[6], time_start[0]);

		CMN_ERR(TIMING_PRINT) (CE_CONT, "Slow path: %d  %d  %d  %d  %d\n",
				       time_stop[2].tv_usec,
				       time_stop[3].tv_usec,
				       time_stop[4].tv_usec,
				       time_stop[5].tv_usec,
				       time_stop[6].tv_usec);
#endif				/* DO_TIMING */

		return (0);
	}
	else {
		/* couldn't hand message to LANai, should queue it */
		/*
		 * FIX - BUT, the message was probably already deleted in
		 * tolanai()
		 */
/*
		CMN_ERR(0) (CE_CONT,
			    "myristart: put msg on wq, set 'want' flag and return nonzero. \n");

		putq(wq, mp);
		myrip->myri_wantw = 1;
*/

		CMN_ERR(3) (CE_CONT, "Calling myri_handle_lanai_intr after send2\n");
		myri_handle_lanai_intr(myrip, RECV_ALL_MSGS);

#ifdef i86pc
		AMCC_INT_ON(myrip->myri_regsp);
#else
		myrip->myri_regsp->int_on = 1;
#endif
		return (1);
	}

#ifdef i86pc
	AMCC_INT_ON(myrip->myri_regsp);
#else
	myrip->myri_regsp->int_on = 1;
#endif

	return (0);
}

static u_int
myriintr(struct myri * myrip)
{
	int got_int = 0;
	int serviced = 0;
	int unit = ddi_get_instance(myrip->myri_dip);

	
	CMN_ERR(3) (CE_CONT, "myriINTERRUPT called\n");

	/* Can't just look at the IBIT since the send side does int off/on */
	/* We might miss the interrupt and return UNCLAIMED falsely */
	/* Will return unclaimed if !got_int && (no stuff in queues) */

#ifdef i86pc
	if (AMCC_INT_BIT(myrip->myri_regsp))
#else
	if (!(myrip->myri_regsp->int_bit & IBIT))
#endif
	{
		got_int = 1;

		if (myri_use_am_intr == 0) {
		  if (!++LANAI[unit][GOT_INTR_LOC_LO])
		    ++LANAI[unit][GOT_INTR_LOC_HI];
		}

	}

#ifdef i86pc
	AMCC_INT_OFF(myrip->myri_regsp);
	AMCC_INT_CLEAR(myrip->myri_regsp);
#else
	myrip->myri_regsp->int_off = 1;
#endif

	if (myri_use_am_intr == 1) {
	  mutex_enter(&myri_am_mu);

	  cv_broadcast(&myri_am_cv);

	  LANAI[0][AM_INTR] = 0; /* turn them off */
	  am_intr_count++;
	  
	  mutex_exit(&myri_am_mu);
	  serviced =1; 
	  goto done;
	}
	

	if (myrip->myri_flags & MYRIRUNNING) {
		/* will grab recv mutex inside handle_lanai_intr */
		serviced = myri_handle_lanai_intr(myrip, RECV_FEW_MSGS);
	}
	else {
		CMN_ERR(5) (CE_CONT, "myriintr(): ignoring IP interrupt (not RUNNING)\n");
	}

	if ((myrip->mlanai_p) && (myrip->mlanai_p->polling)) {
		CMN_ERR(5) (CE_CONT, "Calling mmap() driver interrupt routine\n");
		got_int |= (*myrip->mlanai_intr) (myrip->mlanai_p);
	}

	if ((!serviced) && (got_int)) {
		LANAI[unit][NULL_INTR_LOC]++;
	}

      done:
	CMN_ERR(5) (CE_CONT, "myriINTERRUPT exiting  = %d\n",
		    (got_int || serviced));

#ifdef i86pc
	AMCC_INT_ON(myrip->myri_regsp);
#else
	myrip->myri_regsp->int_on = 1;
#endif

	if (got_int || serviced) {
		return (DDI_INTR_CLAIMED);
	}

	return (DDI_INTR_UNCLAIMED);
}

/*
 * Start xmit on any msgs previously enqueued on any write queues.
 */
void
myriwenable(struct myri * myrip)
{
	struct myristr *slp;
	queue_t *wq;

	CMN_ERR(3) (CE_CONT, "myriwenable called\n");

	/*
	 * Order of wantw accesses is important.
	 */
	do {
		myrip->myri_wantw = 0;
		for (slp = myristrup; slp; slp = slp->sl_nextp)
			if ((wq = WR(slp->sl_rq))->q_first)
				qenable(wq);
	} while (myrip->myri_wantw);
}

/*
 * XXX Test upstream destination sap and address match.
 */
struct myristr *
myriaccept(struct myristr * slp, struct myri * myrip,
	   int type, struct medium_addr * addrp)
{
	int sap;
	int flags;

	CMN_ERR(3) (CE_CONT, "myriaccept called\n");

	for (; slp; slp = slp->sl_nextp) {
		sap = slp->sl_sap;
		flags = slp->sl_flags;
		CMN_ERR(3) (CE_CONT, "   sap = %x  type = %x  flags = %x\n",
			    sap, type, flags);

		if ((slp->sl_myrip == myrip) && MYRISAPMATCH(sap, type, flags)) {
			/* bcmp and family are architecture specific */
			if ((bcmp_addr((caddr_t) addrp, (caddr_t) & myrip->myri_ouraddr,
				       sizeof(struct medium_addr)) == 0) ||
					(bcmp_addr((caddr_t) addrp, (caddr_t) & medbroadcastaddr,
					sizeof(struct medium_addr)) == 0) ||
					(flags & SLALLPHYS) ||
					myrimcmatch((struct myristr *) slp,
					    (struct medium_addr *) addrp)) {
				CMN_ERR(3) (CE_CONT, "myriaccept: found a match slp = %x sap = %x\n",
					    slp, sap);
				return (slp);
			}
		}
	}

	return (NULL);
}

/*
 * Test upstream destination sap and address match for SLALLPHYS only.
 */
/* ARGSUSED3 */
#ifdef NOTUSED
static struct myristr *
myripaccept(struct myristr * slp, struct myri * myrip,
	    int type, struct medium_addr * addrp)
{
	int sap;
	int flags;

	CMN_ERR(3) (CE_CONT, "myriPaccept called\n");

	for (; slp; slp = slp->sl_nextp) {
		sap = slp->sl_sap;
		flags = slp->sl_flags;

		if ((slp->sl_myrip == myrip) &&
				MYRISAPMATCH(sap, type, flags) &&
				(flags & SLALLPHYS)) {
			CMN_ERR(3) (CE_CONT, "found a match\n");
			return (slp);
		}
	}

	return (NULL);
}

#endif				/* NOTUSED */

/*
 * XXX Send packet upstream.
 * Assume mp->b_rptr points to medium_header.
 */
void
myrisendup(struct myri * myrip, mblk_t * mp,
	   struct myristr * (*acceptfunc) ())
{
	int type;
	struct medium_addr *dhostp, *shostp;
	struct myristr *slp, *first_slp;
	mblk_t *nmp;
	ulong isgroupaddr = 0;

	CMN_ERR(3) (CE_CONT, "myrisendup called\n");

	dhostp = &((struct medium_header *) mp->b_rptr)->med_dhost;
	shostp = &((struct medium_header *) mp->b_rptr)->med_shost;
	type = ((struct medium_header *) mp->b_rptr)->med_type;

	/* if multicast or broadcast, set groupaddr = TRUE */
	if (dhostp->medaddr[0] & 0x1) {
		isgroupaddr = 1;
		CMN_ERR(3) (CE_CONT, "      is GROUP address %x:%x:%x:%x:%x:%x\n",
			    dhostp->medaddr[0],
			    dhostp->medaddr[1],
			    dhostp->medaddr[2],
			    dhostp->medaddr[3],
			    dhostp->medaddr[4],
			    dhostp->medaddr[5]);
	}

	/*
	 * While holding a reader lock on the linked list of streams
	 * structures, attempt to match the address criteria for each stream
	 * and pass up the  DL_UNITDATA_IND.
	 */

	rw_enter(&myristruplock, RW_READER);

	if ((first_slp = (*acceptfunc) (myristrup, myrip, type, dhostp)) == NULL) {
		rw_exit(&myristruplock);
		freemsg(mp);
		CMN_ERR(3) (CE_CONT, "    dropping message slp = NULL\n");
		return;
	}


	if (first_slp->sl_nextp) {
		slp = (*acceptfunc) (first_slp->sl_nextp, myrip, type, dhostp);
	}
	else {
		slp = NULL;
	}

	/*
	 * Loop on matching open streams until (*acceptfunc)() returns NULL.
	 */
	while (slp) {
		CMN_ERR(3) (CE_CONT, "inside loop slp = %x  sap = %x\n",
			    slp, slp->sl_sap);
		if ((nmp = dupmsg(mp))) {
			if (slp->sl_flags & SLRAW) {
				CMN_ERR(3) (CE_CONT, "    calling putq(%x) SLRAW1 sap = %x\n",
					    slp->sl_rq, slp->sl_sap);
/*
					myri_dump_msg(nmp);
*/
				do_putnext(slp->sl_rq, nmp, TRUE);
			}
			else {
				if ((nmp = myriaddudind(myrip, nmp, shostp,
					      dhostp, type, isgroupaddr))) {
					CMN_ERR(3) (CE_CONT,
						    "    calling putq(%x) after myriaddudind1 sap = %x\n",
						    slp->sl_rq, slp->sl_sap);
/*
						myri_dump_msg(nmp);
*/
					do_putnext(slp->sl_rq, nmp, TRUE);
				}
				else {
					CMN_ERR(0) (CE_CONT, "myrisendup **** myriaddudind failed\n");
					/* message was freed in myriaddudind */
					myrip->myri_ierrors++;
				}
			}
		}
		else {
			CMN_ERR(0) (CE_CONT, "    CAN'T dup message slp = %x  sap = %x\n",
				    slp, slp->sl_sap);
			myrip->myri_ierrors++;
		}

		/* check the next sap */
		if (slp->sl_nextp) {
			slp = (*acceptfunc) (slp->sl_nextp, myrip, type, dhostp);
		}
	}

	/* now do the first one */
	/* this saves the "dup" if there is only one match */

	slp = first_slp;
	if (slp) {

		if (slp->sl_flags & SLRAW) {
			CMN_ERR(3) (CE_CONT, "    calling putq(%x) SLRAW2 sap = %x\n",
				    slp->sl_rq, slp->sl_sap);
/*
                myri_dump_msg(mp);
*/
			do_putnext(slp->sl_rq, mp, TRUE);
		}
		else {
			if ((mp = myriaddudind(myrip, mp, shostp,
					       dhostp, type, isgroupaddr))) {
				CMN_ERR(3) (CE_CONT,
					    "    calling putq(%x) after myriaddudind2 sap = %x\n",
					    slp->sl_rq, slp->sl_sap);
/*
                    myri_dump_msg(mp);
*/
				do_putnext(slp->sl_rq, mp, TRUE);
			}
			else {
				CMN_ERR(0) (CE_CONT, "  ******* myriaddudind failed\n");
				/* message was freed in myriaddudind */
				myrip->myri_ierrors++;
			}
		}
	}

	else {
		myrip->myri_ierrors++;
		CMN_ERR(0) (CE_CONT, "sendup(): Input packet doesn't match any SAP\n");
		myri_dump_msg(mp);
		freemsg(mp);
	}


	rw_exit(&myristruplock);
}


/*********************   do_putnext()  ***********************/
/*
 * Called from myri_sendup and myrirsrv. "first_time" indicates
 * whether this is a fresh message or one that came off of the
 * read queue (previously blocked).
 */

int
do_putnext(queue_t * rq, mblk_t * mp, int first_time)
{
	struct myristr *slp;
	struct myri *myrip;

	CMN_ERR(3) (CE_CONT, "do_putnext called\n");

	if (rq && mp) {
		slp = (struct myristr *) rq->q_ptr;
		myrip = slp->sl_myrip;

		if (canputnext(rq)) {
			putnext(rq, mp);
			CMN_ERR(3) (CE_CONT, "do_putnext: queueing qsize = %d   next = %d \n",
				    qsize(rq),
				    (rq->q_next) ? qsize(rq->q_next) : -1);
			return (1);
		}
		else {

#ifndef FLOW_CONTROL
			CMN_ERR(1) (CE_CONT, "do_putnext: DROPPING  qsize = %d   next = %d\n",
			  qsize(rq), (rq->q_next) ? qsize(rq->q_next) : -1);

			freemsg(mp);
			myrip->myri_ierrors++;
			return (0);
#else				/* ndef_FLOW_CONTROL */

			/*
			 * save queue pointer on front of message and queue
			 * it
			 */
			if (first_time)
				CMN_ERR(0) (CE_CONT, "Queueing msg mp=0x%x q=0x%x\n", mp, rq);
			else
				CMN_ERR(0) (CE_CONT, "RE-Queueing msg mp=0x%x q=0x%x\n", mp, rq);

			/* put the queue pointer at the front of the message */
			if ((unsigned) (mp->b_rptr - sizeof(queue_t *)) >=
					(unsigned) (mp->b_datap->db_base)) {
				mp->b_rptr -= sizeof(queue_t *);
				*((queue_t **) mp->b_rptr) = rq;
			}
			else {
				CMN_ERR(0) (CE_CONT, "No space in head of message\n");
				myrip->myri_ierrors++;
				freemsg(mp);
				return (1);
			}

			if (!first_time) {
				if (!putbq(rq, mp)) {
					CMN_ERR(0) (CE_CONT, "do_putnext: putBq failed\n");
					myrip->myri_ierrors++;
					freemsg(mp);
					return (1);
				}
			}
			else {
				if (!putq(rq, mp)) {
					CMN_ERR(0) (CE_CONT, "do_putnext: putq failed\n");
					myrip->myri_ierrors++;
					freemsg(mp);
					return (1);
				}
			}
			qenable(rq);
			return (0);
#endif
		}
	}
	else {
		if (mp) {
			freemsg(mp);
		}
	}
	return (1);
}

#ifdef FLOW_CONTROL

/**************************   myrirsrv()   ************************/
static
int
myrirsrv(queue_t * rq)
{
	mblk_t *mp = NULL;
	struct myristr *slp;
	struct myri *myrip;
	queue_t *qptr;
	int counter = 0;

	CMN_ERR(3) (CE_CONT, "myriRSRV(0x%x)\n", rq);

	rw_enter(&myristruplock, RW_READER);

	slp = (struct myristr *) rq->q_ptr;
	if (!slp) {
		goto rsrv_cleanup;
	}
	myrip = slp->sl_myrip;
	if (!myrip) {
		goto rsrv_cleanup;
	}

	/*
	 * messages that are queued have destination queue at the front
	 */
	while ((mp = getq(rq))) {

		qptr = *((queue_t **) mp->b_rptr);
		if (!qptr->q_ptr) {
			goto rsrv_cleanup;
		}

		mp->b_rptr += sizeof(queue_t *);

		if (!do_putnext(qptr, mp, FALSE)) {
			/* message was queued again */
			CMN_ERR(0) (CE_CONT, "myriRSRV queued again \n");
			CMN_ERR(0) (CE_CONT, "\t q = 0x%x  msg = 0x%x q_siz=%d qn_siz=%d, cnt=%d\n",
			 qptr, mp, qsize(rq), qsize(rq->q_next), ++counter);

			rw_exit(&myristruplock);
			return (0);
		}
		else {
			CMN_ERR(0) (CE_CONT, "myriRSRV clr(%d) msg q = 0x%x q_siz=%d qn_siz=%d\n",
			     qptr, qsize(rq), qsize(rq->q_next), ++counter);
		}
	}

	rw_exit(&myristruplock);

	return (0);

rsrv_cleanup:
	CMN_ERR(0) (CE_CONT, "myriRSRV flush msg queue= 0x%x & disable\n", rq);

	if (mp) {
		freemsg(mp);
	}
	flushq(rq, FLUSHALL);
	noenable(rq);

	rw_exit(&myristruplock);
	return (0);
}

#endif				/* FLOW_CONTROL */

/*
 * Prefix msg with a DL_UNITDATA_IND mblk and return the new msg.
 */
mblk_t *
myriaddudind(struct myri * myrip, mblk_t * mp,
	     struct medium_addr * shostp, struct medium_addr * dhostp,
	     int type, ulong isgroupaddr)
{
	dl_unitdata_ind_t *dludindp;
	struct myridladdr *dlap;
	mblk_t *nmp;
	int size;
#define TMP_OFFSET	(2 * sizeof(ulong))

	CMN_ERR(3) (CE_CONT, "myriaddudind called\n");

	/* strip off the Ethernet header */
	adjmsg(mp, sizeof(struct medium_header));

	/*
	 * Allocate an M_PROTO mblk for the DL_UNITDATA_IND.
	 */
	size = sizeof(dl_unitdata_ind_t) + TMP_OFFSET + 2 * DEVICE_ADDRL;
	nmp = allocb(MYRIHEADROOM + size, BPRI_LO);
	if (nmp == NULL) {
		myrip->myri_ierrors++;
		CMN_ERR(0) (CE_CONT, "myriaddudind: allocb failed");
		freemsg(mp);
		return (NULL);
	}
	DB_TYPE(nmp) = M_PROTO;
	nmp->b_wptr = nmp->b_datap->db_lim;
	nmp->b_rptr = nmp->b_wptr - size;

	/*
	 * Construct a DL_UNITDATA_IND primitive.
	 */
	dludindp = (dl_unitdata_ind_t *) nmp->b_rptr;
	dludindp->dl_primitive = DL_UNITDATA_IND;
	dludindp->dl_dest_addr_length = DEVICE_ADDRL;
	dludindp->dl_dest_addr_offset = sizeof(dl_unitdata_ind_t) + TMP_OFFSET;
	dludindp->dl_src_addr_length = DEVICE_ADDRL;
	dludindp->dl_src_addr_offset = sizeof(dl_unitdata_ind_t) + TMP_OFFSET +
		DEVICE_ADDRL;
	dludindp->dl_group_address = isgroupaddr;

#ifdef DELETE
	*(ulong *) (nmp->b_rptr + sizeof(dl_unitdata_ind_t)) = 0xAAAAAAAA;
	*(ulong *) (nmp->b_rptr + sizeof(dl_unitdata_ind_t) + 4) = 0xBBBBBBBB;
#endif				/* DELETE */

	dlap = (struct myridladdr *) (nmp->b_rptr +
				    sizeof(dl_unitdata_ind_t) + TMP_OFFSET);
	bcopy_addr((caddr_t) dhostp, (caddr_t) & dlap->dl_phys,
		   sizeof(struct medium_addr));
	dlap->dl_sap = (u_short) type;

	dlap = (struct myridladdr *) (nmp->b_rptr + sizeof(dl_unitdata_ind_t)
				      + TMP_OFFSET + DEVICE_ADDRL);
	bcopy_addr((caddr_t) shostp, (caddr_t) & dlap->dl_phys,
		   sizeof(struct medium_addr));
	dlap->dl_sap = (u_short) type;

	/*
	 * Link the M_PROTO and M_DATA together.
	 */
	nmp->b_cont = mp;
	return (nmp);
}

/*
 * Return TRUE if the given multicast address is one
 * of those that this particular Stream is interested in.
 */
INLINE
int
myrimcmatch(struct myristr * slp, struct medium_addr * addrp)
{
	struct medium_addr *mctab;
	int mccount;
	int i;

	CMN_ERR(3) (CE_CONT, "myrimcmatch called\n");

	/*
	 * XXX Return FALSE if not a multicast address.
	 */

	if (!(addrp->medaddr[0] & 0x1)) {
		return (FALSE);
	}

	/*
	 * Check if all multicasts have been enable for this Stream
	 */
	if (slp->sl_flags & SLALLMULTI) {
		return (1);
	}

	/*
	 * Return FALSE if no multicast addresses enable for this Stream.
	 */
	if (slp->sl_mccount == 0) {
		return (0);
	}

	/*
	 * Otherwise, find it in the table.
	 */

	mccount = slp->sl_mccount;
	mctab = slp->sl_mctab;

	for (i = 0; i < mccount; i++)
		if (!bcmp_addr((caddr_t) addrp, (caddr_t) & mctab[i],
			       sizeof(struct medium_addr)))
			return (1);

	return (0);
}

/*
 * XXX Initialize chip and driver.
 * Return 0 on success, nonzero on error.
 */
static int
myriinit(struct myri * myrip)
{

	CMN_ERR(3) (CE_CONT, "myriinit called\n");

	rw_enter(&myristruplock, RW_WRITER);

	myrip->myri_flags = 0;
	myrip->myri_wantw = 0;

#ifdef LATER
	myri_mutex_enter(myrip);

	if (!myri_reset_lanai(myrip)) {
		CMN_ERR(0) (CE_CONT, "myriinit: Couldn't reset the LANai\n");
		myrip->myri_flags &= (!MYRIRUNNING);
		rw_exit(&myristruplock);
		myri_mutex_exit(myrip);
		return (!(myrip->myri_flags & MYRIRUNNING));
	}
	myri_init_lanai(myrip);

	myri_mutex_exit(myrip);
#endif				/* LATER */

	myrip->myri_flags |= MYRIRUNNING;

	myriwenable(myrip);

/* done: */
	rw_exit(&myristruplock);
	return (!(myrip->myri_flags & MYRIRUNNING));
}

/*
 * XXX Un-initialize (STOP) DEVICE
 */
static void
myriuninit(struct myri * myrip)
{
	CMN_ERR(3) (CE_CONT, "myriUNinit called\n");

	/*
	 * XXX Allow time  for pending xmit's to complete.
	 */

	/*
	 * Grab mutex's
	 */

	myri_mutex_enter(myrip);

	myrip->myri_flags &= ~MYRIRUNNING;

	/*
	 * XXX Stop the chip.
	 */

	/* turn interrupts off and hold the lanai in reset */

	myri_stop_lanai(myrip);

	/*
	 * Release mutex's
	 */

	myri_mutex_exit(myrip);

	return;
}

/*ARGSUSED*/
static void
myrierror(dev_info_t * dip, const char *fmt,...)
{

	char name[16];
	char buf[256];
	va_list ap;

	if (dip) {
		(void) sprintf(name, "%s%d", ddi_get_name(dip),
			       ddi_get_instance(dip));
	}
	else {
		(void) sprintf(name, "myri");
	}

	va_start(ap, fmt);
	(void) vsprintf(buf, fmt, ap);
	va_end(ap);

	CMN_ERR(0) (CE_CONT, "%s:\t%s", name, buf);

}



/*
 *  Some STREAMS routines.
 *
 */


static void
pserror(queue_t * wq, mblk_t * mp, int error)
{
	if ((mp = (mblk_t *) psexchange(wq, mp, 1, M_ERROR, -1)) == NULL)
		return;

	*mp->b_rptr = (unsigned char) error;
	qreply(wq, mp);
}

/*
 * Convert an M_IOCTL into an M_IOCACK.
 * Assumption:  mp points to an M_IOCTL msg.
 */
static void
psiocack(queue_t * wq, mblk_t * mp, int count, int error)
{
	struct iocblk *iocp;

	mp->b_datap->db_type = M_IOCACK;
	iocp = (struct iocblk *) mp->b_rptr;
	iocp->ioc_count = count;
	iocp->ioc_error = error;
	qreply(wq, mp);
}

/*
 * Convert an M_IOCTL into an M_IOCNAK.
 * Assumption:  mp points to an M_IOCTL msg.
 */
static void
psiocnak(queue_t * wq, mblk_t * mp, int count, int error)
{
	struct iocblk *iocp;

	mp->b_datap->db_type = M_IOCNAK;
	iocp = (struct iocblk *) mp->b_rptr;
	iocp->ioc_count = count;
	iocp->ioc_error = error;
	qreply(wq, mp);
}

/*
 * Exchange one msg for another.  Free old msg and allocate
 * a new one if either (1) mp is NULL, (2), requested size
 * is larger than current size, or (3) reference count of
 * the current msg is greater than one.
 * Set db_type and b_rptr/b_wptr appropriately.
 * Set the first longword of the msg to 'primtype' if
 * 'primtype' is not -1.
 *
 * On allocb() failure, return NULL after sending an
 * M_ERROR msg w/ENOSR error upstream.
 */
static mblk_t *
psexchange(queue_t * wq, mblk_t * mp, int size,
	   int type, long primtype)
{
	if ((mp == NULL) || (MBLKSIZE(mp) < size) || (DB_REF(mp) > 1)) {
		freemsg((mp));
		if ((mp = allocb(size, BPRI_LO)) == NULL) {
			if ((mp = allocb(1, BPRI_HI)))
				pserror(wq, mp, ENOSR);
			return (NULL);
		}
	}
	mp->b_datap->db_type = type;
	mp->b_rptr = mp->b_datap->db_base;
	mp->b_wptr = mp->b_rptr + size;
	if (primtype >= 0)
		*(long *) mp->b_rptr = primtype;
	return (mp);
}


/*
 *  Common DLPI routines.
 */


static void
psdlbindack(queue_t * wq, mblk_t * mp, u_long sap, caddr_t addrp,
	    int addrlen, int maxconind, u_long xidtest)
{
	union DL_primitives *dlp;
	int size;

	size = sizeof(dl_bind_ack_t) + addrlen;
	if ((mp = psexchange(wq, mp, size, M_PCPROTO, DL_BIND_ACK))
			== NULL)
		return;

	dlp = (union DL_primitives *) mp->b_rptr;
	dlp->bind_ack.dl_sap = sap;
	dlp->bind_ack.dl_addr_length = addrlen;
	dlp->bind_ack.dl_addr_offset = sizeof(dl_bind_ack_t);
	dlp->bind_ack.dl_max_conind = maxconind;
	dlp->bind_ack.dl_xidtest_flg = xidtest;
	bcopy((caddr_t) addrp,
	      (caddr_t) (mp->b_rptr + sizeof(dl_bind_ack_t)),
	      addrlen);

	qreply(wq, mp);
}

static void
psdlokack(queue_t * wq, mblk_t * mp, u_long correct_primitive)
{
	union DL_primitives *dlp;

	if ((mp = psexchange(wq, mp, sizeof(dl_ok_ack_t), M_PCPROTO,
			     DL_OK_ACK)) == NULL)
		return;
	dlp = (union DL_primitives *) mp->b_rptr;
	dlp->ok_ack.dl_correct_primitive = correct_primitive;
	qreply(wq, mp);
}

static void
psdlerrorack(queue_t * wq, mblk_t * mp, u_long error_primitive,
	     u_long errno, u_long unix_errno)
{
	register union DL_primitives *dlp;

	if ((mp = psexchange(wq, mp, sizeof(dl_error_ack_t), M_PCPROTO,
			     DL_ERROR_ACK)) == NULL)
		return;
	dlp = (union DL_primitives *) mp->b_rptr;
	dlp->error_ack.dl_error_primitive = error_primitive;
	dlp->error_ack.dl_errno = errno;
	dlp->error_ack.dl_unix_errno = unix_errno;
	qreply(wq, mp);
}

static void
psdluderrorind(queue_t * wq, mblk_t * mp, u_char * addrp,
	       u_long addrlen, u_long errno, u_long unix_errno)
{
	union DL_primitives *dlp;
	char buf[DLADDRL];
	int size;

	if (addrlen > DLADDRL)
		addrlen = DLADDRL;

	bcopy((caddr_t) addrp, (caddr_t) buf, addrlen);

	size = sizeof(dl_uderror_ind_t) + addrlen;

	if ((mp = psexchange(wq, mp, size, M_PCPROTO, DL_UDERROR_IND)) == NULL)
		return;

	dlp = (union DL_primitives *) mp->b_rptr;
	dlp->uderror_ind.dl_dest_addr_length = addrlen;
	dlp->uderror_ind.dl_dest_addr_offset = sizeof(dl_uderror_ind_t);
	dlp->uderror_ind.dl_unix_errno = unix_errno;
	dlp->uderror_ind.dl_errno = errno;
	bcopy((caddr_t) buf,
	      (caddr_t) (mp->b_rptr + sizeof(dl_uderror_ind_t)),
	      addrlen);
	qreply(wq, mp);
}

static void
psdlphysaddrack(queue_t * wq, mblk_t * mp, caddr_t addrp, int len)
{
	union DL_primitives *dlp;
	int size;

	size = sizeof(dl_phys_addr_ack_t) + len;
	if ((mp = psexchange(wq, mp, size, M_PCPROTO, DL_PHYS_ADDR_ACK)) ==
			NULL)
		return;
	dlp = (union DL_primitives *) mp->b_rptr;
	dlp->physaddr_ack.dl_addr_length = len;
	dlp->physaddr_ack.dl_addr_offset = sizeof(dl_phys_addr_ack_t);
	bcopy(addrp, (caddr_t) (mp->b_rptr + sizeof(dl_phys_addr_ack_t)), len);
	qreply(wq, mp);
}



/**************   myrifastpath()  *******************/
INLINE static int
myrifastpath(queue_t * wq, mblk_t * mp)
{
/* this routine is called if
 * case M_PROTO:
 * case M_PCPROTO:
 */

	union DL_primitives *dlp;
	struct myristr *slp;
	u_long prim;
	int save_len;


	slp = (struct myristr *) wq->q_ptr;
	dlp = (union DL_primitives *) mp->b_rptr;
	prim = dlp->dl_primitive;

	if (prim == DL_UNITDATA_REQ) {

		register struct myri *myrip;
		register dl_unitdata_req_t *dludp;
		mblk_t *nmp;
		struct myridladdr *dlap;
		struct medium_header *headerp;
		int off, len, rv;

		rv = mutex_tryenter(&slp->sl_lock);
		if (!rv) {
			CMN_ERR(3) (CE_CONT, "myriFASTPATH FAILED mutex already held\n");
			return (0);
		}

		myrip = slp->sl_myrip;

		dludp = (dl_unitdata_req_t *) mp->b_rptr;

		off = dludp->dl_dest_addr_offset;
		len = dludp->dl_dest_addr_length;

		/*
		 * Validate destination address format.
		 */
		if (!MBLKIN(mp, off, len) || (len != DEVICE_ADDRL)) {
			mutex_exit(&slp->sl_lock);
			CMN_ERR(3) (CE_CONT, "myriFASTPATH FAILED bad addr format\n");
			return (0);
		}

		/*
		 * Error if no M_DATA follows.
		 */
		nmp = mp->b_cont;
		if (nmp == NULL) {
			mutex_exit(&slp->sl_lock);
			CMN_ERR(3) (CE_CONT, "myriFASTPATH FAILED no m_data follows\n");
			return (0);
		}

		dlap = (struct myridladdr *) (mp->b_rptr + off);

		/*
		 * Create medium header by either prepending it onto the next
		 * mblk if possible, or reusing the M_PROTO block if not.
		 */
		if ((DB_REF(nmp) == 1) &&
			  (MBLKHEAD(nmp) >= sizeof(struct medium_header)) &&
				(((ulong) nmp->b_rptr & 0x1) == 0)) {
			nmp->b_rptr -= sizeof(struct medium_header);
			headerp = (struct medium_header *) nmp->b_rptr;
			bcopy_addr((caddr_t) & dlap->dl_phys, (caddr_t) & headerp->med_dhost,
				   sizeof(struct medium_addr));
			bcopy_addr((caddr_t) & myrip->myri_ouraddr,
				   (caddr_t) & headerp->med_shost,
				   sizeof(struct medium_addr));
			headerp->med_type = dlap->dl_sap;
			freeb(mp);
			mp = nmp;
		}
		else {
			DB_TYPE(mp) = M_DATA;
			headerp = (struct medium_header *) mp->b_rptr;
			mp->b_wptr = mp->b_rptr + sizeof(struct medium_header);
			bcopy_addr((caddr_t) & dlap->dl_phys, (caddr_t) & headerp->med_dhost,
				   sizeof(struct medium_addr));
			bcopy_addr((caddr_t) & myrip->myri_ouraddr,
				   (caddr_t) & headerp->med_shost,
				   sizeof(struct medium_addr));
			headerp->med_type = dlap->dl_sap;
		}

		/*
		 * Transmit it.
		 */

		save_len = msgdsize(mp);

		rv = myri_tolanai(wq, mp, myrip);
		GET_TIME(time_stop[6]);

		mutex_exit(&slp->sl_lock);

#ifdef RECURSIVE_PANIC
		if (rv) {
			myrip->myri_regsp->int_off = 1;
			myri_handle_lanai_intr(myrip, RECV_ALL_MSGS);
			myrip->myri_regsp->int_on = 1;
		}
#endif				/* RECURSIVE_PANIC */

		CMN_ERR(3) (CE_CONT, "myriFASTPATH suceeded\n");


#ifdef DO_TIMING
		SUB_TIME(time_stop[2], time_start[0]);
		SUB_TIME(time_stop[3], time_start[0]);
		SUB_TIME(time_stop[4], time_start[0]);
		SUB_TIME(time_stop[5], time_start[0]);
		SUB_TIME(time_stop[6], time_start[0]);

		SUB_TIME(time_stop[8], time_stop[7]);
		SUB_TIME(time_stop[15], time_stop[14]);

	CMN_ERR(0) (CE_CONT, "Fast path: %d  %d  %d  %d  %d  (cpy=%d) (sync=%d) (len=%d)\n",
			    time_stop[2].tv_usec,
			    time_stop[3].tv_usec,
			    time_stop[4].tv_usec,
			    time_stop[5].tv_usec,
			    time_stop[6].tv_usec,
			    time_stop[8].tv_usec,
			    (send_immediate) ? 0 : time_stop[15].tv_usec,
			    save_len);
#endif				/* DO_TIMING */

		return (1);
	}
	else {
		/* not fastpath */
		CMN_ERR(3) (CE_CONT, "myriFASTPATH FAILED not DL_UNITDATA_REQ\n");
		return (0);
	}
}



/* end of dlpi.c */
