
#ifdef NOT_COMPILED

#ifdef NOT_USED
/* The structure of the 48-bit UID might in the future be as follows:
   byte[0] = CPU_TYPE [see below]
   byte[1] = machine_id[0];     [purposely misaligned]
   byte[2] = machine_id[1];
   byte[3] = machine_id[2];
   byte[4] = machine_id[3];
   byte[5] = instance (board_id)

   The reason for the misalignment of the machine_id is so that
   the LSB of the address indicates different boards in the
   same machine. That was, sorting etc. will be able to easily
   notice that two boards are in the same machine and can perhaps
   do something to utilize the two as one seamless interface?

*/

#ifdef sparc
#define MYRI_CPU_TYPE   0
#endif
#ifdef hp
#define MYRI_CPU_TYPE   1
#endif
#ifdef sgi
#define MYRI_CPU_TYPE   2
#endif

#endif				/* NOT_USED */
{
	/* This is being saved for possible future use */

	/*
	 * Get the local medium address and store in myrip->myri_ouraddr. For
	 * a sparc we take the machine id and prepend a code for sparc and a
	 * code for the instance.
	 * 
	 * Since we can use ifconfig myri0 ether 0:0:0:0:0:x to set the device
	 * address, this is all useless, but can be used in the future.
	 */

	struct promid_t {
		u_char format;
		u_char type;
		u_char etheraddr[6];
		u_int date;
		u_char serial[3];
		u_char cksum;
		u_char padding[64];
	}   promid;
	int length = sizeof(promid);
	int rv;

	bzero((caddr_t) & myrip->myri_ouraddr, sizeof(struct medium_addr));

	rv = ddi_getlongprop_buf(DDI_DEV_T_ANY, dip, DDI_PROP_CANSLEEP,
				 "idprom", (caddr_t) & promid, &length);

	if (rv == DDI_PROP_SUCCESS) {

		myrip->myri_ouraddr.medaddr[0] = MYRI_CPU_TYPE;
		myrip->myri_ouraddr.medaddr[1] = promid.type;
		myrip->myri_ouraddr.medaddr[5] = (u_char) (instance & 0xFF);

		bcopy((caddr_t) & promid.serial[0],
		      (caddr_t) & myrip->myri_ouraddr.medaddr[2], 3);

/*
            CMN_ERR(0)(CE_CONT,"     serial num = %x %x %x %x\n",
                   promid.type,
                   promid.serial[0],
                   promid.serial[1],
                   promid.serial[2]);

            CMN_ERR(0)(CE_CONT,"     etheraddr = %x:%x:%x:%x:%x:%x\n",
                   promid.etheraddr[0], promid.etheraddr[1],
                   promid.etheraddr[2], promid.etheraddr[3],
                   promid.etheraddr[4], promid.etheraddr[5]);
*/
	}
	else {
		CMN_ERR(0) (CE_CONT, "   ddi_getlongprop_buf failed 1st time: ");
		switch (rv) {
			case DDI_PROP_SUCCESS:
				CMN_ERR(0) (CE_CONT, "DDI_PROP_SUCCESS\n");
				break;
			case DDI_PROP_NOT_FOUND:
				CMN_ERR(0) (CE_CONT, "DDI_PROP_NOT_FOUND\n");
				break;
			case DDI_PROP_BUF_TOO_SMALL:
				CMN_ERR(0) (CE_CONT, "DDI_PROP_BUF_TOO_SMALL\n");
				break;
			case DDI_PROP_UNDEFINED:
				CMN_ERR(0) (CE_CONT, "DDI_PROP_UNDEFINED\n");
				break;
			case DDI_PROP_NO_MEMORY:
				CMN_ERR(0) (CE_CONT, "DDI_PROP_NO_MEMORY\n");
				break;
			default:
				CMN_ERR(0) (CE_CONT, "default rv = %d\n", rv);
		}		/* switch */
	}			/* else */

/*
        CMN_ERR(0)(CE_CONT,"     MYRI_ID = %x:%x:%x:%x:%x:%x\n",
               myrip->myri_ouraddr.medaddr[0],
               myrip->myri_ouraddr.medaddr[1],
               myrip->myri_ouraddr.medaddr[2],
               myrip->myri_ouraddr.medaddr[3],
               myrip->myri_ouraddr.medaddr[4],
               myrip->myri_ouraddr.medaddr[5]);
*/
}

#endif				/* NOT_COMPILED */
