/*									tab:2
 *
 * am_glib.h - Active Message/GLUnix interface header file
 *
 * "Copyright (c) 1994 by Lok Tin Liu and The Regents of the University 
 * of California.  All rights reserved."
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author: 			Lok Tin Liu
 * Version:			7
 * Creation Date:	Fri Sep 16 10:59:39 1994
 * Filename:		am_glib.h
 * History:
 */

typedef void *Am_Fast_Addr;

/* Get the fast address of the caller. Return 0 if successful; -1 if error.
 * Caller need to pre-allocate storage and give us the pointer in fast_addr.
 */
extern int Am_GetMyFastAddr(Am_Fast_Addr fast_addr);

/* Return the size of a fast address */
extern int Am_GetFastAddrSize();

/* Return a pointer to a string containing a meaning name of the fast address.
 * Note that the string is stored in static storage.
 */
extern char *Am_GetFastAddrStr(Am_Fast_Addr fast_addr);



