#ifndef __QUEUE_H
#define __QUEUE_H

#include <sys/types.h>
#include <elan/elan.h>
#include <ew/ew.h>
#include <elan/event.h>

#define QUEUE_ENTRY_SIZE 32 /*to fit in one writeblock*/
#define QUEUE_ENTRY_WORDS 8 /*one for the flag*/
#define STACK_SIZE 8192
#define DEFAULT_QUEUE_SIZE 512

/*Order of values in each queue element:*/
#define QFLAG 7
#define QREMOTE_NODE 7
#define QARG1 1
#define QARG2 2
#define QARG3 3
#define QARG4 4
#define QARG5 5
#define QARG6 6
#define QTYPE 0
#define QFLAG2 0


#define DEBUG 0



typedef struct {
    /*Queue specific values on the remote node*/
    int *queue_base_ptr;   /*global ptr to the queue base address*/
    int queue_size;        /*size of the remote queue in N byte packets*/

    /*Interface between sparc and elan on the sending side*/
    volatile int *message_ptr;
    int list_head;
} queue_t;

void Queue_Thread(queue_t *queue_ptr);
queue_t *CreateQueue();
int Push(queue_t *queue, int node, ELAN_DMA *dma, int arg0,int arg1,
	 int arg2, int arg3, int arg4, int arg5, int arg6, int blocking);
int Pop(queue_t *queue,int *arg0, int *arg1, int *arg2, int *arg3,
	int *arg4 ,int *arg5, int *arg6, int blocking);
#endif __QUEUE_H
