/*									tab:4
 *
 * timer.sc - Timer library routines
 *
 * "Copyright (c) 1993 by Steve Lumetta and The Regents of the University 
 * of California.  All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author: 			Steve Lumetta
 * Version:			2
 * Creation Date:	Wed Jan 20 12:44:56 1993
 * Filename:		timer.sc
 * History:
 *	ssl	2	Fri Nov 19 00:56:55 1993
 *		Modified for Paragon.
 *	SL	1	Wed Jan 20 12:47:35 1993
 *		Wrote get_seconds using CMNA timer number 0
 */

#include "meiam.h"
#include <sys/types.h>
#include <elan/elan.h>
#include <ew/ew.h>
#include <elan/event.h>


double get_seconds()
{
  ELAN_TIMEVAL tv;

     elan_clock(ew_ctx,&tv);
     return (double)((double)tv.tv_sec + tv.tv_nsec/1000000000.0); 
}


