//									
//
// pam_asm.s - PAM user library
//
// "Copyright (c) 1994 by Lok Tin Liu and The Regents of the University 
// of California.  All rights reserved."
//
// Permission to use, copy, modify, and distribute this software and its
// documentation for any purpose, without fee, and without written agreement is
// hereby granted, provided that the above copyright notice and the following
// two paragraphs appear in all copies of this software.
// 
// IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
// DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
// OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
// CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// 
// THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
// AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
// ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
// PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
//
// Author: 			Lok Tin Liu
// Version:			421
// Creation Date:	Tue Jun  7 11:18:04 1994
// Filename:		pam_asm.s
// Description:
//    This file contains the PAM user library developed by LTL at UCB.
//    It contains no Intel proprietary information except for the
//    way the post page is accessed.
// History:
//	LTL	420	Thu Jul  6 21:07:10 1995
//		PAM Release 1.6
//


	
	.file "pam_asm.s"
	
	PAM_REQUEST_5I = 1
	PAM_REPLY_5I = 4	
	PAM_SEND_5I = 11
	POST_PAM_ENQ = 43
	POST_PAM_STORE_ASYNC = 45
	POST_PAM_GET = 46
	POST_PAM_REPLY_GET = 47	
	RPM_TIME = 0xffff2040       // RPM global timer lower 32 bits
	EPOCH_TIME = 0xffff4630     // EPOCH timer


//	
// am_request_5()
//
// Inputs:	
//   r16	dest node
//   r17	handler
//   r18-r22	arg0-arg4
//							
.globl _am_request_5
_am_request_5:
	
	addu -48,sp,sp		// need to align at 16-byte boundary
	st.l fp,0(sp)		// store the caller's frame pointer
 	addu 0,sp,fp		// update stack pointer
	st.l r1,4(fp)		// store the return adddress in frame
	shl 2,r16,r28
	orh ha%_pam_outstanding,r0,r31
	ld.l l%_pam_outstanding(r31),r30
	br 3f
	addu r30,r28,r24	// get pointer to pam_outstanding[dest_node]
				// count = 9
1:
	st.l r16, 8(fp)		// move args to frame so that am_poll()
	st.l r17, 12(fp)	// won't ruin it
	st.l r18, 16(fp)	// should do this only once since we may
	st.l r19, 20(fp)	// be polling multiple times
	st.l r20, 24(fp)
	st.l r21, 28(fp)
	st.l r22, 32(fp)
2:	call _am_poll		// poll if used up credit
	st.l r24, 36(fp)	// save temporary value also

	ld.l 36(fp), r24	// restore args and temp var
	orh ha%_pam_max_outstanding,r0,r31
	ld.l 0(r24),r25		// load # of outstanding messages
	ld.l l%_pam_max_outstanding(r31),r30
	orh ha%_pam_mynode,r0,r31	// assemble tag as arg3
	subs r25,r30,r0
	bnc 2b			// if used up credit, keep polling

	ld.l 8(fp), r16
	ld.l 12(fp), r17
	ld.l 16(fp), r18
	ld.l 20(fp), r19
	ld.l 24(fp), r20
	ld.l 28(fp), r21
	br 4f	
	ld.l 32(fp), r22


3:	orh ha%_pam_max_outstanding,r0,r31
	ld.l 0(r24),r25			// load # of outstanding messages
	ld.l l%_pam_max_outstanding(r31),r30
	orh ha%_pam_mynode,r0,r31	// assemble tag as arg3
	subs r25,r30,r0
	bnc 1b			// if used up credit, keep polling
4:	ld.l l%_pam_mynode(r31),r23
	shl 16,r23,r23		// arg3 -- message tag
	or PAM_REQUEST_5I,r23,r23
	or POST_PAM_ENQ, r0, r31	

	// this is an modified version of mcmsg_post10
	orh	ha%_mcmsg_post_page_in, r0, r29	// r29 = ptr to in index
	ld.l	l%_mcmsg_post_page_in(r29), r28	// r28 = in index
	orh	ha%_mcmsg_post_page, r0, r30	//
	ld.l	l%_mcmsg_post_page(r30), r30	// r30 =  pointer to post page
	ixfr	r31, f16			// Move method to FP
	and	31, r28, r0			// Check for half page bdry
	bc	6f				// Branch if half page bdry
5:	ixfr	r21, f24			// Move arg 8 to FP
	ixfr	r22, f25			// Move arg 9 to FP
	shl	6, r28, r31			// Create entry pointer
	addu	r30, r31, r31			//
	addu	1, r28, r28			// Increment index
	st.l	r28, l%_mcmsg_post_page_in(r29)	// Store new index
	addu 1,r25,r25				// increment *ip
	st.l r25,0(r24)
		
	fst.d	f24, 32(r31)			// Post arg 8-9

	ixfr	r17, f20			// Move arg 4 to FP
	ixfr	r18, f21			// Move arg 5 to FP
	ixfr	r19, f22			// Move arg 6 to FP
	ixfr	r20, f23			// Move arg 7 to FP
	fst.q	f20, 16(r31)			// Post arg 4-7
			
	ixfr	r16, f17			// Move arg 1 to FP
						// arg 2: don't care;  for
						// alignment
	ixfr	r23, f19			// Move arg 3 to FP

	fst.q	f16, 0(r31)			// Post request


	
	adds 48,fp,r31		// restore frame
	ld.l 4(fp),r1	
	ld.l 0(fp),fp
	mov 	r0,r16		// return 0
	bri r1
	mov r31,sp

	
6:	and	63, r28, r28			// Fix index for end of page
//
//	At this point, r28 is either	 0 (was 64) or	32.
//	We want to spin on index	31 or		63, respectively.
//	That will ensure that entries 0-31 or        32-63 are open,
//	so we don't have to check them individually.
//
	shl	6, r28, r31			//
	addu	r30, r31, r31			// r31 = entry pointer
7:	ld.l	1984(r31), r31			// r31 = method
	or	r31, r0, r0			// Test for zero
	bc	5b				// Branch when zero
	shl	6, r28, r31			// (Its OK to waste time here)
	br	7b				// Loop back
	addu	r30, r31, r31			// r31 = entry pointer

//	
// am_send_5()
//
// Inputs:	
//   r16	dest node
//   r17	handler
//   r18-r22	arg0-arg4
//							
.globl _am_send_5
_am_send_5:
	orh ha%_pam_mynode,r0,r31	// assemble tag as arg3	
	ld.l l%_pam_mynode(r31),r23
	or POST_PAM_ENQ, r0, r31		
	shl 16,r23,r23		// arg3 -- message tag
	or PAM_SEND_5I,r23,r23


	// this is an modified version of mcmsg_post10
	orh	ha%_mcmsg_post_page_in, r0, r29	// r29 = ptr to in index
	ld.l	l%_mcmsg_post_page_in(r29), r28	// r28 = in index
	orh	ha%_mcmsg_post_page, r0, r30	//
	ld.l	l%_mcmsg_post_page(r30), r30	// r30 =  pointer to post page
	ixfr	r31, f16			// Move method to FP
	and	31, r28, r0			// Check for half page bdry
	bc	4f				// Branch if half page bdry
3:	
	ixfr	r21, f24			// Move arg 8 to FP
	ixfr	r22, f25			// Move arg 9 to FP
	shl	6, r28, r31			// Create entry pointer
	addu	r30, r31, r31			//
	addu	1, r28, r28			// Increment index
	st.l	r28, l%_mcmsg_post_page_in(r29)	// Store new index	
	fst.d	f24, 32(r31)			// Post arg 8-9
	ixfr	r17, f20			// Move arg 4 to FP
	ixfr	r18, f21			// Move arg 5 to FP
	ixfr	r19, f22			// Move arg 6 to FP
	ixfr	r20, f23			// Move arg 7 to FP
	fst.q	f20, 16(r31)			// Post arg 4-7
			
	ixfr	r16, f17			// Move arg 1 to FP
						// arg 2: don't care;  for
						// alignment
	ixfr	r23, f19			// Move arg 3 to FP
	
	fst.q	f16, 0(r31)			// Post request

	bri r1
	mov 	r0,r16		// return 0	


	
4:	and	63, r28, r28			// Fix index for end of page
//
//	At this point, r28 is either	 0 (was 64) or	32.
//	We want to spin on index	31 or		63, respectively.
//	That will ensure that entries 0-31 or        32-63 are open,
//	so we don't have to check them individually.
//
	shl	6, r28, r31			//
	addu	r30, r31, r31			// r31 = entry pointer
5:	ld.l	1984(r31), r31			// r31 = method
	or	r31, r0, r0			// Test for zero
	bc	3b				// Branch when zero
	shl	6, r28, r31			// (Its OK to waste time here)
	br	5b				// Loop back
	addu	r30, r31, r31			// r31 = entry pointer


//	
// am_reply_5()
//
// Inputs:	
//   r16	dest node
//   r17	handler
//   r18-r22	arg0-arg4
//							
.globl _am_reply_5
_am_reply_5:
	orh ha%_pam_mynode,r0,r31	// assemble tag as arg3	
	ld.l l%_pam_mynode(r31),r23
	or POST_PAM_ENQ, r0, r31		
	shl 16,r23,r23		// arg3 -- message tag
	or PAM_REPLY_5I,r23,r23

	// this is an modified version of mcmsg_post10
	orh	ha%_mcmsg_post_page_in, r0, r29	// r29 = ptr to in index
	ld.l	l%_mcmsg_post_page_in(r29), r28	// r28 = in index
	orh	ha%_mcmsg_post_page, r0, r30	//
	ld.l	l%_mcmsg_post_page(r30), r30	// r30 =  pointer to post page
	ixfr	r31, f16			// Move method to FP
	and	31, r28, r0			// Check for half page bdry
	bc	4f				// Branch if half page bdry
3:	ixfr	r21, f24			// Move arg 8 to FP
	ixfr	r22, f25			// Move arg 9 to FP
	shl	6, r28, r31			// Create entry pointer
	addu	r30, r31, r31			//
	addu	1, r28, r28			// Increment index
	st.l	r28, l%_mcmsg_post_page_in(r29)	// Store new index
	orh ha%_pam_replied,r0,r30
	st.l r23,l%_pam_replied(r30)		// set pam_replied to non-zero
	
	fst.d	f24, 32(r31)			// Post arg 8-9

	ixfr	r17, f20			// Move arg 4 to FP
	ixfr	r18, f21			// Move arg 5 to FP
	ixfr	r19, f22			// Move arg 6 to FP
	ixfr	r20, f23			// Move arg 7 to FP
	fst.q	f20, 16(r31)			// Post arg 4-7
			
	ixfr	r16, f17			// Move arg 1 to FP
						// arg 2: don't care;  for
						// alignment
	ixfr	r23, f19			// Move arg 3 to FP

	fst.q	f16, 0(r31)			// Post request
	bri r1
	mov 	r0,r16		// return 0
	
4:	and	63, r28, r28			// Fix index for end of page
//
//	At this point, r28 is either	 0 (was 64) or	32.
//	We want to spin on index	31 or		63, respectively.
//	That will ensure that entries 0-31 or        32-63 are open,
//	so we don't have to check them individually.
//
	shl	6, r28, r31			//
	addu	r30, r31, r31			// r31 = entry pointer
5:	ld.l	1984(r31), r31			// r31 = method
	or	r31, r0, r0			// Test for zero
	bc	3b				// Branch when zero
	shl	6, r28, r31			// (Its OK to waste time here)
	br	5b				// Loop back
	addu	r30, r31, r31			// r31 = entry pointer



		
// This is a hybrid of am_request and am_send. It checks for credit before
// sending. But, the message is tagged as AM_SEND_5I so that the receiver
// won't generate an empty reply. This is used for speeding up barrier.
.globl _am_send2_5
_am_send2_5:
	
	addu -48,sp,sp		// need to align at 16-byte boundary
	st.l fp,0(sp)		// store the caller's frame pointer
 	addu 0,sp,fp		// update stack pointer
	st.l r1,4(fp)		// store the return adddress in frame
	shl 2,r16,r28
	orh ha%_pam_outstanding,r0,r31
	ld.l l%_pam_outstanding(r31),r30
	br 3f
	addu r30,r28,r24	// get pointer to pam_outstanding[dest_node]
				// count = 9
1:
	st.l r16, 8(fp)		// move args to frame so that am_poll()
	st.l r17, 12(fp)	// won't ruin it
	st.l r18, 16(fp)	// should do this only once since we may
	st.l r19, 20(fp)	// be polling multiple times
	st.l r20, 24(fp)
	st.l r21, 28(fp)
	st.l r22, 32(fp)
2:	call _am_poll		// poll if used up credit
	st.l r24, 36(fp)	// save temporary value also

	ld.l 36(fp), r24	// restore args and temp var
	orh ha%_pam_max_outstanding,r0,r31
	ld.l 0(r24),r25		// load # of outstanding messages
	ld.l l%_pam_max_outstanding(r31),r30
	orh ha%_pam_mynode,r0,r31	// assemble tag as arg3
	subs r25,r30,r0
	bnc 2b			// if used up credit, keep polling

	ld.l 8(fp), r16
	ld.l 12(fp), r17
	ld.l 16(fp), r18
	ld.l 20(fp), r19
	ld.l 24(fp), r20
	ld.l 28(fp), r21
	br 4f	
	ld.l 32(fp), r22


3:	orh ha%_pam_max_outstanding,r0,r31
	ld.l 0(r24),r25			// load # of outstanding messages
	ld.l l%_pam_max_outstanding(r31),r30
	orh ha%_pam_mynode,r0,r31	// assemble tag as arg3
	subs r25,r30,r0
	bnc 1b			// if used up credit, keep polling
4:	ld.l l%_pam_mynode(r31),r23
	shl 16,r23,r23		// arg3 -- message tag
	or PAM_REQUEST_5I,r23,r23
	or POST_PAM_ENQ, r0, r31	

	// this is an modified version of mcmsg_post10
	orh	ha%_mcmsg_post_page_in, r0, r29	// r29 = ptr to in index
	ld.l	l%_mcmsg_post_page_in(r29), r28	// r28 = in index
	orh	ha%_mcmsg_post_page, r0, r30	//
	ld.l	l%_mcmsg_post_page(r30), r30	// r30 =  pointer to post page
	ixfr	r31, f16			// Move method to FP
	and	31, r28, r0			// Check for half page bdry
	bc	6f				// Branch if half page bdry
5:	ixfr	r21, f24			// Move arg 8 to FP
	ixfr	r22, f25			// Move arg 9 to FP
	shl	6, r28, r31			// Create entry pointer
	addu	r30, r31, r31			//
	addu	1, r28, r28			// Increment index
	st.l	r28, l%_mcmsg_post_page_in(r29)	// Store new index
	addu 1,r25,r25		// increment *ip
	st.l r25,0(r24)	
	fst.d	f24, 32(r31)			// Post arg 8-9

	ixfr	r17, f20			// Move arg 4 to FP
	ixfr	r18, f21			// Move arg 5 to FP
	ixfr	r19, f22			// Move arg 6 to FP
	ixfr	r20, f23			// Move arg 7 to FP
	fst.q	f20, 16(r31)			// Post arg 4-7
			
	ixfr	r16, f17			// Move arg 1 to FP
						// arg 2: don't care;  for
						// alignment
	ixfr	r23, f19			// Move arg 3 to FP

	fst.q	f16, 0(r31)			// Post request

	
	adds 48,fp,r31		// restore frame
	ld.l 4(fp),r1	
	ld.l 0(fp),fp
	mov 	r0,r16		// return 0
	bri r1
	mov r31,sp
	.align 8
	nop
	
6:	and	63, r28, r28			// Fix index for end of page
//
//	At this point, r28 is either	 0 (was 64) or	32.
//	We want to spin on index	31 or		63, respectively.
//	That will ensure that entries 0-31 or        32-63 are open,
//	so we don't have to check them individually.
//
	shl	6, r28, r31			//
	addu	r30, r31, r31			// r31 = entry pointer
7:	ld.l	1984(r31), r31			// r31 = method
	or	r31, r0, r0			// Test for zero
	bc	5b				// Branch when zero
	shl	6, r28, r31			// (Its OK to waste time here)
	br	7b				// Loop back
	addu	r30, r31, r31			// r31 = entry pointer

	
//
// Post a request
//
// Entry:
//	r16 - r25	Arguments to be posted (preserved through call)
//	r31		Method number
// Post page characteristics:
//	4096 bytes in page
//	64   bytes per entry
//	64   entries
//	1st long is method number
//	Args start at 2nd long
//
// To post a request the method and arguments are written to an entry,
// method last. To make sure an entry is not already occupied it is necessary
// to test the method to make sure it is zero.
// Entries are always used in order.
// To avoid pulling the cache line for a request into local
// cache every time, this code checks them in batches, half the page at a time.
// The check only occurs when the index crosses from one half of the page to
// the other. The wrap-around check is be done here too.

_pam_post1::
_pam_post2::
_pam_post3::

_pam_post4::
_pam_post5::
_pam_post6::
_pam_post7::

_pam_post8::
_pam_post9::
_pam_post10::
	
	orh	ha%_mcmsg_post_page_in, r0, r29	// r29 = ptr to in index
	ld.l	l%_mcmsg_post_page_in(r29), r28	// r28 = in index
	orh	ha%_mcmsg_post_page, r0, r30	//
	ld.l	l%_mcmsg_post_page(r30), r30	// r30 =  pointer to post page
	ixfr	r31, f16			// Move method to FP
	and	31, r28, r0			// Check for half page bdry
	bc	2f				// Branch if half page bdry
1:
	shl	6, r28, r31			// Create entry pointer
	addu	r30, r31, r31			//
	addu	1, r28, r28			// Increment index
	st.l	r28, l%_mcmsg_post_page_in(r29)	// Store new index
		
	ixfr	r23, f24			// Move arg 8 to FP
	ixfr	r24, f25			// Move arg 9 to FP
	ixfr	r25, f26			// Move arg 10 to FP
	fst.q	f24, 32(r31)			// Post arguments
		
	ixfr	r19, f20			// Move arg 4 to FP
	ixfr	r20, f21			// Move arg 5 to FP
	ixfr	r21, f22			// Move arg 6 to FP
	ixfr	r22, f23			// Move arg 7 to FP
	fst.q	f20, 16(r31)			//
		
	ixfr	r16, f17			// Move arg 1 to FP
	ixfr	r17, f18			// Move arg 2 to FP
	ixfr	r18, f19			// Move arg 3 to FP
	fst.q	f16, 0(r31)			// Post request

	bri	r1				// Return
	mov 	r0,r16	


2:	and	63, r28, r28			// Fix index for end of page
//
//	At this point, r28 is either	 0 (was 64) or	32.
//	We want to spin on index	31 or		63, respectively.
//	That will ensure that entries 0-31 or        32-63 are open,
//	so we don't have to check them individually.
//
	shl	6, r28, r31			//
	addu	r30, r31, r31			// r31 = entry pointer
3:	ld.l	1984(r31), r31			// r31 = method
	or	r31, r0, r0			// Test for zero
	bc	1b				// Branch when zero
	shl	6, r28, r31			// (Its OK to waste time here)
	br	3b				// Loop back
	addu	r30, r31, r31			// r31 = entry pointer

	


//	
// am_store_async()
//
.globl _am_store_async
_am_store_async:	
	
	addu -48,sp,sp		// need to align at 16-byte boundary
	st.l fp,0(sp)		// store the caller's frame pointer
 	addu 0,sp,fp		// update stack pointer
	st.l r1,4(fp)		// store the return adddress in frame
	orh ha%_pam_mynode,r0,r31 // load pam_mynode
	ld.l l%_pam_mynode(r31),r30
	shl 2,r16,r28		// get index into pam_outstanding
	bte r30,r16,11f         // branch if dest = pam_mynode
	orh ha%_pam_outstanding,r0,r31
	ld.l l%_pam_outstanding(r31),r30
	br 3f
	addu r30,r28,r24	// get pointer to pam_outstanding[dest_node]
				// count = 9
1:
	st.l r16, 8(fp)		// move args to frame so that am_poll()
	st.l r17, 12(fp)	// won't ruin it
	st.l r18, 16(fp)	// should do this only once since we may
	st.l r19, 20(fp)	// be polling multiple times
	st.l r20, 24(fp)
	st.l r21, 28(fp)
	st.l r22, 32(fp)
	st.l r23, 36(fp)	
2:	call _am_poll		// poll if used up credit
	st.l r24, 36(fp)	// save temporary value also

	ld.l 36(fp), r24	// restore args and temp var
	orh ha%_pam_max_outstanding,r0,r31
	ld.l 0(r24),r25		// load # of outstanding messages
	ld.l l%_pam_max_outstanding(r31),r30
	orh ha%_pam_mynode,r0,r31	// assemble tag as arg3
	subs r25,r30,r0
	bnc 2b			// if used up credit, keep polling

	ld.l 8(fp), r16
	ld.l 12(fp), r17
	ld.l 16(fp), r18
	ld.l 20(fp), r19
	ld.l 24(fp), r20
	ld.l 28(fp), r21
	ld.l 32(fp), r22
	br 4f	
	ld.l 36(fp), r23


3:	orh ha%_pam_max_outstanding,r0,r31
	ld.l 0(r24),r25			// load # of outstanding messages
	ld.l l%_pam_max_outstanding(r31),r30
	subs r25,r30,r0
	bnc 1b			// if used up credit, keep polling

4:	or POST_PAM_STORE_ASYNC, r0, r31	

	// this is an modified version of mcmsg_post10
	orh	ha%_mcmsg_post_page_in, r0, r29	// r29 = ptr to in index
	ld.l	l%_mcmsg_post_page_in(r29), r28	// r28 = in index
	orh	ha%_mcmsg_post_page, r0, r30	//
	ld.l	l%_mcmsg_post_page(r30), r30	// r30 =  pointer to post page
	ixfr	r31, f16			// Move method to FP
	and	31, r28, r0			// Check for half page bdry
	bc	6f				// Branch if half page bdry
5:	ixfr	r23, f24			// Move arg 8 to FP
	shl	6, r28, r31			// Create entry pointer
	addu	r30, r31, r31			//
	addu	1, r28, r28			// Increment index
	st.l	r28, l%_mcmsg_post_page_in(r29)	// Store new index
	addu 1,r25,r25		// increment *ip
	st.l r25,0(r24)	
	
	fst.l	f24, 32(r31)			// Post arg 8

	ixfr	r19, f20			// Move arg 4 to FP
	ixfr	r20, f21			// Move arg 5 to FP
	ixfr	r21, f22			// Move arg 6 to FP
	ixfr	r22, f23			// Move arg 7 to FP
	fst.q	f20, 16(r31)			// Post arg 4-7
			
	ixfr	r16, f17			// Move arg 1 to FP
	ixfr	r17, f18			// Move arg 2 to FP
	ixfr	r18, f19			// Move arg 3 to FP

	fst.q	f16, 0(r31)			// Post request

10:		
	adds 48,fp,r31		// restore frame
	ld.l 4(fp),r1	
	ld.l 0(fp),fp
	mov 	r0,r16		// return 0
	bri r1
	mov r31,sp
	.align 8
	nop
	
6:	and	63, r28, r28			// Fix index for end of page
//
//	At this point, r28 is either	 0 (was 64) or	32.
//	We want to spin on index	31 or		63, respectively.
//	That will ensure that entries 0-31 or        32-63 are open,
//	so we don't have to check them individually.
//
	shl	6, r28, r31			//
	addu	r30, r31, r31			// r31 = entry pointer
7:	ld.l	1984(r31), r31			// r31 = method
	or	r31, r0, r0			// Test for zero
	bc	5b				// Branch when zero
	shl	6, r28, r31			// (Its OK to waste time here)
	br	7b				// Loop back
	addu	r30, r31, r31			// r31 = entry pointer

11:
	st.l r16, 8(fp)		// move args to frame so that memcpy()
	st.l r17, 12(fp)	// won't ruin it
	st.l r18, 16(fp)	
	st.l r19, 20(fp)	
	st.l r20, 24(fp)
	st.l r21, 28(fp)
	st.l r22, 32(fp)
	st.l r23, 36(fp)		
        mov r18, r16		// move dest_buf to r16
	call _memmove
        mov r19, r18		// move len to r18
	
	ld.l 8(fp), r16		// load dest_node
	ld.l 12(fp), r17	// load src_buf
	ld.l 32(fp), r22	// load endfunc	
	ld.l 20(fp), r18	// load len
	calli r22		// call endfunc
	ld.l 36(fp), r19	// load endfunc_arg1

	ld.l 8(fp), r16		// load dest_node
	ld.l 16(fp), r17	// load dest_buf
	ld.l 24(fp), r20	// load request_handler
	ld.l 20(fp), r18	// load len
        calli r20		// call request_handler
	ld.l 28(fp), r19	// load request_handler_arg1
	br 10b			// branch to exit code
	nop


//	
// am_get
//
.globl _am_get
_am_get:	
	addu -48,sp,sp		// need to align at 16-byte boundary
	st.l fp,0(sp)		// store the caller's frame pointer
 	addu 0,sp,fp		// update stack pointer
	st.l r1,4(fp)		// store the return adddress in frame
	orh ha%_pam_mynode,r0,r31 // load pam_mynode
	ld.l l%_pam_mynode(r31),r30
	shl 2,r16,r28		// get index into pam_outstanding
	bte r30,r16,11f         // branch if dest = pam_mynode
	orh ha%_pam_outstanding,r0,r31
	ld.l l%_pam_outstanding(r31),r30
	br 3f
	addu r30,r28,r24	// get pointer to pam_outstanding[dest_node]
				// count = 9
1:
	st.l r16, 8(fp)		// move args to frame so that am_poll()
	st.l r17, 12(fp)	// won't ruin it
	st.l r18, 16(fp)	// should do this only once since we may
	st.l r19, 20(fp)	// be polling multiple times
	st.l r20, 24(fp)
	st.l r21, 28(fp)
	st.l r22, 32(fp)
	st.l r23, 36(fp)	
2:	call _am_poll		// poll if used up credit
	st.l r24, 36(fp)	// save temporary value also

	ld.l 36(fp), r24	// restore args and temp var
	orh ha%_pam_max_outstanding,r0,r31
	ld.l 0(r24),r25		// load # of outstanding messages
	ld.l l%_pam_max_outstanding(r31),r30
	orh ha%_pam_mynode,r0,r31	// assemble tag as arg3
	subs r25,r30,r0
	bnc 2b			// if used up credit, keep polling

	ld.l 8(fp), r16
	ld.l 12(fp), r17
	ld.l 16(fp), r18
	ld.l 20(fp), r19
	ld.l 24(fp), r20
	ld.l 28(fp), r21
	ld.l 32(fp), r22
	br 4f	
	ld.l 36(fp), r23


3:	orh ha%_pam_max_outstanding,r0,r31
	ld.l 0(r24),r25			// load # of outstanding messages
	ld.l l%_pam_max_outstanding(r31),r30
	subs r25,r30,r0
	bnc 1b			// if used up credit, keep polling

4:	or POST_PAM_GET, r0, r31	

	// this is an modified version of mcmsg_post10
	orh	ha%_mcmsg_post_page_in, r0, r29	// r29 = ptr to in index
	ld.l	l%_mcmsg_post_page_in(r29), r28	// r28 = in index
	orh	ha%_mcmsg_post_page, r0, r30	//
	ld.l	l%_mcmsg_post_page(r30), r30	// r30 =  pointer to post page
	ixfr	r31, f16			// Move method to FP
	and	31, r28, r0			// Check for half page bdry
	bc	6f				// Branch if half page bdry

5:	shl	6, r28, r31			// Create entry pointer
	addu	r30, r31, r31			//
	addu	1, r28, r28			// Increment index
	st.l	r28, l%_mcmsg_post_page_in(r29)	// Store new index
	addu 1,r25,r25		// increment *ip
	st.l r25,0(r24)	
	
	ixfr	r19, f20			// Move arg 4 to FP
	ixfr	r20, f21			// Move arg 5 to FP
	ixfr	r21, f22			// Move arg 6 to FP
	fst.q	f20, 16(r31)			// Post arg 4-7
			
	ixfr	r16, f17			// Move arg 1 to FP
	ixfr	r17, f18			// Move arg 2 to FP
	ixfr	r18, f19			// Move arg 3 to FP

	fst.q	f16, 0(r31)			// Post request

10:		
	adds 48,fp,r31		// restore frame
	ld.l 4(fp),r1	
	ld.l 0(fp),fp
	mov 	r0,r16		// return 0
	bri r1
	mov r31,sp
	.align 8
	nop
	
6:	and	63, r28, r28			// Fix index for end of page
//
//	At this point, r28 is either	 0 (was 64) or	32.
//	We want to spin on index	31 or		63, respectively.
//	That will ensure that entries 0-31 or        32-63 are open,
//	so we don't have to check them individually.
//
	shl	6, r28, r31			//
	addu	r30, r31, r31			// r31 = entry pointer
7:	ld.l	1984(r31), r31			// r31 = method
	or	r31, r0, r0			// Test for zero
	bc	5b				// Branch when zero
	shl	6, r28, r31			// (Its OK to waste time here)
	br	7b				// Loop back
	addu	r30, r31, r31			// r31 = entry pointer

11:
	st.l r16, 8(fp)		// move args to frame so that memcpy()
	st.l r17, 12(fp)	// won't ruin it
	st.l r18, 16(fp)	
	st.l r19, 20(fp)	
	st.l r20, 24(fp)
	st.l r21, 28(fp)
	st.l r22, 32(fp)
	st.l r23, 36(fp)		
        mov r18, r16		// move dest_buf to r16
	call _memmove
        mov r19, r18		// move len to r18
	

	ld.l 8(fp), r16		// load dest_node
	ld.l 16(fp), r17	// load dest_buf
	ld.l 24(fp), r20	// load reply_handler
	ld.l 20(fp), r18	// load len
        calli r20		// call reply_handler
	ld.l 28(fp), r19	// load reply_handler_arg1
	br 10b			// branch to exit code
	nop

	