
/* sample main() to use GLUnix and TCPAM */
#include <stdio.h>
#include <glib.h>
#include <am.h>

volatile int counter = 0;


void reply_handler(int src)
{
  ++counter;
}

void request_handler(int src)
{
	am_reply_0(src, reply_handler);
  ++counter;
}

main(int argc, char **argv)
{

  if (!Glib_Initialize()) {
    fprintf(stderr,"Error - GLUnix couldn't initialize!\n");
    exit(-1);
  }
  if (Glib_AmIStartup()) {
    if (argc > 1)
      /* argv[1] is number of nodes; argv[0] is program name; argv is
       * list of arguments including program name and number of nodes
       */
      Glib_Spawn(atoi(argv[1]), argv[0], &argv[0]);
    else
      Glib_Spawn(1, argv[0], &argv[0]);
  }
  else {
    am_enable();
    /* do your stuff here */
    printf("node %d\n", am_my_proc());
    if (am_my_proc() == 0) {
      am_request_0(1, request_handler);
			while (counter < 1)
				am_poll();
		}
		else if (am_my_proc() == 1) {
			while (counter < 1)
				am_poll();
		}
		printf("node %d done\n", am_my_proc());
		am_barrier();
  	am_disable();		
  }

}
