/* stuff shared between CMAM glue routines and Bitonic sort routines */

/******************** TYPEDEFS *************************/


typedef long doubleword[2];

/* #if __STDC__
 *#define __P(x) x
 *#else
 *#define volatile
 *#define const
 * #define __P(x) ()
 *#endif
 */


extern volatile int receive_flag, service_flag;
extern doubleword *incoming;
extern doubleword *outgoing;

typedef void (*voidfunptr)();

/* XXX WARNING:  the CMAM indirect RPC code assumes that
   a pointer to this structure can be dereferenced to get a function
   pointer */
/*struct indir_rpc {
 *    void (*procedure) __P((int, long, long, long, long));
 *    int index;
 *};
 */


#if __GNUC__ && defined(DO_INLINE)

#undef MIN
#undef MAX

static inline MIN(x, y, z)
doubleword x;
doubleword y;
doubleword z;
/*
    Take min of x and y and place the result in z
*/
{
    if(x[0] < y[0]){
	z[1] = x[1];
	z[0] = x[0];
    }
    else
        if(y[0] < x[0]){
	    z[1] = y[1];
	    z[0] = y[0];
	}
	else
	    if(x[1] < y[1]){
		z[1] = x[1];	
		z[0] = x[0];
            }
	    else{
		z[1] = y[1];	
		z[0] = y[0];
	    }
}
/* MIN */
static inline MAX(x, y, z)
doubleword x; 
doubleword y; 
doubleword z;
/*
    Take max of x and y and place the result in z
*/
{
    if(x[0] > y[0]){
	z[1] = x[1];
	z[0] = x[0];
    }
    else
        if(y[0] > x[0]){
	    z[1] = y[1];
	    z[0] = y[0];
	}
	else
	    if(x[1] > y[1]){
		z[1] = x[1];	
		z[0] = x[0];
            }
	    else{
		z[1] = y[1];	
		z[0] = y[0];
	    }
}
/* MAX */

/* how to do doubleword compares and swaps */

static inline void assign(doubleword x, doubleword y)
{ 
    x[0] = y[0];
    x[1] = y[1];
}

static inline int is_greater_than(doubleword x, doubleword y)
{
    return ( (x[0] > y[0]) ? 1: 
	    ( ((x[0] == y[0]) && (x[1] > y[1])) ? 1 : 0));
}

static inline int is_greaterorequal_than(doubleword x, doubleword y)
{
    return ( (x[0] > y[0]) ? 1:
	    ( ((x[0] == y[0]) && (x[1] >= y[1])) ? 1 : 0));
}

static inline int is_less_than(doubleword x, doubleword y)
{
    return (( x[0] < y[0])? 1 : 
	    ( ((x[0] == y[0]) && (x[1] < y[1])) ? 1 : 0));
}

static inline int is_lessorequal_than(doubleword x, doubleword y)
{
    return (( x[0] < y[0])? 1 :
	    ( ((x[0] == y[0]) && (x[1] <= y[1])) ? 1 : 0));
}
#else /* not GCC, or not DO_INLINE */

/* DO AS MACROS to make 'em fast */

#define MIN(x, y, z) \
{\
    if(x[0] < y[0]){\
	z[1] = x[1];\
	z[0] = x[0];\
    }\
    else\
        if(y[0] < x[0]){\
	    z[1] = y[1];\
	    z[0] = y[0];\
	}\
	else\
	    if(x[1] < y[1]){\
		z[1] = x[1];	\
		z[0] = x[0];\
            }\
	    else{\
		z[1] = y[1];	\
		z[0] = y[0];\
	    }\
}



#define MAX(x, y, z) \
{\
    if(x[0] > y[0]){\
	z[1] = x[1];\
	z[0] = x[0];\
    }\
    else\
        if(y[0] > x[0]){\
	    z[1] = y[1];\
	    z[0] = y[0];\
	}\
	else\
	    if(x[1] > y[1]){\
		z[1] = x[1];	\
		z[0] = x[0];\
            }\
	    else{\
		z[1] = y[1];	\
		z[0] = y[0];\
	    }\
}

#define assign(x, y) \
{ \
    (x)[0] = (y)[0]; \
    (x)[1] = (y)[1]; \
}




#define is_greater_than(x, y) \
    ( (x[0] > y[0]) ? 1: \
        ( ((x[0] == y[0]) && (x[1] > y[1])) ? 1 : 0))

#define is_greaterorequal_than(x, y) \
    ( (x[0] > y[0]) ? 1: \
        ( ((x[0] == y[0]) && (x[1] >= y[1])) ? 1 : 0))





#define is_less_than(x, y) \
    (( x[0] < y[0])? 1 : \
       ( ((x[0] == y[0]) && (x[1] < y[1])) ? 1 : 0))

#define is_lessorequal_than(x, y) \
    (( x[0] < y[0])? 1 : \
       ( ((x[0] == y[0]) && (x[1] <= y[1])) ? 1 : 0))

#endif /* DO_INLINE or GCC */

#define MAX_PER_PROC (1024*512)

#undef __P
