/*									tab:4
 *
 * X_handlers.sc - Split-C node X functions
 *
 * "Copyright (c) 1993 by Steve Lumetta and The Regents of the University 
 * of California.  All rights reserved."
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author: 			Lok Tin Liu
 * Version:			1
 * Creation Date:	Sun Nov  7 17:00:51 1993
 * Filename:		X_handlers.sc
 * History:
 *	LTL	1	Sun Nov  7 17:01:12 1993
 *		Initial release. X stuff is not in libsplit-c anymore.
 */



#include "ansi-c.h"
#include <split-c/split-c.h>
#include "cm5.h"
#include "print.h"
#include "X_handlers.h"

#define X_INIT          (DEFAULT_HOST_HANDLERS_NUM)
#define X_POINT         (DEFAULT_HOST_HANDLERS_NUM+1)
#define X_BLOCK         (DEFAULT_HOST_HANDLERS_NUM+2)
#define X_SHOW          (DEFAULT_HOST_HANDLERS_NUM+3)

#define myProc MYPROC
#define LARGEST_PRINT_STRING	4096+8 /* the +8 is so I can guarantee that it
					* is on a doubleword boundary
					*/ 
typedef int Channel;

/* X interface--X_init, X_point, X_block, and X_show */

VOID X_init(int N) /* halts on failure */
{
	send_to_host(X_INIT, N, 0, 0);
}

VOID X_point(int x, int y, int color)
{
	send_to_host(X_POINT, x, y, color);
}

VOID X_block(int x1, int y1, int x2, int y2, char *info)
{
	char buffer[LARGEST_PRINT_STRING];
	char *bp;
	int len, p1, p2;
	volatile Channel chan;

	len = ((x2 - x1)*(y2 - y1) + 3)/4;
	bp = (char *)((((unsigned)buffer) + 7)&~7);
	bcopy(info, bp, len);

	p1 = ((x1<<16)|(y1&0xFFFF));
	p2 = ((x2<<16)|(y2&0xFFFF));
	
	if (len > 0) {
		chan = -2;
		send_to_host(X_BLOCK, &chan, p1, p2);
		while (chan == -2) am_poll();
		am_xferBuffer2Host(chan, (int *)bp, len);
		while (chan != -3) am_poll();
	}
}

VOID X_show()
{
	send_to_host(X_SHOW, 0, 0, 0);
}
