/*									tab:4
 *
 * am_cmmd.h - Active message header file for CMMD version of libsplitc
 *
 * "Copyright (c) 1993 by Steve Lumetta and The Regents of the University 
 * of California.  All rights reserved."
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author: 			Lok Tin Liu
 * Version:			2
 * Creation Date:	Mon Aug 16 15:05:32 1993
 * Filename:		am_cmmd.h
 * History:
 *	LTL	1	Mon Aug 16 15:06:44 1993
 *		New header file for CMMD version of libsplitc
 */



#ifndef AM_CMMD_H
#define AM_CMMD_H

/**************************************/
/* so it can be included in c++ files */
/**************************************/

#ifdef __cplusplus
			extern "C" {
#endif	

#if !defined(CMAML_DEBUG) && defined(__GNUC__)
#	define	CMAML_INLINE
#	define	INLINE(code) {code}
#else
#	undef	CMAML_INLINE
#	define	INLINE(code) ;
#endif

#ifdef	CM5
#	if defined(pe_obj)
#	  ifndef PE_CODE
#	    define PE_CODE
#	  endif
#	  undef	CP_CODE
#	  undef	PE_ONLY
#	elif defined(PE_ONLY)
#	  undef	CP_CODE
#	  ifndef pe_obj
#	    define pe_obj
#	  endif
#	  ifndef PE_CODE
#	    define PE_CODE
#	  endif
#	else /* defined(CP_CODE) */
#	  undef	PE_CODE
#	  undef	pe_obj
#	  undef	PE_ONLY
#	endif
#
#endif	/*CM5*/

#include <cm/cmmd.h>

typedef void (*Handler)();

extern int cmaml_open_segment(void *base_addr, int len, 
                                     Handler func, void *data); 
extern int cmaml_xfer(int dest, int sid, void *buf, int len);
extern int cmaml_barrier(int info_bit);
extern void cmaml_wait(volatile int *flag, int value);

/*********************/
/* for c++ inclusion */
/*********************/

#ifdef __cplusplus
}
#endif	

#endif AM_CMMD_H
