/*									tab:4
 *
 * host.h - include for all host side code
 *
 * Copyright (c) 1992 by Seth Copen Goldstein and 
 * Regents of the University of California
 *
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  Copyright holder(s) make no
 * representation about the suitability of this software for
 * any purpose. It is provided "as is" without express or
 * implied warranty.
 *
 * Author: 			Seth Copen Goldstein
 * Version:			17
 * Creation Date:	Wed Jan 20 15:24:48 1993
 * Filename:		host.h
 * History:
 *	ssl	15	Tue Nov  2 17:05:18 1993
 *		Included am.h instead of cm5.h. Took out cm5 specific includes.
 *	LTL	14	Mon Aug 16 15:38:58 1993
 *		Fixed it up for version 112 to support CMMD
 * 	TvE	13	Sat Apr  3 22:52:49 PST 1993
 *		Changed include <cmam/cmam.h> to "cmam.h"
 */

#ifndef _SPLIT_C__HOST_H_
#define _SPLIT_C__HOST_H_

#include <stdio.h>
#include <split-c/am.h>

#include <split-c/ansi-c.h>

typedef int Channel;
typedef int Processor;

typedef struct
{
	Processor pid;				/* processor to get function */
	Handler function;			/* function to invoke on pid */
	FILE *stream;
	VOID_STAR adr;
	VOID_STAR adr2;
} remoteFunction;


extern int splitc_notDone;
extern volatile int splitc_exitCode;
extern int splitc_partition_size;


int  splitc_addHandlers(int num, Handler *newHandlers);

#ifndef CMMD
int  splitc_packageArgs(int argc, char **argv);
void splitc_abstain_com(void);
#endif

void splitc_host_initialize(void);
void splitc_startnodes(int argc, char **argv);
void splitc_host_loop(void);

/*********************************************************/
/* used for debugging the default host handler routines. */
/*********************************************************/

#ifdef LOGGING_HOST
    extern FILE *loger;
    void openLogger(char *name);
#	define closeLogger()	fclose(loger);
#else
#	define openLogger(name)
#	define closeLogger()
#endif

#endif


