/*									tab:4
 *
 * init_cp.c - code to startup splitc environment
 *
 * Copyright (c) 1992 by Seth Copen Goldstein and 
 * Regents of the University of California
 *
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  Copyright holder(s) make no
 * representation about the suitability of this software for
 * any purpose. It is provided "as is" without express or
 * implied warranty.
 *
 * Author: 			Seth Copen Goldstein
 * Version:			10
 * Creation Date:	Wed Jan 20 15:21:28 1993
 * Filename:		init_cp.c
 * History:
 *	ssl	10	Tue Jan 18 20:47:01 1994
 *		Set splitc_partition_size in splitc_startnodes instead
 *	LTL	8	Mon Aug 16 15:39:55 1993
 *		Fixed it up for version 112 to support CMMD
 */
static char _version_string_[] = "\nVersion:10:init_cp.c\0\n";

#include "host.h"

#ifndef CMMD

void splitc_host_initialize()
{
	openLogger(argv[0]);
	
	CMAM_enable();
	CMAM_enable_barrier();
	splitc_abstain_com();
	splitc_partition_size = CMAM_partition_size;
}

#else

void splitc_host_initialize()
{
	openLogger(argv[0]);
	splitc_partition_size = CMMD_partition_size();

}
#endif /* CMMD */


