/*									tab:4
 *
 * loop_cp.c - top level loop
 *
 * Copyright (c) 1992 by Seth Copen Goldstein and 
 * Regents of the University of California
 *
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  Copyright holder(s) make no
 * representation about the suitability of this software for
 * any purpose. It is provided "as is" without express or
 * implied warranty.
 *
 * Author: 			Seth Copen Goldstein
 * Version:			8
 * Creation Date:	Wed Jan 20 15:32:52 1993
 * Filename:		loop_cp.c
 * History:
 *	LTL	7	Mon Aug 16 15:43:22 1993
 *		Fixed it up for version 112 to support CMMD
 */
static char _version_string_[] = "\nVersion:7:loop_cp.c\0\n";

#include "host.h"

#ifndef CMMD

void splitc_host_loop()
{
	/* wait for messages to do things like print etc. */

	while (splitc_notDone)
	{
		CMAM_poll();
	}
	/* time to exit */
	
	CMAM_disable_barrier();
	closeLogger();
}

#else


void splitc_host_loop()
{

  /* service I/O requests from node */
  while (splitc_notDone) {
    CMMD_poll_for_services();
  }

  /* time to exit */
  closeLogger();
}

#endif /* CMMD */
