/*									tab:4
 *
 * main_cp.c - Split-C Control Processor Side default main code
 *
 * Copyright (c) 1992 by Seth Copen Goldstein and 
 * Regents of the University of California
 *
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  Copyright holder(s) make no
 * representation about the suitability of this software for
 * any purpose. It is provided "as is" without express or
 * implied warranty.
 *
 * Author: 			Seth Copen Goldstein
 * Version:			227
 * Creation Date:	Fri Jan 24 13:37:26 1992
 * Filename:		cp.c
 * History:
 *	SCG	225	Wed Jan 20 15:18:09 1993
 *		broke out all real work into handlers_cp.c, loop_cp.c, init_cp.c, and
 *		host.h so that any combination of these files can be replaced by
 *		a user.
 * 	TvE	224	Sun Jan 17 02:49:39 PST 1993
 *		Host needs to abstain from combine network for all_sotre_sync
 *		to work. Added that to main().
 *	SCG	221	Mon Dec  7 16:02:55 1992
 *		added argv, argc support for splitc_main.
 *		removed direct inclusion of prototype file.
 *	SCG	211	Wed Dec  2 15:42:31 1992
 *		added fread & fseek.  Fixed some re-entrancy bugs
 *	AK	209	Sat Nov 28 21:15:36 1992
 *		Changed include file name from 2-4.
 */
static char _version_string_[] = "\nVersion:225:pm.c\0\n";

#include "host.h"

/***************************************************/
/* basic main routine that starts split-c programs */
/***************************************************/

void main(argc, argv)
int argc;
char **argv;
{
	splitc_host_initialize();
	splitc_startnodes(argc, argv);
	splitc_host_loop();
	exit(splitc_exitCode);
}
