/*									tab:8
 *
 * timer.c - timing routines
 * 
 * "Copyright (c) 1993 The Regents of the University of California.
 * All rights reserved.
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author: 		Richard P. Martin
 * Version:		5
 * Creation Date:	Sun Nov 21 17:30:24 PST 1993
 * Filename:		timer.c
 * History:
 */

#include <sys/time.h>

struct timeval splitc_base_time;

void timer_init()
{
	struct timezone z;		
	gettimeofday(&splitc_base_time, &z);
}

double get_seconds()
{
	struct timeval t,lapsed;
	struct timezone z;
	
	gettimeofday(&t,&z);
	if (splitc_base_time.tv_usec > t.tv_usec) {
		t.tv_usec += 1000000;
		t.tv_sec--;
	}
    
	lapsed.tv_usec = t.tv_usec - splitc_base_time.tv_usec;
	lapsed.tv_sec = t.tv_sec - splitc_base_time.tv_sec;

	return (double)lapsed.tv_sec+((double)lapsed.tv_usec/(double)1000000.0) ;
}

