/*									tab:8
 *
 * ansi-c.h - header file to enhance portablility of ansi-ish C programs
 *
 * Copyright (c) 1991 by Regents of the University of California
 *
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  Copyright holder(s) make no
 * representation about the suitability of this software for
 * any purpose. It is provided "as is" without express or
 * implied warranty.
 *
 * Version:		35
 * Creation Date:	Thu Jan 17 12:50:38 1991
 * Filename:		ansi-c.h
 * History:
 *	SCG	30	Sun Mar 15 12:03:34 1992
 *		made bool into an int
 * 	TvE	27	Wed Nov  6 01:50:27 PST 1991
 *		made sun4 to use more files in /usr/include
 *	SCG	23	Mon Jul  8 16:42:59 1991
 *		changhed elif to else and if (for ncc)
 *	SCG	21	Tue Jul  2 10:03:28 1991
 *		make the Address datatype valid across all models
 *	SCG	19	Mon Jun 10 16:01:14 1991
 *		added aint-> trunc definition for sun4
 *	SCG	17	Mon Jun  3 14:49:05 1991
 *		fixc varargs so works on both mammoth and sun4
 *	SCG	15	Wed May 15 18:31:24 1991
 *		fix vararg macros to work on a sun4
 *	SCG	13	Fri Feb  1 15:41:01 1991
 *		add varagrs macros that work for both sparc and mips.  see example
 *		usage
 *	SCG	5	Fri Jan 18 12:30:59 1991
 *		removed ushort - it's in sys//types.h
 *	SCG	2	Thu Jan 17 12:51:02 1991
 *		added uint, ushort, and bool.
 */

#ifndef ANSIC_H
#define ANSIC_H

typedef unsigned int bool;

#if defined(__STDC__)
#	if defined(sprite)
#		define	_VARARGS	/* varargs/stdargs kludge */
#		define _HAS_PROTOTYPES	/* /sprite/lib/include/cfuncproto.h */
#		define _HAS_VOIDPTR
#		define Boolean int
#	endif
#	include <stdio.h>
#	include <unistd.h>
#	include <stdlib.h>
#	if !defined(__GNUC__)
#		include <stdarg.h>
#		define	inline
#	else
#		include <varargs.h>
#		ifndef _VARARGS_
#			define _VARARGS_
#		endif
#	endif
#	define	VOID		void	/* type of fun returning nothing */
#	define	VOID_STAR	void*	/* generic pointer */
#	define	VOID_A		void	/* function with no arguments */
#else
# if defined(ds3100) && defined(sprite)
#	include <stdio.h>
#	include <unistd.h>
#	include <stdlib.h>
#	include <varargs.h>
#	define	const
#	define	signed
#	define	inline
#	define	VOID		void	/* type of fun returning nothing */
#	define	VOID_STAR	char*	/* generic pointer */
#	define	VOID_A		void	/* function with no arguments */
# else
#  if defined(sparc)
#	include <stdio.h>
#	include <unistd.h>
#	include <stdlib.h>
#	include <varargs.h>
#	ifndef _VARARGS_
#		define _VARARGS_
#	endif
#	define	const
#	define	signed
#	define	inline
#	define	VOID		void	/* type of fun returning nothing */
#	define	VOID_STAR	void*	/* generic pointer */
#	define	VOID_A			/* function with no arguments */
#  else
#	include <stdio.h>
#	include <varargs.h>
#	ifndef _VARARGS_
#		define _VARARGS_
#	endif
#	define	const
#	define	signed
#	define	inline
#	define	VOID		void	/* type of fun returning nothing */
#	define	VOID_STAR	char*	/* generic pointer */
#	define	VOID_A			/* function with no arguments */
#  endif
# endif
#endif

#if !defined(symm)
#	define shared
#endif

#define Address VOID_STAR


/*
 * int32 should be a 32bit integer
 * int16 should be a 16bit integer
 * uint32 should be an unsigned 32bit integer
 * uint16 should be an unsigned 16bit integer
 * real should be a 64bit floating-point
 */
#ifdef vax
typedef int		int32;
typedef short		int16;
typedef	unsigned int	uint32;
typedef	unsigned short	uint16;
#else
typedef int		int32;
typedef short		int16;
/*typedef	unsigned int	uint32;*/
typedef	unsigned short	uint16;
#endif
typedef	double		real;

#ifndef FALSE
#define	FALSE	(0)
#endif

#ifndef TRUE
#define	TRUE	(!FALSE)
#endif

#ifdef sun386
#define PORTAR
#endif

#if defined(symm)
#define LACK_SYS5
#define strchr index
#define signed
#endif

#ifndef	NULL
#define	NULL	0
#endif	/* NULL */

#if !defined(sprite) && defined(sparc)
# define trunc aint
#endif

/* some call it strings.h, some call it string.h; others, also have memory.h */
#if defined(__STDC__) || defined(sprite) || defined(sparc)
#include "/usr/include/string.h"
#else
/* ANSI C string.h -- 1/11/88 Draft Standard */
#if defined(ultrix) || defined(hpux)
#include "/usr/include/strings.h"
#else
extern char *strcpy(), *strncpy(), *strcat(), *strncat(), *strerror();
extern char *strpbrk(), *strtok(), *strchr(), *strrchr(), *strstr(), *strdup();
extern int strcoll(), strxfrm(), strncmp(), strlen(), strspn(), strcspn();
extern char *memmove(), *memccpy(), *memchr(), *memcpy(), *memset();
extern int memcmp(), strcmp();
#endif /* ultrix */
#endif /* __STDC__ */

/* Function prototypes
 * Example:	extern int foo ARGS((char *blah, double threshold));
 */
#if defined(__STDC__) || defined(ds3100)
#define	ARGS(args)	args
#else
#define	ARGS(args)	()
#endif

/* varargs macros that understand the difference between stdargs and varargs */

#define VarArgBase	va_alist
#ifdef m88k
# define VarArgBaseDecl	va_type va_alist
#else
# define VarArgBaseDecl	int va_alist
#endif
#define VarArg		___va_lp___
#define VarArgDecl	va_list VarArg
#if defined(_VARARGS_H) || defined(_VARARGS_)
# define VarArgInit(l)	va_start(VarArg)
#else
# define VarArgInit(l)	va_start(VarArg, l)
#endif
#define VarArgNext(t)	va_arg(VarArg, t)
#ifdef m88k
# define VarArgEnd()	va_end(VarArg)
#else
# define VarArgEnd()
#endif

#if 0
/* example usage of vararg macros */

foo(var1, var2, VarArgBase)	/* VarArgBase must be last parameter */
type var1;
type var2;
VarArgBaseDecl;			/* must have this as last decl */
{
	VarArgDecl;		/* declares variable that will be used to
				 * run down the list of arguments starting at
				 * VarArgBase
				 */
	typename var3;		/* example variable that gets one of the
				 * arguments from the argument list
				 */

	VarArgInit(var2);	/* MUST BE CALLED BEFORE ACCESSING THE
				 * ARGUMENTS, the parameter to this macro is
				 * ALWAYS the parameter preceding VarArgBase
				 */
	

	/* usage to send argument list to one of the v-printf functions */
	
	vfprintf(of, format, VarArg);

	/* usage to get an element off the argument list */
	
	var3 = VarArgNext(typename);
}
#endif

#endif /* PORT_H */
