#ifndef enameserver_h
#define enameserver_h

typedef unsigned char byte;
/* these all return 0 on success, -1 on failure */
int NameServer_Init(void);
/* output_name is allocated space, you should free it when done*/
/* output_name == NULL => name was non existant */
int NameServer_Lookup(char *input_name, byte **output_name,int *output_namelen);
int NameServer_Bind(char *input_name, byte *output_name,int output_namelen);
#define ENS_NOERROR(x) if ((x)!=0) {printf("Nameserver error.\n");exit(1);}

/* This returns the context -- you need to release the space for this
   (it's been malloced); SetContext duplicates the context, so you can
   go ahead and free it. */
char *NameServer_GetContext(void);
void NameServer_SetContext(char *context);

#ifdef ENAMESERVER_GET_PRIVATE_DEFINITIONS
#define NS_PRIV_NAMESERVERPORT 26313
#define NS_PRIV_LOOKUP 1
#define NS_PRIV_BIND 2
#endif

#endif
