/*									tab:4
 *
 * handlers.c - Install AM handlers
 *
 * "Copyright (c) 1996 and The Regents of the University 
 * of California.  All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author: 			Andrea C. Dusseau
 * Version:			2
 * Creation Date:	Mon Feb 12 17:25:24 1996
 * Filename:		handlers.c
 * History:
 */

#include <split-c/split-c.h>

/* Declared in main.c */
extern void __error_handler(int status, op_t opcode, void *argblock);

handler_func_t reply_handler_list[] = {
	__C_GET_RH,		__c_get_reply_handler,
	__SH_GET_RH,	__sh_get_reply_handler,
	__I_GET_RH,		__i_get_reply_handler,
	__F_GET_RH,		__f_get_reply_handler,
	__D_GET_RH,		__d_get_reply_handler,
	__LL_GET_RH,	__ll_get_reply_handler,
	__DECR_CTR_RH,			__decr_ctr_reply_handler,
	__DECR_PUT_CTR_RH,		__decr_put_ctr_reply_handler,
	__DECR_WRITE_CTR_RH,	__decr_write_ctr_reply_handler,
	__GETCOMPLETE_RH,		__get_complete_reply_handler,
	__PUTCTRCOMPSRC_RH,		__put_ctr_comp_src_reply_handler,
	__NULL_RH,				__null_reply_handler,
	__ATOMIC_I_RH,			__atomic_i_reply_handler,
	__ATOMIC_D_RH,			__atomic_d_reply_handler,
	__LAST_HANDLER,			NULL
};

handler_func_t handler_list[] = {
	__ERROR_H,		__error_handler,
	__C_GET_H,		__c_get_handler,
	__SH_GET_H,		__sh_get_handler,
	__I_GET_H,		__i_get_handler,
	__F_GET_H,		__f_get_handler,
	__D_GET_H,		__d_get_handler,
	__LL_GET_H,		__ll_get_handler,
	__C_PUT_H,		__c_put_handler,
	__SH_PUT_H,		__sh_put_handler,
	__I_PUT_H,		__i_put_handler,
	__F_PUT_H,		__f_put_handler,
	__D_PUT_IMPLICIT_H,		__d_put_implicit_handler,
	__LL_PUT_IMPLICIT_H,	__ll_put_implicit_handler,
	__D_WRITE_H,			__d_write_handler,
	__LL_WRITE_H,			__ll_write_handler,
	__BULK_PUT_H,			__bulk_put_handler,	
	__STORE_H,				__store_handler,	
	__C_STORE_H,			__c_store_handler,		 	
	__SH_STORE_H,			__sh_store_handler,	 	
	__I_STORE_H,			__i_store_handler,		 	
	__F_STORE_H,			__f_store_handler,		 	
	__D_STORE_H,			__d_store_handler,		 	
	__LL_STORE_H,			__ll_store_handler,
	__BARRIER_INCR_H,		__barrier_incr_handler,
	__ATOMIC_NOSYNC_H,		__atomic_nosync_handler,
	__ATOMIC_H,				__atomic_handler,
	__ATOMIC_LONG_H,		__atomic_long_handler,
	__ATOMIC_VAL_H,			__atomic_val_handler,
	__GET_H,				__get_handler,
	__LAST_HANDLER,			NULL
};


	
	
	

