/*									tab:4
 *
 * handlers.h - Definitions for handlers
 *
 * "Copyright (c) 1996 and The Regents of the University 
 * of California.  All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author: 			Andrea C. Dusseau
 * Version:			2
 * Creation Date:	Mon Feb 12 14:03:13 1996
 * Filename:		handlers.h
 * History:
 */

#include <split-c/split-c.h>

#ifndef __HANDLERS_H__
#define __HANDLERS_H__


#define __ERROR_H				0

/* Handlers defined in memory.c */
#define __C_GET_H				1
#define __SH_GET_H				2
#define __I_GET_H				3
#define __F_GET_H				4
#define __D_GET_H				5
#define __LL_GET_H				6

#define __C_GET_RH				7
#define __SH_GET_RH				8
#define __I_GET_RH				9
#define __F_GET_RH				10
#define __D_GET_RH				11
#define __LL_GET_RH				12

#define __C_PUT_H				13
#define __SH_PUT_H				14
#define __I_PUT_H				15
#define __F_PUT_H				16
#define __D_PUT_IMPLICIT_H		17
#define __LL_PUT_IMPLICIT_H		18

#define __DECR_CTR_RH			19
#define __DECR_PUT_CTR_RH		20

#define __D_WRITE_H				21
#define __LL_WRITE_H			22
#define __DECR_WRITE_CTR_RH		23

/* Defined in bulk.c */
#define __GETCOMPLETE_RH		24
#define __BULK_PUT_H			25
#define __PUTCTRCOMPSRC_RH		26
#define __NULL_RH				27
#define __STORE_H				28


/* Defined in store.c */
#define __C_STORE_H			 	29
#define __SH_STORE_H		 	30
#define __I_STORE_H			 	31
#define __F_STORE_H			 	32
#define __D_STORE_H			 	33
#define __LL_STORE_H			34

/* Defined in barrier.c */
#define __BARRIER_INCR_H		35

/* Defined in atomic.c */
#define __ATOMIC_NOSYNC_H		36
#define __ATOMIC_H				37
#define __ATOMIC_LONG_H			38
#define __ATOMIC_VAL_H			39
#define __ATOMIC_I_RH			40
#define __ATOMIC_D_RH			41

#define __GET_H					42

/* Must update this if add handlers */
#define __LAST_HANDLER			43

typedef struct handler_function_T {
	handler_t 	handler_index;
	void 		(*func)();
} handler_func_t;

extern handler_func_t handler_list[];
extern handler_func_t reply_handler_list[];

#endif
	
