/****************************************************************************/
/*                                                                          */
/* Copyright    **    **  ********  ********  **    **   ******     Limited */
/* Copyright    ***  ***  ********  ********  **   **   ********    Limited */
/* Copyright    ********  **           **     **  **    **    **    Limited */
/* Copyright    ** ** **  ******       **     ****      **    **    Limited */
/* Copyright    **    **  **           **     ** **     **    **    Limited */
/* Copyright    **    **  **           **     **  **    **    **    Limited */
/* Copyright    **    **  ********  ********  **   **   ********    Limited */
/* Copyright    **    **  ********  ********  **    **   ******     Limited */
/*                                                                          */
/*                      **       ****     ******    ******                  */
/*                     ***      ******   ********  ********                 */
/*                    ****     **    **  **    **  **   ***                 */
/*                      **      *******   *******      ***                  */
/*                      **           **        **    ***                    */
/*                      **           **        **   ***                     */
/*                      **     ********  ********  ********                 */
/*                      **      ******    ******   ********                 */
/*                                                                          */
/* Author:  Eric Barton - September 1992                                    */
/****************************************************************************/

/*
 * Copyright (c) 1992 by Meiko Ltd.
 */

/* $Id: group_sys.h,v 1.6 1994/06/17 20:45:54 eric Exp $ */
/* $Source: /home/cvs/master/cs2parts/ew/group_sys.h,v $ */

#ifndef _EW_GROUPSYS_H
#define _EW_GROUPSYS_H

#ifdef	__cplusplus
extern "C" {
#endif

#define GROUPSTACK		512

#define GROUPMINWAIT		10000		/* microseconds */
#define GROUPMAXWAIT		500000
#define PINGTIMEOUT		10000000

#define MINRBUFSIZE		1024		/* minimum reduction buffer size */

typedef struct					/* 1D array slice */
{
   int		baseVp;
   int		stride;
}	G1D;

typedef struct gpeer				/* Group's Peer */
{
   ELAN_DMA	   gp_dma;			/* dma -> branch */
   ELAN_EVENT	   gp_done;			/* set by my dma to branch */
   ELAN_EVENT	   gp_peerDone;			/* set by dma from branch */
   int		   gp_proc;			/* first process in sub-tree */
   int		   gp_endProc;			/* first process in next sub-tree */
   char            gp_buffer[MINRBUFSIZE];	/* reduction buffer (of required size) */
}               GPEER;

typedef struct group				/* Group */
{
   EW_GROUP	   g_public;
   int		   g_magic;
   int		   g_pad[3];
   /* EW_ALIGN */
   ELAN_DMA	   g_bcastDma;			/* everyone !? */
   ELAN_EVENT	   g_bcastPeerDone[2];		/* dest events for broadcast */
   ELAN_EVENT	   g_bcastDone;			/* src event for broadcast */
   ELAN_EVENT	   g_t_gsyncGo;
   ELAN_EVENT	   g_t_bcastGo;
   ELAN_EVENT	   g_t_pingGo;
   ELAN_EVENT	   g_t_pingDone;
   volatile int	   g_ping;			/* param/result from thread ping */
   volatile u_int  g_tgsyncUpSeq;		/* tgsync: sub-tree ready */
   volatile u_int  g_tgsyncDwnSeq;		/* tgsycn: parent ready */
   volatile u_int  g_bcastSeq;			/* broadcast sequence number */
   volatile u_int  g_fgsyncReadySeq;		/* fgsync: all ready */
   volatile u_int  g_fgsyncDoneSeq;		/* fgsync: bcast complete */
   int             g_waitType;			/* elan_waitevent() modifier */
   int             g_bufSize;			/* reduction buffer size */
   int		   g_peerSize;			/* size of EW_GPEERs in this group */
   GPEER	  *g_upDown;			/* my EW_GPEER in parent's g_down array */
   GPEER	  *g_up;			/* up the tree */
   GPEER	  *g_down;			/* down the tree (array) */
   GPEER	  *g_endDown;			/* end of g_down array */
}               GROUP;

#define GROUP_MAGIC 0xfb207699

extern void     ew_t_gsync (GROUP *g);
extern void     ew_t_bcast (GROUP *g);
extern void     ew_t_ping (GROUP *g);

#ifdef	__cplusplus
}
#endif

#endif
