/*                                                                      tab:8
 * malloc.c - management for global and local heaps.
 *
 * 
 * "Copyright (c) 1992 The Regents of the University of California.
 * All rights reserved.
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author:              Steve Luna
 * Version:             1
 * Creation Date:       Tue Nov 30 22:41:55 1993
 * Filename:            malloc.c
 * History:
 *	ssl	1	Thu Apr 28 21:46:21 1994
 *		added dword align check in all_spread_malloc
 *	ssl	1	Sun Mar 20 20:25:50 1994
 *		modified to make initial sbrk dword aligned
 */

#include <sys/types.h>
#include <stdio.h>
#include <split-c/split-c.h>
#define SC_MALLOC_INTERNAL_DEFINE
#include "malloc_int.h"

int verbose=0;

___V_SPTR all_spread_malloc (unsigned num_elems, unsigned bytes_per_elem)
{
	int s;
	unsigned size;
	static char *cp;

	size = ((num_elems+PROCS-1)/PROCS) * bytes_per_elem;
        if ((cp = ew_allocate(ew_base.alloc,8,size))==NULL)
		ew_exception(EW_ENOMEM,"Can't allocate spread object");
	return tospread(0, cp);
}

void all_spread_free (___V_SPTR sptr)
{
	char *c, *cp;

	cp = (char*)tolocal(sptr);
        ew_free(cp);
}

/* to appease ld */
#if 0
char *realloc(char *ptr, unsigned size)
{
	printf("FATAL ERROR: realloc called\n");
}

#endif
