/*									tab:8
 *
 * malloc.h - prototypes for split-c malloc functions
 *
 * 
 * "Copyright (c) 1992 The Regents of the University of California.
 * All rights reserved.
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author: 		Steve Luna
 * Version:		6
 * Creation Date:	Tue Nov 30 22:41:55 1993
 * Filename:		malloc.h
 * History:
 *	LTL	2	Mon Feb 20 09:51:51 1995
 *		Used sc_malloc_wrapper and sc_free_wrapper for SP2 instead.
 */

#ifndef SC_MALLOC_H
#define SC_MALLOC_H

/* use system prototype of malloc and free because different systems have
   different prototypes - ssl */
/*extern void *malloc(unsigned long size);*/
/*extern void free(void *cp);*/
extern ___V_SPTR all_spread_malloc (unsigned num_elems, unsigned bytes_per_elem);
extern void all_spread_free (___V_SPTR cp);

/* see malloc.c for explanation and potential problem */
#if defined(SP2)
#define malloc(size) sc_malloc_wrapper(size)
#define free(ptr) sc_free_wrapper(ptr)
#define realloc(ptr, size) sc_realloc_wrapper(ptr, size)
#endif

#endif SC_MALLOC_H
