/*                                                                      tab:4
 *
 * string.sc - Global-string library
 *
 * "Copyright (c) 1992 The Regents of the University of California.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 *
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author:        Andrea Dusseau
 * Version:       6
 * Creation Date: Thu Oct  1 14:45:08 PDT 1992
 * Filename:      string.sc
 * History:
 *	ssl	6	Tue Nov 16 12:23:39 1993
 *		Replaced global tags with macros.
 *	ssl	5	Thu Oct 28 22:05:28 1993
 *		Include am.h instead of cm5.h
 *	ssl	4	Fri Oct 22 13:15:54 1993
 *		Moved _version_string_ from string_inline.h
 *	LTL	3	Mon Aug 16 16:00:04 1993
 *		Fixed it up for version 112 to support CMMD
 * 	TvE	2	Mon Jan  4 17:26:34 PST 1993
 *		Renamed to string.sc.
 *		Removed some includes.
 */

#include <stdio.h>
#include <split-c/split-c.h>
#define STRING_INTERNAL_DEFINE
#include <split-c/string.h>
#include "am.h"

static char _version_string_[] = "\nVersion:1:string_inline.h\0\n";

/* ------------------------ g_strlen ------------------------ */
void g_strlen_rh(int src_node, int *flag, int *lengthaddr, int len)
{
  *lengthaddr = len;
  (*flag)++;
}

void g_strlen_h(int proc, char *s, int *flag, int *lengthaddr)
{
  am_reply_3(proc, g_strlen_rh, flag, lengthaddr, strlen(s));
}

/* ---------------------- g_strchr ---------------------------- */
void g_strhelper_rh(int proc, g_strhelper *info, char *result)
{
  info->result = (___C_GPTR)toglobal(proc, result);
  info->flag++;
}

void g_strchr_h(int proc, char *s, int c, g_strhelper *info)
{
  char *result;

  result = strchr(s, c);
  am_reply_2(proc, g_strhelper_rh, info, result);
}

/* ---------------------- g_strrchr ---------------------------- */
void g_strrchr_h(int proc, char *s, int c, g_strhelper *info)
{
  char *result;

  result = strrchr(s, c);
  am_reply_2(proc, g_strhelper_rh, info, result);
}






