/*									tab:4
 *
 * com.h - Header file for global communication routines
 *
 * "Copyright (c) 1993 by Steve Lumetta and The Regents of the University 
 * of California.  All rights reserved."
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author: 			Lok Tin Liu
 * Version:			3
 * Creation Date:	Mon Aug 16 15:29:07 1993
 * Filename:		com.h
 * History:
 *	ssl	3	Fri Mar  4 08:07:21 1994
 *		fixed bug in all_bcast_p
 *	LTL	1	Mon Aug 16 15:30:12 1993
 *		New header file for version 112 to support CMMD
 */



#ifndef SPLIT_C_COM_H
#define SPLIT_C_COM_H

/* reduce to Proc 0 */
extern int all_reduce_to_one_add(int val);
extern unsigned int all_reduce_to_one_uadd(unsigned int val);
extern float all_reduce_to_one_fadd(float val);
extern double all_reduce_to_one_dadd(double val);

extern int all_reduce_to_one_mult(int val);
extern unsigned int all_reduce_to_one_umult(unsigned int val);
extern float all_reduce_to_one_fmult(float val);
extern double all_reduce_to_one_dmult(double val);

extern int all_reduce_to_one_max(int val);
extern unsigned int all_reduce_to_one_umax(unsigned int val);
extern float all_reduce_to_one_fmax(float val);
extern double all_reduce_to_one_dmax(double val);

extern int all_reduce_to_one_min(int val);
extern unsigned int all_reduce_to_one_umin(unsigned int val);
extern float all_reduce_to_one_fmin(float val);
extern double all_reduce_to_one_dmin(double val);

extern int all_reduce_to_one_or(int val);
extern unsigned int all_reduce_to_one_uor( unsigned int val);

extern int all_reduce_to_one_xor(int val);
extern unsigned int all_reduce_to_one_uxor(unsigned int val);

extern int all_reduce_to_one_and(int val);
extern unsigned int all_reduce_to_one_uand(unsigned int val);

/* broadcast to all nodes */
extern int all_bcast(int val);  /* same as all_bcast_i */

extern int all_bcast_i(int val);
extern unsigned int all_bcast_u(unsigned int val);
extern float all_bcast_f(float val);
extern double all_bcast_d(double val);
extern void * all_bcast_p(void * val);
extern void all_bcast_buffer(___V_SPTR buf, int size);

/* reduction to all nodes */
extern int all_reduce_to_all_add(int val);
extern unsigned int all_reduce_to_all_uadd(unsigned int val);
extern float all_reduce_to_all_fadd(float val);
extern double all_reduce_to_all_dadd(double val);

extern int all_reduce_to_all_mult(int val);
extern unsigned int all_reduce_to_all_umult(unsigned int val);
extern float all_reduce_to_all_fmult(float val);
extern double all_reduce_to_all_dmult(double val);

extern int all_reduce_to_all_max(int val);
extern unsigned int all_reduce_to_all_umax(unsigned int val);
extern float all_reduce_to_all_fmax(float val);
extern double all_reduce_to_all_dmax(double val);

extern int all_reduce_to_all_min(int val);
extern unsigned int all_reduce_to_all_umin(unsigned int val);
extern float all_reduce_to_all_fmin(float val);
extern double all_reduce_to_all_dmin(double val);

extern int all_reduce_to_all_or(int val);
extern unsigned int all_reduce_to_all_uor(unsigned int val);

extern int all_reduce_to_all_xor(int val);
extern unsigned int all_reduce_to_all_uxor(unsigned int val);

extern int all_reduce_to_all_and(int val);
extern unsigned int all_reduce_to_all_uand(unsigned int val);


/* upward scan from Proc 0 to Proc (PROCS - 1) */
extern int all_scan_add(int val);
extern unsigned int all_scan_uadd(unsigned int val);
extern float all_scan_fadd(float val);
extern double all_scan_dadd(double val);

extern int all_scan_mult(int val);
extern unsigned int all_scan_umult(unsigned int val);
extern float all_scan_fmult(float val);
extern double all_scan_dmult(double val);

extern int all_scan_max(int val);
extern unsigned int all_scan_umax(unsigned int val);
extern float all_scan_fmax(float val);
extern double all_scan_dmax(double val);

extern int all_scan_min(int val);
extern unsigned int all_scan_umin(unsigned int val);
extern float all_scan_fmin(float val);
extern double all_scan_dmin(double val);

extern int all_scan_or(int val);
extern unsigned int all_scan_uor(unsigned int val);

extern int all_scan_xor(int val);
extern unsigned int all_scan_uxor(unsigned int val);

extern int all_scan_and(int val);
extern unsigned int all_scan_uand(unsigned int val);

#endif








