/*									tab:4
 *
 * profile.h - Split-c profiling information
 *
 * "Copyright (c) 1993 by Steve Lumetta and The Regents of the University 
 * of California.  All rights reserved."
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author: 			Steve Lumetta
 * Version:			1
 * Creation Date:	Thu May 13 17:13:04 1993
 * Filename:		profile.h
 * History:
 *	SL	1	Thu May 13 17:13:22 1993
 *		First written
 */

#ifndef _SPLIT_C_PROFILE_H
#define _SPLIT_C_PROFILE_H

#ifdef SC_PROFILE  /* Just in case someone included by mistake */

/* READ THIS!!  If this set is expanded, make sure to change the
   set defined in cmam_asm.s as well. */

enum {
	/* User controlled values */
	PROF_COMPUTE,    /* Computation count */
	PROF_IDLE,       /* Idle processor count */

	/* Internal values */
	PROF_BARRIER,    /* Waiting at barrier (includes all_*_sync) */
	PROF_SYNC,       /* Waiting for data (sync, store_sync, etc.) */
	PROF_NET_BUSY,   /* Trying to send data to NI */
	PROF_REQUEST,    /* Send message to another processor */
	PROF_SERVICE,    /* Service message from another processor */

	NUM_PROF_TYPES};

extern int sc_prof_data[NUM_PROF_TYPES];

extern void all_do_profile(char *comment);

#define prof_compute() sc_prof_data[PROF_COMPUTE]++;
#define prof_idle() sc_prof_data[PROF_IDLE]++;

#endif

#endif


