/*									tab:4
 *
 * lock.h - Routines for guaranteeing that counters are modified atomically
 *
 * "Copyright (c) 1996 and The Regents of the University 
 * of California.  All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author: 			Andrea C. Dusseau
 * Version:			2
 * Creation Date:	Mon Feb 26 14:04:39 1996
 * Filename:		lock.h
 * History:
 */

#ifndef __LOCK_H__
#define __LOCK_H__

#if defined(SC_SEP_REQ_RPL) || defined(SC_AM_ATOMIC) || !defined(SC_MSG_THR)
#define __splitc_lock(m)
#else
EXTERN inline __splitc_lock(mutex_t *mutex)
INLINE({
	if (mutex_lock(mutex)) {
		perror("mutex_lock");
		exit(-1);
	}
})
#endif


#if defined(SC_SEP_REQ_RPL) || defined(SC_AM_ATOMIC) || !defined(SC_MSG_THR)
#define __splitc_unlock(m)
#else
EXTERN inline __splitc_unlock(mutex_t *mutex)
INLINE({
	if (mutex_unlock(mutex)) {
		/*fprintf(stderr, "ERROR: mutex_unlock failed\n");*/
		/*fflush(stderr);*/
		perror("mutex_unlock");
		exit(-1);
	}
})
#endif
  
#endif
