/*   Vector, Aux, and Dist additions Copyright (C) 1993,1994 
 *       United States Government as represented by the Director, 
 *       National Security Agency.
 *       All rights reserved
 */
aux long *aux_alloc_stack(int);
aux long *aux_alloc_heap(int);

aux long *__aux_stack_pointer;
aux int *__aux_unit_vector;
/*
 * code to initialize stack.  MUST be called in main. NO aux variables
 * declared in main 
 */
#define AC_INIT_STACK(size)                    			\
       ({int __size; __size = size;            			\
         __aux_unit_vector = (aux int *) aux_alloc_stack(size);	\
         __aux_stack_pointer = (aux long *) __aux_unit_vector + (size-1); \
	 asm volatile("mov %0, %%l5"::"r"(__aux_stack_pointer)); \
	 __aux_unit_vector[0] = 0;  __aux_unit_vector[1] = 1;  \
	 __aux_unit_vector[2] = 2;  __aux_unit_vector[3] = 3;  \
	 __aux_unit_vector[4] = 4;  __aux_unit_vector[5] = 5;  \
	 __aux_unit_vector[6] = 6;  __aux_unit_vector[7] = 7;  \
	 __aux_unit_vector[8] = 8;  __aux_unit_vector[9] = 9;  \
	 __aux_unit_vector[10] = 10;  __aux_unit_vector[11] = 11;  \
	 __aux_unit_vector[12] = 12;  __aux_unit_vector[13] = 13;  \
	 __aux_unit_vector[14] = 14;  __aux_unit_vector[15] = 15;})
				 
#define CMMD_DEFINE_AUX_ALLOC_ROUTINES                             	     \
aux long *aux_alloc_stack(len)						     \
     int len;								     \
{								     	     \
  aux long *rtn_ptr = (aux long *)CMPE_get_dp_stack_ptr();		     \
  int failed = 0;							     \
  CMMD_sync_with_nodes();						     \
  if (CMMD_self_address() == 0)						     \
    {								     	     \
      CMPE_set_dp_stack_ptr(rtn_ptr + len);				     \
      failed = (CMPE_get_dp_stack_ptr() < (unsigned)(rtn_ptr + len));	     \
	if (failed)							     \
	  fprintf(stderr, "could not allocate %d words on DP stack\n", len); \
	  }								     \
  failed = CMMD_reduce_int(failed, CMMD_combiner_ior);			     \
  rtn_ptr = (aux long *)CHANGE_DPV_SPACE_INST(rtn_ptr);			     \
  if (failed) exit(0);							     \
  return(rtn_ptr);							     \
}								     	     \
aux long *aux_alloc_heap(len) 						     \
     int len;								     \
{								     	     \
  aux long *rtn_ptr = (aux long *)CMPE_get_dp_heap_ptr();		     \
  int failed = 0;							     \
  CMMD_sync_with_nodes();						     \
  if (CMMD_self_address() == 0)						     \
    {								     	     \
      CMPE_set_dp_heap_ptr(rtn_ptr + len);				     \
      failed = (CMPE_get_dp_heap_ptr() < (unsigned)(rtn_ptr + len));	     \
	if (failed)							     \
	  fprintf(stderr, "could not allocate %d words on DP heap\n", len);  \
	  }								     \
  failed = CMMD_reduce_int(failed, CMMD_combiner_ior);			     \
  rtn_ptr = (aux long *)CHANGE_DPV_SPACE_INST(rtn_ptr);			     \
  if (failed) exit(0);							     \
  return(rtn_ptr);							     \
}

#define CMRT_DEFINE_INIT_STACK						     \
void CMPE_ac_init_stack(stack_ptr,stack_size)				     \
    aux long *stack_ptr;						     \
    int stack_size; 							     \
{									     \
  extern aux long *__aux_stack_pointer;                                      \
  aux volatile int foo;                                                      \
  __aux_stack_pointer = (stack_ptr + stack_size - 1);			     \
  asm volatile ("mov %0,%%l5"::"r"(__aux_stack_pointer));		     \
  foo = 42;  /* ensure that %l5 is used, so it will not be eliminated */     \
} 

#define CMRT_DEFINE_INIT_STACK_WRAPPER					     \
void ac_init_stack_(stack_pointer, stack_size)				     \
    CMRT_desc_t  stack_pointer;						     \
    int *stack_size;							     \
{									     \
    unsigned arg_array[10];						     \
    unsigned *arg_array_ptr = &arg_array[2];				     \
    extern void CMPE_ac_init_stack();					     \
    *arg_array_ptr++ = CMRT_desc_get_cm_location(stack_pointer);	     \
    *arg_array_ptr++ = *stack_size;					     \
    arg_array[0]= (unsigned)CMPE_ac_init_stack;				     \
    arg_array[1] = (unsigned) (arg_array_ptr - arg_array);		     \
    CMNA_bc_send_msg(arg_array, arg_array[1]);				     \
}


/*
 * Various vector unit instructions.  See DPEAC manual for details.
 * In general:
 *   AC_instruction(rs1, rs2, rd);
 */

/* find first bit */
#define AC_uffb(rs, rd) asm volatile ("uffb%v0 %1,%0" : "=v" (rd) : "v"  (rs))
#define AC_duffb(rs, rd) asm volatile ("duffb%v0 %1,%0" : "=v" (rd) \
							: "v"  (rs))

/* population count */
#define AC_epcv(rls, ria) asm volatile ("fnop%v0; epcv(%1)=%0" \
					 : "=v" (ria) \
					 : "v"  (rls))
#define AC_depcv(rls, ria) asm volatile ("fnop%v0; depcv(%1)=%0" \
					  : "=v" (ria) \
					  : "v" (rls))
#define AC_epcs(rls, ria) asm volatile ("fnops; epcs(%1)=%0" \
					 : "=d" (ria) \
					 : "d" (rls))
#define AC_depcs(rls, ria) asm volatile ("fnops; depcs(%1)=%0" \
					   : "=d" (ria) \
					   : "d" (rls))

/* Vector mask load/store */
#define AC_ldvm(rs1) asm volatile ("ldvm %0" : : "d" ((aux int) (rs1)))
#define AC_stvm(rd) asm volatile ("ieqv V1,V1\n\tstvm %0" : \
				  "=d" ((aux int) (rd)):)

/* vector count */
#define AC_vmcount(expr, rD) \
  asm volatile("inev %1,0;vmcurrent \n\tfnopv; vmcount=%0;vmnop"\
               :"=v" (rD) :"v" (expr))

/* merge */
#define AC_umrg(rs1, rs2, rd) asm ("umrg %1,%2,%0" \
				     : "=v" (rd) \
				     : "v" (rs1), "v" (rs2))
#define AC_dumrg(rs1, rs2, rd) asm ("dumrg %1,%2,%0" \
				     : "=v" (rd) \
				     : "v" (rs1), "v" (rs2))

/* read and write data regs */
#define AC_dprd(dp, rs, rd)	asm volatile ("dprd %1,%2,%0"\
				     : "=r" (rd) \
				     : "r" (dp), "d" (rs))
#define AC_dprdd(dp, rs, rd)	asm volatile ("dprdd %1,%2,%0"\
				      : "=r" (rd) \
				      : "r" (dp), "d" (rs))
#define AC_dpwrt(dp, rs, rd)	asm volatile ("dpwrt %1,%2,%0"\
				      : "=d" (rd) \
				      : "r" (dp), "r" (rs), "0" (rd))
#define AC_dpwrtd(dp, rs, rd)	asm volatile ("dpwrtd %1,%2,%0"\
				      : "=d" (rd) \
				      : "r" (dp), "r" (rs), "0" (rd))
#define AC_dpwrtf(dp, rs, rd)	asm volatile ("dpwrt %1,%2,%0"\
				      : "=d" (rd) \
				      : "r" (dp), "f" (rs), "0" (rd))
#define AC_dpwrtdf(dp, rs, rd)	asm volatile ("dpwrtd %1,%2,%0"\
				      : "=d" (rd) \
				      : "r" (dp), "f" (rs), "0" (rd))
/* read and write control regs */
#define AC_dpget(dp, rs, rd)	asm ("dpget %1,%2,%0"\
				      : "=r" (rd) \
				      : "r" (dp), "d" (rs))
#define AC_dpgetd(dp, rs, rd)	asm ("dpgetd %1,%2,%0"\
				      : "=r" (rd) \
				      : "r" (dp), "d" (rs))
#define AC_dpset(dp, rs, rd)	asm ("dpset %1,%2,%0"\
				      : "=d" (rd) \
				      : "r" (dp), "r" (rs))
#define AC_dpsetd(dp, rs, rd)	asm ("dpsetd %1,%2,%0"\
				      : "=d" (rd) \
				      : "r" (dp), "r" (rs))

/* change space and change bank */
#define AC_dpchgsp(dp,rs,rd)
#define AC_dpchgbk(dp,rs,rd)

/* higher level macros which "return" the values read, rather than
   forcing use of registers */
#define AC_read_int(exp, unit)     ({int __res; aux int __s = (exp); AC_dprd((unit),__s,__res); \
				       __res;})
#define AC_read_long(exp, unit)    ({long __res; aux long __s = (exp); \
				       AC_dprdd((unit),__s,__res); \
				       __res;})
#define AC_read_float(exp, unit)   ({float __res; aux float __s = (exp); \
				       AC_dprd((unit),__s,__res); \
				       __res;}) 
#define AC_read_double(exp, unit)  ({double __res; aux double __s = (exp); \
				       AC_dprdd((unit),__s,__res); \
				       __res;})

#define AC_write_int(var, exp, unit)   ({aux int __x; int __s; __x = (var); \
					  __s = (exp); \
					  AC_dpwrt((unit),(__s),(__x)); \
					  (var) = __x;})
#define AC_write_long(var, exp, unit)   ({aux long __x; long __s; __x = (var); \
					  __s = (exp); \
					  AC_dpwrtd((unit),(__s),(__x)); \
					  (var) = __x;})
#define AC_write_float(var, exp, unit)   ({aux float __x;float __s;__x = (var); \
					    __s = (exp); \
					    AC_dpwrtf((unit),(__s),(__x)); \
					    (var) = __x;})
#define AC_write_double(var, exp, unit)   ({aux double __x;double __s;__x = (var); \
					    __s = (exp); \
					    AC_dpwrtdf((unit),(__s),(__x)); \
					    (var) = __x;})

#define AC_change_dp(e, unit)       ((typeof (e))(((unsigned)(e)&~(0xf<<25))|(unit)<<25))
#define AC_toggle_dpv_space(e)      ((typeof (e))(TOGGLE_DPV_SPACE(e)))
#define AC_change_dpv_space_data(e) ((typeof (e))(CHANGE_DPV_SPACE_DATA(e)))
#define AC_change_dpv_space_inst(e) ((typeof (e))(CHANGE_DPV_SPACE_INST(e)))
