#ifndef __DIST_H
#define __DIST_H
#ifdef __DIST__
enum {PROCS};
extern const long MYPROC;

#define __VM_UMEMREG       (0x82<<32)
#define __VM_MR_USR        (__VM_UMEMREG | 0x144000) /* User Status register */

#define _seq() ({volatile int *t=(int *)(__VM_MR_USR); \
                 asm volatile("mb"); \
                 while (*t & (3<<10)); })

extern const long _BAR_BAR0;
extern const long _BAR_EUR0;
#define __VM_MR_BARRIER    (__VM_UMEMREG | 0x108000) /* Barrier register */
#ifndef __BAR_REG
#define __BAR_REG          (*((volatile long *)__VM_MR_BARRIER))
#define __BAR_REG_NV       (*((long *)__VM_MR_BARRIER))
#endif

#define _barrier()   ({_seq(); \
                       __BAR_REG_NV=__BAR_REG|_BAR_BAR0; \
                       asm volatile ("mb"); \
                       while (__BAR_REG&_BAR_BAR0); })

/*
 * these are replacements for libgetput.a, they should really go away
 * at some point...
 */

void _call_pal133(int);
void _call_pal135(int);

#define cache_invalid_on()  (_call_pal133 (0x200))
#define cache_invalid_off() (_call_pal133 (0))
#define line_invalid_on(x)  (_call_pal133 ((x>>5&0xff)|0x300))
#define line_invalid_off()  (_call_pal133 (0))

#define udcflush() (_call_pal135 (0))
#endif /* __DIST__ */
#endif /* not __DIST_H */



