/*									tab:4
 *
 * split-c.h - 
 *
 * Copyright (c) 1992 by Seth Copen Goldstein and 
 * Regents of the University of California
 *
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  Copyright holder(s) make no
 * representation about the suitability of this software for
 * any purpose. It is provided "as is" without express or
 * implied warranty.
 *
 * Author: 			Seth Copen Goldstein
 * Version:			30
 * Creation Date:	Tue Dec 15 13:48:02 1992
 * Filename:		split-c.h
 * History:
 *	AK	21	Tue Jul  6 03:19:21 1993
 *		There is now a sc_parser_build_binary_op.
 *	AK	19	Tue Jul  6 02:10:41 1993
 *		Adding prototype for sc_default_conversion.
 */

#ifndef _SPLIT_C_H_
#define _SPLIT_C_H_

tree convert_for_assignment ();

tree lookup_splitc (char const * const s);

tree build_global_put ();
tree build_global_get ();
tree build_global_array_ref ();
tree modify_get_call ();
tree build_global_component_get ();
tree build_modify_expr_with_opt ();
tree build_global_ptr_arith ();
tree build_arith_side_effects ();
tree build_xfer ();
tree build_post_inc ();
tree build_post_dec ();
tree build_pointer_compare ();

tree build_initial_split_cast ();
tree build_split_ptr_from_array ();
tree build_split_arith_op ();
tree build_split_ref ();
tree build_local_split_ref ();
tree build_sc_cast ();

/* In tree.c */
tree build_split_index_type ();

tree build_address_increments ();

tree transform_rvalue_writes ();
tree transform_reads ();
tree transform_side_effect_stmt ();

tree modify_expr_list ();
tree sc_default_conversion ();
tree sc_parser_build_binary_op ();
tree sc_build_unary_op ();
tree sc_build_blocking_ops ();
tree sc_build_nonblocking_ops ();
tree sc_build_store_ops ();
tree sc_build_assign_ops ();
tree sc_sizeof ();

int  global_op ();
tree get_global_addr ();

tree integer_type_node;
tree char_type_node;

tree replaceProcsWith1(tree size);
tree lookup_splitc(const char * const s);

extern int stmt_count;
extern tree current_declspecs;
extern tree declspec_stack;

#endif
